-- 
-- Table structure for table `dg_user_accounts`
-- 

CREATE TABLE `dg_user_accounts` (
  `account_id` mediumint(8) unsigned NOT NULL auto_increment,
  `date_created` datetime NOT NULL,
  `last_updated` datetime NOT NULL,
  `date_expires` datetime default NULL,
  `first_name` varchar(50) default NULL,
  `last_name` varchar(50) default NULL,
  `email` varchar(100) NOT NULL,
  `password` varchar(20) NOT NULL,
  `password_recovery_question` varchar(100) default NULL,
  `password_recovery_answer` varchar(100) default NULL,
  `max_records` mediumint(9),
  `num_records_generated` int(11) NOT NULL default '0',
  PRIMARY KEY  (`account_id`)
) ENGINE=MyISAM ;

INSERT INTO `dg_user_accounts` VALUES (1, '2007-05-19 19:13:07', '2007-05-19 19:14:52', '2010-05-19 19:13:07', 'Test', 'Account',	'test@test.com', 'test', '', '', '', 0);


-- 
-- Table structure for table `dg_forms`
-- 

CREATE TABLE `dg_forms` (
  `form_id` mediumint(9) NOT NULL auto_increment,
  `account_id` mediumint(9) NOT NULL,
  `form_name` varchar(100) NOT NULL,
  `content` mediumtext NOT NULL,
  PRIMARY KEY  (`form_id`)
) ENGINE=MyISAM ;

INSERT INTO `dg_forms` VALUES (1, 1, 'Demo Form', '{title1: "Name",type1: "Name",example1: "Name%20Initial.%20Surname",option1: "Name%20Initial.%20Surname",title2: "Home%20Phone",type2: "Phone",example2: "(Xxx)%20Xxx-xxxx",option2: "(Xxx)%20Xxx-xxxx",title3: "Work%20Phone",type3: "Phone",example3: "(Xxx)%20Xxx-xxxx",option3: "(Xxx)%20Xxx-xxxx",title4: "Email%20Address",type4: "Email",example4: "",option4: "",title5: "Street%20Address",type5: "Street-Address",example5: "",option5: "",title6: "City%20%2F%20Town",type6: "City",example6: "",option6: "",title7: "Postal%20%2F%20Zipcode",type7: "Postal-Zip",example7: "",option7: "canada,netherlands,uk",title8: "Province",type8: "State-Province",example8: "",option8: "canada,canada_full,netherlands,netherlands_full,netherlands_short,uk,uk_full,uk_short,us,us_full,us_short",title9: "Marital%20Status",type9: "List",example9: "Single%7CMarried%7CDivorced%7CCommon-Law",option9: "true%2Cfalse%2C1%2C1%2CSingle%7CMarried%7CDivorced%7CCommon-Law",num_rows: 9,num_results: 100,result_type: "HTML",countries: "canada",xml_root_node_name: "records",xml_record_node_name: "record",sql_table_name: "myTable",sql_database: "MySQL",csv_delimiter: "|"}');



-- 
-- table `dg_cities`
-- 

CREATE TABLE `dg_cities` (
  `city_id` mediumint(8) unsigned NOT NULL auto_increment,
  `city` varchar(80) NOT NULL default '',
  PRIMARY KEY  (`city_id`)
) TYPE=MyISAM AUTO_INCREMENT=1057 ;

INSERT INTO `dg_cities` VALUES (1, 'Aberdeen');
INSERT INTO `dg_cities` VALUES (2, 'Abilene');
INSERT INTO `dg_cities` VALUES (3, 'Ada');
INSERT INTO `dg_cities` VALUES (4, 'Agat');
INSERT INTO `dg_cities` VALUES (5, 'Agawam');
INSERT INTO `dg_cities` VALUES (6, 'Agoura Hills');
INSERT INTO `dg_cities` VALUES (7, 'Aguadilla');
INSERT INTO `dg_cities` VALUES (8, 'Akron');
INSERT INTO `dg_cities` VALUES (9, 'Alameda');
INSERT INTO `dg_cities` VALUES (10, 'Alamogordo');
INSERT INTO `dg_cities` VALUES (11, 'Albany');
INSERT INTO `dg_cities` VALUES (12, 'Albuquerque');
INSERT INTO `dg_cities` VALUES (13, 'Alexandria');
INSERT INTO `dg_cities` VALUES (14, 'Alhambra');
INSERT INTO `dg_cities` VALUES (15, 'Aliquippa');
INSERT INTO `dg_cities` VALUES (16, 'Aliso Viejo');
INSERT INTO `dg_cities` VALUES (17, 'Allentown');
INSERT INTO `dg_cities` VALUES (18, 'Alpharetta');
INSERT INTO `dg_cities` VALUES (19, 'Altoona');
INSERT INTO `dg_cities` VALUES (20, 'Ames');
INSERT INTO `dg_cities` VALUES (21, 'Amesbury');
INSERT INTO `dg_cities` VALUES (22, 'Anaconda');
INSERT INTO `dg_cities` VALUES (23, 'Anaheim');
INSERT INTO `dg_cities` VALUES (24, 'Anchorage');
INSERT INTO `dg_cities` VALUES (25, 'Anderson');
INSERT INTO `dg_cities` VALUES (26, 'Ann Arbor');
INSERT INTO `dg_cities` VALUES (27, 'Annapolis');
INSERT INTO `dg_cities` VALUES (28, 'Ansonia');
INSERT INTO `dg_cities` VALUES (29, 'Apple Valley');
INSERT INTO `dg_cities` VALUES (30, 'Appleton');
INSERT INTO `dg_cities` VALUES (31, 'Arcadia');
INSERT INTO `dg_cities` VALUES (32, 'Ardmore');
INSERT INTO `dg_cities` VALUES (33, 'Areceibo');
INSERT INTO `dg_cities` VALUES (34, 'Arlington');
INSERT INTO `dg_cities` VALUES (35, 'Artesia');
INSERT INTO `dg_cities` VALUES (36, 'Arvada');
INSERT INTO `dg_cities` VALUES (37, 'Asbury Park');
INSERT INTO `dg_cities` VALUES (38, 'Asheville');
INSERT INTO `dg_cities` VALUES (39, 'Ashland');
INSERT INTO `dg_cities` VALUES (40, 'Aspen');
INSERT INTO `dg_cities` VALUES (41, 'Astoria');
INSERT INTO `dg_cities` VALUES (42, 'Athens');
INSERT INTO `dg_cities` VALUES (43, 'Atlanta');
INSERT INTO `dg_cities` VALUES (44, 'Atlantic City');
INSERT INTO `dg_cities` VALUES (45, 'Attleboro');
INSERT INTO `dg_cities` VALUES (46, 'Atwater');
INSERT INTO `dg_cities` VALUES (47, 'Auburn');
INSERT INTO `dg_cities` VALUES (48, 'Auburn Hills');
INSERT INTO `dg_cities` VALUES (49, 'Augusta');
INSERT INTO `dg_cities` VALUES (50, 'Aurora');
INSERT INTO `dg_cities` VALUES (51, 'Austin');
INSERT INTO `dg_cities` VALUES (52, 'Avalon');
INSERT INTO `dg_cities` VALUES (53, 'Azusa');
INSERT INTO `dg_cities` VALUES (54, 'Bakersfield');
INSERT INTO `dg_cities` VALUES (55, 'Baldwin Park');
INSERT INTO `dg_cities` VALUES (56, 'Baltimore');
INSERT INTO `dg_cities` VALUES (57, 'Bandera');
INSERT INTO `dg_cities` VALUES (58, 'Bandon');
INSERT INTO `dg_cities` VALUES (59, 'Bangor');
INSERT INTO `dg_cities` VALUES (60, 'Barre');
INSERT INTO `dg_cities` VALUES (61, 'Barrow');
INSERT INTO `dg_cities` VALUES (62, 'Bartlesville');
INSERT INTO `dg_cities` VALUES (63, 'Basin');
INSERT INTO `dg_cities` VALUES (64, 'Batavia');
INSERT INTO `dg_cities` VALUES (65, 'Baton Rouge');
INSERT INTO `dg_cities` VALUES (66, 'Battle Creek');
INSERT INTO `dg_cities` VALUES (67, 'Bay City');
INSERT INTO `dg_cities` VALUES (68, 'Bay St. Louis');
INSERT INTO `dg_cities` VALUES (69, 'Bayamon');
INSERT INTO `dg_cities` VALUES (70, 'Baytown');
INSERT INTO `dg_cities` VALUES (71, 'Beacon');
INSERT INTO `dg_cities` VALUES (72, 'Beaumont');
INSERT INTO `dg_cities` VALUES (73, 'Beaver Falls');
INSERT INTO `dg_cities` VALUES (74, 'Beckley');
INSERT INTO `dg_cities` VALUES (75, 'Bell');
INSERT INTO `dg_cities` VALUES (76, 'Bell Gardens');
INSERT INTO `dg_cities` VALUES (77, 'Belleville');
INSERT INTO `dg_cities` VALUES (78, 'Bellflower');
INSERT INTO `dg_cities` VALUES (79, 'Bellingham');
INSERT INTO `dg_cities` VALUES (80, 'Beloit');
INSERT INTO `dg_cities` VALUES (81, 'Belpre');
INSERT INTO `dg_cities` VALUES (82, 'Bend');
INSERT INTO `dg_cities` VALUES (83, 'Benton Harbor');
INSERT INTO `dg_cities` VALUES (84, 'Bentonville');
INSERT INTO `dg_cities` VALUES (85, 'Berkeley');
INSERT INTO `dg_cities` VALUES (86, 'Berlin');
INSERT INTO `dg_cities` VALUES (87, 'Bessemer');
INSERT INTO `dg_cities` VALUES (88, 'Bethany');
INSERT INTO `dg_cities` VALUES (89, 'Bethlehem');
INSERT INTO `dg_cities` VALUES (90, 'Beverly');
INSERT INTO `dg_cities` VALUES (91, 'Beverly Hills');
INSERT INTO `dg_cities` VALUES (92, 'Biddeford');
INSERT INTO `dg_cities` VALUES (93, 'Billings');
INSERT INTO `dg_cities` VALUES (94, 'Biloxi');
INSERT INTO `dg_cities` VALUES (95, 'Binghamton');
INSERT INTO `dg_cities` VALUES (96, 'Birmingham');
INSERT INTO `dg_cities` VALUES (97, 'Bismarck');
INSERT INTO `dg_cities` VALUES (98, 'Blacksburg');
INSERT INTO `dg_cities` VALUES (99, 'Bloomington');
INSERT INTO `dg_cities` VALUES (100, 'Blythe');
INSERT INTO `dg_cities` VALUES (101, 'Boise');
INSERT INTO `dg_cities` VALUES (102, 'Bossier City');
INSERT INTO `dg_cities` VALUES (103, 'Boston');
INSERT INTO `dg_cities` VALUES (104, 'Boulder');
INSERT INTO `dg_cities` VALUES (105, 'Boulder City');
INSERT INTO `dg_cities` VALUES (106, 'Boulder Junction');
INSERT INTO `dg_cities` VALUES (107, 'Bowie');
INSERT INTO `dg_cities` VALUES (108, 'Bowling Green');
INSERT INTO `dg_cities` VALUES (109, 'Bozeman');
INSERT INTO `dg_cities` VALUES (110, 'Bradbury');
INSERT INTO `dg_cities` VALUES (111, 'Bradford');
INSERT INTO `dg_cities` VALUES (112, 'Branson');
INSERT INTO `dg_cities` VALUES (113, 'Brea');
INSERT INTO `dg_cities` VALUES (114, 'Bremerton');
INSERT INTO `dg_cities` VALUES (115, 'Bridgeport');
INSERT INTO `dg_cities` VALUES (116, 'Brigham City');
INSERT INTO `dg_cities` VALUES (117, 'Bristol');
INSERT INTO `dg_cities` VALUES (118, 'Brockton');
INSERT INTO `dg_cities` VALUES (119, 'Broken Arrow');
INSERT INTO `dg_cities` VALUES (120, 'Brookfield');
INSERT INTO `dg_cities` VALUES (121, 'Brookings');
INSERT INTO `dg_cities` VALUES (122, 'Brooklyn Park');
INSERT INTO `dg_cities` VALUES (123, 'Brown Deer');
INSERT INTO `dg_cities` VALUES (124, 'Brownsville');
INSERT INTO `dg_cities` VALUES (125, 'Brunswick');
INSERT INTO `dg_cities` VALUES (126, 'Buena Park');
INSERT INTO `dg_cities` VALUES (127, 'Buffalo');
INSERT INTO `dg_cities` VALUES (128, 'Burbank');
INSERT INTO `dg_cities` VALUES (129, 'Burlingame');
INSERT INTO `dg_cities` VALUES (130, 'Burlington');
INSERT INTO `dg_cities` VALUES (131, 'Butler');
INSERT INTO `dg_cities` VALUES (132, 'Butte');
INSERT INTO `dg_cities` VALUES (133, 'Caguas');
INSERT INTO `dg_cities` VALUES (134, 'Cairo');
INSERT INTO `dg_cities` VALUES (135, 'Calabasas');
INSERT INTO `dg_cities` VALUES (136, 'Calumet City');
INSERT INTO `dg_cities` VALUES (137, 'Cambridge');
INSERT INTO `dg_cities` VALUES (138, 'Camden');
INSERT INTO `dg_cities` VALUES (139, 'Canandaigua');
INSERT INTO `dg_cities` VALUES (140, 'Canton');
INSERT INTO `dg_cities` VALUES (141, 'Cape Coral');
INSERT INTO `dg_cities` VALUES (142, 'Cape Girardeau');
INSERT INTO `dg_cities` VALUES (143, 'Cape May');
INSERT INTO `dg_cities` VALUES (144, 'Carbondale');
INSERT INTO `dg_cities` VALUES (145, 'Carolina');
INSERT INTO `dg_cities` VALUES (146, 'Carrollton');
INSERT INTO `dg_cities` VALUES (147, 'Carson');
INSERT INTO `dg_cities` VALUES (148, 'Carson City');
INSERT INTO `dg_cities` VALUES (149, 'Cary');
INSERT INTO `dg_cities` VALUES (150, 'Casper');
INSERT INTO `dg_cities` VALUES (151, 'Catskill');
INSERT INTO `dg_cities` VALUES (152, 'Cedar City');
INSERT INTO `dg_cities` VALUES (153, 'Cedar Falls');
INSERT INTO `dg_cities` VALUES (154, 'Cedar Rapids');
INSERT INTO `dg_cities` VALUES (155, 'Cedarburg');
INSERT INTO `dg_cities` VALUES (156, 'Centennial');
INSERT INTO `dg_cities` VALUES (157, 'Cerritos');
INSERT INTO `dg_cities` VALUES (158, 'Champaign');
INSERT INTO `dg_cities` VALUES (159, 'Chandler');
INSERT INTO `dg_cities` VALUES (160, 'Charleston');
INSERT INTO `dg_cities` VALUES (161, 'Charleston');
INSERT INTO `dg_cities` VALUES (162, 'Charlotte');
INSERT INTO `dg_cities` VALUES (163, 'Charlotte Amalie');
INSERT INTO `dg_cities` VALUES (164, 'Charlottesville');
INSERT INTO `dg_cities` VALUES (165, 'Chattanooga');
INSERT INTO `dg_cities` VALUES (166, 'Chelsea');
INSERT INTO `dg_cities` VALUES (167, 'Chesapeake');
INSERT INTO `dg_cities` VALUES (168, 'Chester');
INSERT INTO `dg_cities` VALUES (169, 'Cheyenne');
INSERT INTO `dg_cities` VALUES (170, 'Chicago');
INSERT INTO `dg_cities` VALUES (171, 'Chicago Heights');
INSERT INTO `dg_cities` VALUES (172, 'Chickasha');
INSERT INTO `dg_cities` VALUES (173, 'Chico');
INSERT INTO `dg_cities` VALUES (174, 'Chicopee');
INSERT INTO `dg_cities` VALUES (175, 'Chino');
INSERT INTO `dg_cities` VALUES (176, 'Chino Hills');
INSERT INTO `dg_cities` VALUES (177, 'Christiansted');
INSERT INTO `dg_cities` VALUES (178, 'Chula Vista');
INSERT INTO `dg_cities` VALUES (179, 'Cicero');
INSERT INTO `dg_cities` VALUES (180, 'Cincinnati');
INSERT INTO `dg_cities` VALUES (181, 'Citrus Heights');
INSERT INTO `dg_cities` VALUES (182, 'City of Industry');
INSERT INTO `dg_cities` VALUES (183, 'Clairton');
INSERT INTO `dg_cities` VALUES (184, 'Claremont');
INSERT INTO `dg_cities` VALUES (185, 'Claremore');
INSERT INTO `dg_cities` VALUES (186, 'Clarksburg');
INSERT INTO `dg_cities` VALUES (187, 'Clarksville');
INSERT INTO `dg_cities` VALUES (188, 'Clearwater');
INSERT INTO `dg_cities` VALUES (189, 'Clemson');
INSERT INTO `dg_cities` VALUES (190, 'Cleveland');
INSERT INTO `dg_cities` VALUES (191, 'Clovis');
INSERT INTO `dg_cities` VALUES (192, 'Coatesville');
INSERT INTO `dg_cities` VALUES (193, 'Cody');
INSERT INTO `dg_cities` VALUES (194, 'Cohoes');
INSERT INTO `dg_cities` VALUES (195, 'College Park');
INSERT INTO `dg_cities` VALUES (196, 'College Station');
INSERT INTO `dg_cities` VALUES (197, 'Colorado Springs');
INSERT INTO `dg_cities` VALUES (198, 'Columbia');
INSERT INTO `dg_cities` VALUES (199, 'Columbia');
INSERT INTO `dg_cities` VALUES (200, 'Columbus');
INSERT INTO `dg_cities` VALUES (201, 'Columbus');
INSERT INTO `dg_cities` VALUES (202, 'Commerce');
INSERT INTO `dg_cities` VALUES (203, 'Compton');
INSERT INTO `dg_cities` VALUES (204, 'Concord');
INSERT INTO `dg_cities` VALUES (205, 'Concord');
INSERT INTO `dg_cities` VALUES (206, 'Connellsville');
INSERT INTO `dg_cities` VALUES (207, 'Coos Bay');
INSERT INTO `dg_cities` VALUES (208, 'Coral Springs');
INSERT INTO `dg_cities` VALUES (209, 'Corinth');
INSERT INTO `dg_cities` VALUES (210, 'Corona');
INSERT INTO `dg_cities` VALUES (211, 'Corpus Christi');
INSERT INTO `dg_cities` VALUES (212, 'Corry');
INSERT INTO `dg_cities` VALUES (213, 'Cortland');
INSERT INTO `dg_cities` VALUES (214, 'Corvallis');
INSERT INTO `dg_cities` VALUES (215, 'Costa Mesa');
INSERT INTO `dg_cities` VALUES (216, 'Council Bluffs');
INSERT INTO `dg_cities` VALUES (217, 'Covina');
INSERT INTO `dg_cities` VALUES (218, 'Covington');
INSERT INTO `dg_cities` VALUES (219, 'Cranston');
INSERT INTO `dg_cities` VALUES (220, 'Crown Point');
INSERT INTO `dg_cities` VALUES (221, 'Cruz Bay');
INSERT INTO `dg_cities` VALUES (222, 'Cudahy');
INSERT INTO `dg_cities` VALUES (223, 'Culver City');
INSERT INTO `dg_cities` VALUES (224, 'Cumberland');
INSERT INTO `dg_cities` VALUES (225, 'Cypress');
INSERT INTO `dg_cities` VALUES (226, 'Dallas');
INSERT INTO `dg_cities` VALUES (227, 'Dalton');
INSERT INTO `dg_cities` VALUES (228, 'Daly City');
INSERT INTO `dg_cities` VALUES (229, 'Dana Point');
INSERT INTO `dg_cities` VALUES (230, 'Danbury');
INSERT INTO `dg_cities` VALUES (231, 'Danville');
INSERT INTO `dg_cities` VALUES (232, 'Darlington');
INSERT INTO `dg_cities` VALUES (233, 'Davenport');
INSERT INTO `dg_cities` VALUES (234, 'Davis');
INSERT INTO `dg_cities` VALUES (235, 'Dayton');
INSERT INTO `dg_cities` VALUES (236, 'Deadwood');
INSERT INTO `dg_cities` VALUES (237, 'Dearborn');
INSERT INTO `dg_cities` VALUES (238, 'Decatur');
INSERT INTO `dg_cities` VALUES (239, 'DeKalb');
INSERT INTO `dg_cities` VALUES (240, 'Del Rio');
INSERT INTO `dg_cities` VALUES (241, 'Delta Junction');
INSERT INTO `dg_cities` VALUES (242, 'Denver');
INSERT INTO `dg_cities` VALUES (243, 'Derby');
INSERT INTO `dg_cities` VALUES (244, 'Des Moines');
INSERT INTO `dg_cities` VALUES (245, 'Detroit');
INSERT INTO `dg_cities` VALUES (246, 'Diamond Bar');
INSERT INTO `dg_cities` VALUES (247, 'Dickinson');
INSERT INTO `dg_cities` VALUES (248, 'Dixon');
INSERT INTO `dg_cities` VALUES (249, 'Dodge City');
INSERT INTO `dg_cities` VALUES (250, 'Dothan');
INSERT INTO `dg_cities` VALUES (251, 'Douglas');
INSERT INTO `dg_cities` VALUES (252, 'Dover');
INSERT INTO `dg_cities` VALUES (253, 'Dover');
INSERT INTO `dg_cities` VALUES (254, 'Downey');
INSERT INTO `dg_cities` VALUES (255, 'Duarte');
INSERT INTO `dg_cities` VALUES (256, 'DuBois');
INSERT INTO `dg_cities` VALUES (257, 'Dubuque');
INSERT INTO `dg_cities` VALUES (258, 'Duluth');
INSERT INTO `dg_cities` VALUES (259, 'Duncan');
INSERT INTO `dg_cities` VALUES (260, 'Dunkirk');
INSERT INTO `dg_cities` VALUES (261, 'Duquesne');
INSERT INTO `dg_cities` VALUES (262, 'Durango');
INSERT INTO `dg_cities` VALUES (263, 'Durant');
INSERT INTO `dg_cities` VALUES (264, 'Durham');
INSERT INTO `dg_cities` VALUES (265, 'East Hartford');
INSERT INTO `dg_cities` VALUES (266, 'East Lansing');
INSERT INTO `dg_cities` VALUES (267, 'East Rutherford');
INSERT INTO `dg_cities` VALUES (268, 'East St. Louis');
INSERT INTO `dg_cities` VALUES (269, 'Easthampton');
INSERT INTO `dg_cities` VALUES (270, 'Easton');
INSERT INTO `dg_cities` VALUES (271, 'Eatontown');
INSERT INTO `dg_cities` VALUES (272, 'Eau Claire');
INSERT INTO `dg_cities` VALUES (273, 'Eden Prairie');
INSERT INTO `dg_cities` VALUES (274, 'Edina');
INSERT INTO `dg_cities` VALUES (275, 'Edmond');
INSERT INTO `dg_cities` VALUES (276, 'Effingham');
INSERT INTO `dg_cities` VALUES (277, 'Egg Harbor');
INSERT INTO `dg_cities` VALUES (278, 'El Cerrito');
INSERT INTO `dg_cities` VALUES (279, 'El Monte');
INSERT INTO `dg_cities` VALUES (280, 'El Paso');
INSERT INTO `dg_cities` VALUES (281, 'El Segundo');
INSERT INTO `dg_cities` VALUES (282, 'Elizabeth City');
INSERT INTO `dg_cities` VALUES (283, 'Elkhart');
INSERT INTO `dg_cities` VALUES (284, 'Elko');
INSERT INTO `dg_cities` VALUES (285, 'Elmira');
INSERT INTO `dg_cities` VALUES (286, 'Elsmere');
INSERT INTO `dg_cities` VALUES (287, 'Enfield');
INSERT INTO `dg_cities` VALUES (288, 'Enid');
INSERT INTO `dg_cities` VALUES (289, 'Ephraim');
INSERT INTO `dg_cities` VALUES (290, 'Erie');
INSERT INTO `dg_cities` VALUES (291, 'Escondido');
INSERT INTO `dg_cities` VALUES (292, 'Eufaula');
INSERT INTO `dg_cities` VALUES (293, 'Eugene');
INSERT INTO `dg_cities` VALUES (294, 'Eureka');
INSERT INTO `dg_cities` VALUES (295, 'Evanston');
INSERT INTO `dg_cities` VALUES (296, 'Evansville');
INSERT INTO `dg_cities` VALUES (297, 'Everett');
INSERT INTO `dg_cities` VALUES (298, 'Fairbanks');
INSERT INTO `dg_cities` VALUES (299, 'Fairfax');
INSERT INTO `dg_cities` VALUES (300, 'Fairfield');
INSERT INTO `dg_cities` VALUES (301, 'Fairmont');
INSERT INTO `dg_cities` VALUES (302, 'Fajardo');
INSERT INTO `dg_cities` VALUES (303, 'Fall River');
INSERT INTO `dg_cities` VALUES (304, 'Fallon');
INSERT INTO `dg_cities` VALUES (305, 'Falls Church');
INSERT INTO `dg_cities` VALUES (306, 'Fargo');
INSERT INTO `dg_cities` VALUES (307, 'Farmer City');
INSERT INTO `dg_cities` VALUES (308, 'Farmington');
INSERT INTO `dg_cities` VALUES (309, 'Farrell');
INSERT INTO `dg_cities` VALUES (310, 'Fayetteville');
INSERT INTO `dg_cities` VALUES (311, 'Fernley');
INSERT INTO `dg_cities` VALUES (312, 'Fitchburg');
INSERT INTO `dg_cities` VALUES (313, 'Flagstaff');
INSERT INTO `dg_cities` VALUES (314, 'Flint');
INSERT INTO `dg_cities` VALUES (315, 'Florence');
INSERT INTO `dg_cities` VALUES (316, 'Fond du Lac');
INSERT INTO `dg_cities` VALUES (317, 'Fontana');
INSERT INTO `dg_cities` VALUES (318, 'Forest Lake');
INSERT INTO `dg_cities` VALUES (319, 'Forrest City');
INSERT INTO `dg_cities` VALUES (320, 'Fort Collins');
INSERT INTO `dg_cities` VALUES (321, 'Fort Dodge');
INSERT INTO `dg_cities` VALUES (322, 'Fort Lauderdale');
INSERT INTO `dg_cities` VALUES (323, 'Fort Smith');
INSERT INTO `dg_cities` VALUES (324, 'Fort Wayne');
INSERT INTO `dg_cities` VALUES (325, 'Fort Worth');
INSERT INTO `dg_cities` VALUES (326, 'Fountain Valley');
INSERT INTO `dg_cities` VALUES (327, 'Frankfort');
INSERT INTO `dg_cities` VALUES (328, 'Franklin');
INSERT INTO `dg_cities` VALUES (329, 'Frederick');
INSERT INTO `dg_cities` VALUES (330, 'Fredericksburg');
INSERT INTO `dg_cities` VALUES (331, 'Frederiksted');
INSERT INTO `dg_cities` VALUES (332, 'Fremont');
INSERT INTO `dg_cities` VALUES (333, 'Fresno');
INSERT INTO `dg_cities` VALUES (334, 'Frisco');
INSERT INTO `dg_cities` VALUES (335, 'Fullerton');
INSERT INTO `dg_cities` VALUES (336, 'Fulton');
INSERT INTO `dg_cities` VALUES (337, 'Gadsden');
INSERT INTO `dg_cities` VALUES (338, 'Gainesville');
INSERT INTO `dg_cities` VALUES (339, 'Gaithersburg');
INSERT INTO `dg_cities` VALUES (340, 'Galesburg');
INSERT INTO `dg_cities` VALUES (341, 'Gallup');
INSERT INTO `dg_cities` VALUES (342, 'Galveston');
INSERT INTO `dg_cities` VALUES (343, 'Garden Grove');
INSERT INTO `dg_cities` VALUES (344, 'Gardena');
INSERT INTO `dg_cities` VALUES (345, 'Gardner');
INSERT INTO `dg_cities` VALUES (346, 'Garland');
INSERT INTO `dg_cities` VALUES (347, 'Gary');
INSERT INTO `dg_cities` VALUES (348, 'Gastonia');
INSERT INTO `dg_cities` VALUES (349, 'Gatlinburg');
INSERT INTO `dg_cities` VALUES (350, 'Geneva');
INSERT INTO `dg_cities` VALUES (351, 'Georgetown');
INSERT INTO `dg_cities` VALUES (352, 'Gettysburg');
INSERT INTO `dg_cities` VALUES (353, 'Gilbert');
INSERT INTO `dg_cities` VALUES (354, 'Gilette');
INSERT INTO `dg_cities` VALUES (355, 'Glen Cove');
INSERT INTO `dg_cities` VALUES (356, 'Glendale');
INSERT INTO `dg_cities` VALUES (357, 'Glendora');
INSERT INTO `dg_cities` VALUES (358, 'Glens Falls');
INSERT INTO `dg_cities` VALUES (359, 'Gloucester');
INSERT INTO `dg_cities` VALUES (360, 'Gloversville');
INSERT INTO `dg_cities` VALUES (361, 'Gold Beach');
INSERT INTO `dg_cities` VALUES (362, 'Goose Creek');
INSERT INTO `dg_cities` VALUES (363, 'Grafton');
INSERT INTO `dg_cities` VALUES (364, 'Grambling');
INSERT INTO `dg_cities` VALUES (365, 'Grand Forks');
INSERT INTO `dg_cities` VALUES (366, 'Grand Island');
INSERT INTO `dg_cities` VALUES (367, 'Grand Junction');
INSERT INTO `dg_cities` VALUES (368, 'Grand Rapids');
INSERT INTO `dg_cities` VALUES (369, 'Grass Valley');
INSERT INTO `dg_cities` VALUES (370, 'Great Falls');
INSERT INTO `dg_cities` VALUES (371, 'Green Bay');
INSERT INTO `dg_cities` VALUES (372, 'Green River');
INSERT INTO `dg_cities` VALUES (373, 'Greenfield');
INSERT INTO `dg_cities` VALUES (374, 'Greensboro');
INSERT INTO `dg_cities` VALUES (375, 'Greensburg');
INSERT INTO `dg_cities` VALUES (376, 'Greenville');
INSERT INTO `dg_cities` VALUES (377, 'Gunica');
INSERT INTO `dg_cities` VALUES (378, 'Guayama');
INSERT INTO `dg_cities` VALUES (379, 'Guayanilla');
INSERT INTO `dg_cities` VALUES (380, 'Gulfport');
INSERT INTO `dg_cities` VALUES (381, 'Guthrie');
INSERT INTO `dg_cities` VALUES (382, 'Hackensack');
INSERT INTO `dg_cities` VALUES (383, 'Hagerstown');
INSERT INTO `dg_cities` VALUES (384, 'Half Moon Bay');
INSERT INTO `dg_cities` VALUES (385, 'Hamilton');
INSERT INTO `dg_cities` VALUES (386, 'Hammond');
INSERT INTO `dg_cities` VALUES (387, 'Hampton');
INSERT INTO `dg_cities` VALUES (388, 'Hanahan');
INSERT INTO `dg_cities` VALUES (389, 'Hannibal');
INSERT INTO `dg_cities` VALUES (390, 'Harrisburg');
INSERT INTO `dg_cities` VALUES (391, 'Hartford');
INSERT INTO `dg_cities` VALUES (392, 'Hartford');
INSERT INTO `dg_cities` VALUES (393, 'Hartland');
INSERT INTO `dg_cities` VALUES (394, 'Hastings');
INSERT INTO `dg_cities` VALUES (395, 'Hattiesburg');
INSERT INTO `dg_cities` VALUES (396, 'Haverhill');
INSERT INTO `dg_cities` VALUES (397, 'Hawaiian Gardens');
INSERT INTO `dg_cities` VALUES (398, 'Hawthorne');
INSERT INTO `dg_cities` VALUES (399, 'Hayward');
INSERT INTO `dg_cities` VALUES (400, 'Hazleton');
INSERT INTO `dg_cities` VALUES (401, 'Healdsburg');
INSERT INTO `dg_cities` VALUES (402, 'Helena');
INSERT INTO `dg_cities` VALUES (403, 'Henderson');
INSERT INTO `dg_cities` VALUES (404, 'Hermitage');
INSERT INTO `dg_cities` VALUES (405, 'Hermosa Beach');
INSERT INTO `dg_cities` VALUES (406, 'Hialeah');
INSERT INTO `dg_cities` VALUES (407, 'Hickory');
INSERT INTO `dg_cities` VALUES (408, 'Hidden Hills');
INSERT INTO `dg_cities` VALUES (409, 'High Point');
INSERT INTO `dg_cities` VALUES (410, 'Highland Park');
INSERT INTO `dg_cities` VALUES (411, 'Hilo');
INSERT INTO `dg_cities` VALUES (412, 'Hoboken');
INSERT INTO `dg_cities` VALUES (413, 'Hollister');
INSERT INTO `dg_cities` VALUES (414, 'Hollywood');
INSERT INTO `dg_cities` VALUES (415, 'Holyoke');
INSERT INTO `dg_cities` VALUES (416, 'Homer');
INSERT INTO `dg_cities` VALUES (417, 'Honolulu');
INSERT INTO `dg_cities` VALUES (418, 'Hoover');
INSERT INTO `dg_cities` VALUES (419, 'Hope');
INSERT INTO `dg_cities` VALUES (420, 'Hopkinsville');
INSERT INTO `dg_cities` VALUES (421, 'Hornell');
INSERT INTO `dg_cities` VALUES (422, 'Hot Springs');
INSERT INTO `dg_cities` VALUES (423, 'Houma');
INSERT INTO `dg_cities` VALUES (424, 'Houston');
INSERT INTO `dg_cities` VALUES (425, 'Hudson');
INSERT INTO `dg_cities` VALUES (426, 'Huntington');
INSERT INTO `dg_cities` VALUES (427, 'Huntington Beach');
INSERT INTO `dg_cities` VALUES (428, 'Huntington Park');
INSERT INTO `dg_cities` VALUES (429, 'Huntsville');
INSERT INTO `dg_cities` VALUES (430, 'Hutchinson');
INSERT INTO `dg_cities` VALUES (431, 'Idabel');
INSERT INTO `dg_cities` VALUES (432, 'Idaho Falls');
INSERT INTO `dg_cities` VALUES (433, 'Idaho Springs');
INSERT INTO `dg_cities` VALUES (434, 'Independence');
INSERT INTO `dg_cities` VALUES (435, 'Indianapolis');
INSERT INTO `dg_cities` VALUES (436, 'Indio');
INSERT INTO `dg_cities` VALUES (437, 'Inglewood');
INSERT INTO `dg_cities` VALUES (438, 'International Falls');
INSERT INTO `dg_cities` VALUES (439, 'Iowa City');
INSERT INTO `dg_cities` VALUES (440, 'Irvine');
INSERT INTO `dg_cities` VALUES (441, 'Irving');
INSERT INTO `dg_cities` VALUES (442, 'Irwindale');
INSERT INTO `dg_cities` VALUES (443, 'Isle of Palms');
INSERT INTO `dg_cities` VALUES (444, 'Ithaca');
INSERT INTO `dg_cities` VALUES (445, 'Jackson');
INSERT INTO `dg_cities` VALUES (446, 'Jackson');
INSERT INTO `dg_cities` VALUES (447, 'Jacksonville');
INSERT INTO `dg_cities` VALUES (448, 'Jamestown');
INSERT INTO `dg_cities` VALUES (449, 'Janesville');
INSERT INTO `dg_cities` VALUES (450, 'Jeannette');
INSERT INTO `dg_cities` VALUES (451, 'Jefferson City');
INSERT INTO `dg_cities` VALUES (452, 'Jeffersontown');
INSERT INTO `dg_cities` VALUES (453, 'Jeffersonville');
INSERT INTO `dg_cities` VALUES (454, 'Jenks');
INSERT INTO `dg_cities` VALUES (455, 'Jersey City');
INSERT INTO `dg_cities` VALUES (456, 'Johnson City');
INSERT INTO `dg_cities` VALUES (457, 'Johnstown');
INSERT INTO `dg_cities` VALUES (458, 'Joliet');
INSERT INTO `dg_cities` VALUES (459, 'Jonesboro');
INSERT INTO `dg_cities` VALUES (460, 'Joplin');
INSERT INTO `dg_cities` VALUES (461, 'Jordan Valley');
INSERT INTO `dg_cities` VALUES (462, 'Juneau');
INSERT INTO `dg_cities` VALUES (463, 'Kahului');
INSERT INTO `dg_cities` VALUES (464, 'Kalamazoo');
INSERT INTO `dg_cities` VALUES (465, 'Kalispell');
INSERT INTO `dg_cities` VALUES (466, 'Kankakee');
INSERT INTO `dg_cities` VALUES (467, 'Kansas City');
INSERT INTO `dg_cities` VALUES (468, 'Kearney');
INSERT INTO `dg_cities` VALUES (469, 'Kearns');
INSERT INTO `dg_cities` VALUES (470, 'Keene');
INSERT INTO `dg_cities` VALUES (471, 'Kemmerer');
INSERT INTO `dg_cities` VALUES (472, 'Kenner');
INSERT INTO `dg_cities` VALUES (473, 'Kennesaw');
INSERT INTO `dg_cities` VALUES (474, 'Kennewick');
INSERT INTO `dg_cities` VALUES (475, 'Kenosha');
INSERT INTO `dg_cities` VALUES (476, 'Kent');
INSERT INTO `dg_cities` VALUES (477, 'Ketchikan');
INSERT INTO `dg_cities` VALUES (478, 'Kettering');
INSERT INTO `dg_cities` VALUES (479, 'Kingsport');
INSERT INTO `dg_cities` VALUES (480, 'Kingston');
INSERT INTO `dg_cities` VALUES (481, 'Klamath Falls');
INSERT INTO `dg_cities` VALUES (482, 'Knoxville');
INSERT INTO `dg_cities` VALUES (483, 'Kokomo');
INSERT INTO `dg_cities` VALUES (484, 'Kona');
INSERT INTO `dg_cities` VALUES (485, 'La Caada Flintridge');
INSERT INTO `dg_cities` VALUES (486, 'La Crosse');
INSERT INTO `dg_cities` VALUES (487, 'La Habra');
INSERT INTO `dg_cities` VALUES (488, 'La Habra Heights');
INSERT INTO `dg_cities` VALUES (489, 'La Jolla');
INSERT INTO `dg_cities` VALUES (490, 'La Mirada');
INSERT INTO `dg_cities` VALUES (491, 'La Palma');
INSERT INTO `dg_cities` VALUES (492, 'La Puente');
INSERT INTO `dg_cities` VALUES (493, 'La Verne');
INSERT INTO `dg_cities` VALUES (494, 'Laconia');
INSERT INTO `dg_cities` VALUES (495, 'Lafayette');
INSERT INTO `dg_cities` VALUES (496, 'LaGrange');
INSERT INTO `dg_cities` VALUES (497, 'Laguna Beach');
INSERT INTO `dg_cities` VALUES (498, 'Laguna Hills');
INSERT INTO `dg_cities` VALUES (499, 'Laguna Niguel');
INSERT INTO `dg_cities` VALUES (500, 'Laguna Woods');
INSERT INTO `dg_cities` VALUES (501, 'Lahaina');
INSERT INTO `dg_cities` VALUES (502, 'Lake Charles');
INSERT INTO `dg_cities` VALUES (503, 'Lake Forest');
INSERT INTO `dg_cities` VALUES (504, 'Lakeland');
INSERT INTO `dg_cities` VALUES (505, 'Lakewood');
INSERT INTO `dg_cities` VALUES (506, 'Lancaster');
INSERT INTO `dg_cities` VALUES (507, 'Lander');
INSERT INTO `dg_cities` VALUES (508, 'Lansing');
INSERT INTO `dg_cities` VALUES (509, 'Laramie');
INSERT INTO `dg_cities` VALUES (510, 'Laredo');
INSERT INTO `dg_cities` VALUES (511, 'Las Cruces');
INSERT INTO `dg_cities` VALUES (512, 'Las Vegas');
INSERT INTO `dg_cities` VALUES (513, 'Latrobe');
INSERT INTO `dg_cities` VALUES (514, 'Laughlin');
INSERT INTO `dg_cities` VALUES (515, 'Laurel');
INSERT INTO `dg_cities` VALUES (516, 'Lawndale');
INSERT INTO `dg_cities` VALUES (517, 'Lawrence');
INSERT INTO `dg_cities` VALUES (518, 'Lawrenceville');
INSERT INTO `dg_cities` VALUES (519, 'Lawton');
INSERT INTO `dg_cities` VALUES (520, 'Layton');
INSERT INTO `dg_cities` VALUES (521, 'Lebanon');
INSERT INTO `dg_cities` VALUES (522, 'Leominster');
INSERT INTO `dg_cities` VALUES (523, 'Lewiston');
INSERT INTO `dg_cities` VALUES (524, 'Lexington');
INSERT INTO `dg_cities` VALUES (525, 'Liberal');
INSERT INTO `dg_cities` VALUES (526, 'Lima');
INSERT INTO `dg_cities` VALUES (527, 'Lincoln');
INSERT INTO `dg_cities` VALUES (528, 'Little Falls');
INSERT INTO `dg_cities` VALUES (529, 'Little Rock');
INSERT INTO `dg_cities` VALUES (530, 'Littleton');
INSERT INTO `dg_cities` VALUES (531, 'Livonia');
INSERT INTO `dg_cities` VALUES (532, 'Lock Haven');
INSERT INTO `dg_cities` VALUES (533, 'Lockport');
INSERT INTO `dg_cities` VALUES (534, 'Lodi');
INSERT INTO `dg_cities` VALUES (535, 'Logan');
INSERT INTO `dg_cities` VALUES (536, 'Lomita');
INSERT INTO `dg_cities` VALUES (537, 'Long Beach');
INSERT INTO `dg_cities` VALUES (538, 'Longview');
INSERT INTO `dg_cities` VALUES (539, 'Los Alamitos');
INSERT INTO `dg_cities` VALUES (540, 'Los Angeles');
INSERT INTO `dg_cities` VALUES (541, 'Loudon');
INSERT INTO `dg_cities` VALUES (542, 'Louisville');
INSERT INTO `dg_cities` VALUES (543, 'Lowell');
INSERT INTO `dg_cities` VALUES (544, 'Lower Burrell');
INSERT INTO `dg_cities` VALUES (545, 'Lubbock');
INSERT INTO `dg_cities` VALUES (546, 'Lufkin');
INSERT INTO `dg_cities` VALUES (547, 'Lynchburg');
INSERT INTO `dg_cities` VALUES (548, 'Lynn');
INSERT INTO `dg_cities` VALUES (549, 'Lynwood');
INSERT INTO `dg_cities` VALUES (550, 'Macomb');
INSERT INTO `dg_cities` VALUES (551, 'Macon');
INSERT INTO `dg_cities` VALUES (552, 'Madison');
INSERT INTO `dg_cities` VALUES (553, 'Malden');
INSERT INTO `dg_cities` VALUES (554, 'Malibu');
INSERT INTO `dg_cities` VALUES (555, 'Manassas');
INSERT INTO `dg_cities` VALUES (556, 'Manassas Park');
INSERT INTO `dg_cities` VALUES (557, 'Manchester');
INSERT INTO `dg_cities` VALUES (558, 'Mandan');
INSERT INTO `dg_cities` VALUES (559, 'Manhattan');
INSERT INTO `dg_cities` VALUES (560, 'Manhattan Beach');
INSERT INTO `dg_cities` VALUES (561, 'Manitowoc');
INSERT INTO `dg_cities` VALUES (562, 'Mankato');
INSERT INTO `dg_cities` VALUES (563, 'Marietta');
INSERT INTO `dg_cities` VALUES (564, 'Marlborough');
INSERT INTO `dg_cities` VALUES (565, 'Marquette');
INSERT INTO `dg_cities` VALUES (566, 'Marshall');
INSERT INTO `dg_cities` VALUES (567, 'Marshfield');
INSERT INTO `dg_cities` VALUES (568, 'Martinsburg');
INSERT INTO `dg_cities` VALUES (569, 'Mason City');
INSERT INTO `dg_cities` VALUES (570, 'Mayagez');
INSERT INTO `dg_cities` VALUES (571, 'Maywood');
INSERT INTO `dg_cities` VALUES (572, 'McAlester');
INSERT INTO `dg_cities` VALUES (573, 'McAllen');
INSERT INTO `dg_cities` VALUES (574, 'McKeesport');
INSERT INTO `dg_cities` VALUES (575, 'Meadville');
INSERT INTO `dg_cities` VALUES (576, 'Mechanicville');
INSERT INTO `dg_cities` VALUES (577, 'Medford');
INSERT INTO `dg_cities` VALUES (578, 'Melrose');
INSERT INTO `dg_cities` VALUES (579, 'Memphis');
INSERT INTO `dg_cities` VALUES (580, 'Menomonee Falls');
INSERT INTO `dg_cities` VALUES (581, 'Mentor');
INSERT INTO `dg_cities` VALUES (582, 'Mequon');
INSERT INTO `dg_cities` VALUES (583, 'Merced');
INSERT INTO `dg_cities` VALUES (584, 'Meriden');
INSERT INTO `dg_cities` VALUES (585, 'Meridian');
INSERT INTO `dg_cities` VALUES (586, 'Merizo');
INSERT INTO `dg_cities` VALUES (587, 'Mesa');
INSERT INTO `dg_cities` VALUES (588, 'Mesquite');
INSERT INTO `dg_cities` VALUES (589, 'Methuen');
INSERT INTO `dg_cities` VALUES (590, 'Miami');
INSERT INTO `dg_cities` VALUES (591, 'Miami Beach');
INSERT INTO `dg_cities` VALUES (592, 'Miami Gardens');
INSERT INTO `dg_cities` VALUES (593, 'Michigan City');
INSERT INTO `dg_cities` VALUES (594, 'Middlebury');
INSERT INTO `dg_cities` VALUES (595, 'Middletown');
INSERT INTO `dg_cities` VALUES (596, 'Midland');
INSERT INTO `dg_cities` VALUES (597, 'Midwest City');
INSERT INTO `dg_cities` VALUES (598, 'Milford');
INSERT INTO `dg_cities` VALUES (599, 'Milwaukee');
INSERT INTO `dg_cities` VALUES (600, 'Minneapolis');
INSERT INTO `dg_cities` VALUES (601, 'Minnetonka');
INSERT INTO `dg_cities` VALUES (602, 'Minot');
INSERT INTO `dg_cities` VALUES (603, 'Mission Viejo');
INSERT INTO `dg_cities` VALUES (604, 'Missoula');
INSERT INTO `dg_cities` VALUES (605, 'Mobile');
INSERT INTO `dg_cities` VALUES (606, 'Modesto');
INSERT INTO `dg_cities` VALUES (607, 'Moline');
INSERT INTO `dg_cities` VALUES (608, 'Monongahela');
INSERT INTO `dg_cities` VALUES (609, 'Monroe');
INSERT INTO `dg_cities` VALUES (610, 'Monrovia');
INSERT INTO `dg_cities` VALUES (611, 'Montebello');
INSERT INTO `dg_cities` VALUES (612, 'Monterey');
INSERT INTO `dg_cities` VALUES (613, 'Monterey Park');
INSERT INTO `dg_cities` VALUES (614, 'Montgomery');
INSERT INTO `dg_cities` VALUES (615, 'Montpelier');
INSERT INTO `dg_cities` VALUES (616, 'Moore');
INSERT INTO `dg_cities` VALUES (617, 'Moorhead');
INSERT INTO `dg_cities` VALUES (618, 'Moraga');
INSERT INTO `dg_cities` VALUES (619, 'Moreno Valley');
INSERT INTO `dg_cities` VALUES (620, 'Morgan City');
INSERT INTO `dg_cities` VALUES (621, 'Morgantown');
INSERT INTO `dg_cities` VALUES (622, 'Morrison');
INSERT INTO `dg_cities` VALUES (623, 'Moscow');
INSERT INTO `dg_cities` VALUES (624, 'Moultrie');
INSERT INTO `dg_cities` VALUES (625, 'Mount Pleasant');
INSERT INTO `dg_cities` VALUES (626, 'Mount Vernon');
INSERT INTO `dg_cities` VALUES (627, 'Muncie');
INSERT INTO `dg_cities` VALUES (628, 'Murfreesboro');
INSERT INTO `dg_cities` VALUES (629, 'Murray');
INSERT INTO `dg_cities` VALUES (630, 'Murrieta');
INSERT INTO `dg_cities` VALUES (631, 'Muskegon');
INSERT INTO `dg_cities` VALUES (632, 'Muskogee');
INSERT INTO `dg_cities` VALUES (633, 'Myrtle Beach');
INSERT INTO `dg_cities` VALUES (634, 'Nacogdoches');
INSERT INTO `dg_cities` VALUES (635, 'Nampa');
INSERT INTO `dg_cities` VALUES (636, 'Nanticoke');
INSERT INTO `dg_cities` VALUES (637, 'Naperville');
INSERT INTO `dg_cities` VALUES (638, 'Narragansett');
INSERT INTO `dg_cities` VALUES (639, 'Nashua');
INSERT INTO `dg_cities` VALUES (640, 'Nashville');
INSERT INTO `dg_cities` VALUES (641, 'Natchez');
INSERT INTO `dg_cities` VALUES (642, 'Natchitoches');
INSERT INTO `dg_cities` VALUES (643, 'Needham');
INSERT INTO `dg_cities` VALUES (644, 'Nenana');
INSERT INTO `dg_cities` VALUES (645, 'Nevada City');
INSERT INTO `dg_cities` VALUES (646, 'New Albany');
INSERT INTO `dg_cities` VALUES (647, 'New Bedford');
INSERT INTO `dg_cities` VALUES (648, 'New Britain');
INSERT INTO `dg_cities` VALUES (649, 'New Brunswick');
INSERT INTO `dg_cities` VALUES (650, 'New Castle');
INSERT INTO `dg_cities` VALUES (651, 'New Haven');
INSERT INTO `dg_cities` VALUES (652, 'New Iberia');
INSERT INTO `dg_cities` VALUES (653, 'New Kensington');
INSERT INTO `dg_cities` VALUES (654, 'New London');
INSERT INTO `dg_cities` VALUES (655, 'New Madrid');
INSERT INTO `dg_cities` VALUES (656, 'New Orleans');
INSERT INTO `dg_cities` VALUES (657, 'New Rochelle');
INSERT INTO `dg_cities` VALUES (658, 'New York');
INSERT INTO `dg_cities` VALUES (659, 'Newark');
INSERT INTO `dg_cities` VALUES (660, 'Newburgh');
INSERT INTO `dg_cities` VALUES (661, 'Newburyport');
INSERT INTO `dg_cities` VALUES (662, 'Newcastle');
INSERT INTO `dg_cities` VALUES (663, 'Newport');
INSERT INTO `dg_cities` VALUES (664, 'Newport Beach');
INSERT INTO `dg_cities` VALUES (665, 'Newport News');
INSERT INTO `dg_cities` VALUES (666, 'Newton');
INSERT INTO `dg_cities` VALUES (667, 'Niagara Falls');
INSERT INTO `dg_cities` VALUES (668, 'Nichols Hills');
INSERT INTO `dg_cities` VALUES (669, 'Nogales');
INSERT INTO `dg_cities` VALUES (670, 'Nome');
INSERT INTO `dg_cities` VALUES (671, 'Norfolk');
INSERT INTO `dg_cities` VALUES (672, 'Normal');
INSERT INTO `dg_cities` VALUES (673, 'Norman');
INSERT INTO `dg_cities` VALUES (674, 'North Adams');
INSERT INTO `dg_cities` VALUES (675, 'North Charleston');
INSERT INTO `dg_cities` VALUES (676, 'North Chicago');
INSERT INTO `dg_cities` VALUES (677, 'North Las Vegas');
INSERT INTO `dg_cities` VALUES (678, 'North Little Rock');
INSERT INTO `dg_cities` VALUES (679, 'North Platte');
INSERT INTO `dg_cities` VALUES (680, 'North Pole');
INSERT INTO `dg_cities` VALUES (681, 'North Tonawanda');
INSERT INTO `dg_cities` VALUES (682, 'Northampton');
INSERT INTO `dg_cities` VALUES (683, 'Norton');
INSERT INTO `dg_cities` VALUES (684, 'Norwalk');
INSERT INTO `dg_cities` VALUES (685, 'Norwich');
INSERT INTO `dg_cities` VALUES (686, 'Oak Ridge');
INSERT INTO `dg_cities` VALUES (687, 'Oakland');
INSERT INTO `dg_cities` VALUES (688, 'Ocean City');
INSERT INTO `dg_cities` VALUES (689, 'Odessa');
INSERT INTO `dg_cities` VALUES (690, 'Ogden');
INSERT INTO `dg_cities` VALUES (691, 'Ogdensburg');
INSERT INTO `dg_cities` VALUES (692, 'Oil City');
INSERT INTO `dg_cities` VALUES (693, 'Oklahoma City');
INSERT INTO `dg_cities` VALUES (694, 'Olean');
INSERT INTO `dg_cities` VALUES (695, 'Olympia');
INSERT INTO `dg_cities` VALUES (696, 'Omaha');
INSERT INTO `dg_cities` VALUES (697, 'Oneida');
INSERT INTO `dg_cities` VALUES (698, 'Oneonta');
INSERT INTO `dg_cities` VALUES (699, 'Ontario');
INSERT INTO `dg_cities` VALUES (700, 'Opelousas');
INSERT INTO `dg_cities` VALUES (701, 'Orange');
INSERT INTO `dg_cities` VALUES (702, 'Orangeburg');
INSERT INTO `dg_cities` VALUES (703, 'Orem');
INSERT INTO `dg_cities` VALUES (704, 'Orlando');
INSERT INTO `dg_cities` VALUES (705, 'Oro Valley');
INSERT INTO `dg_cities` VALUES (706, 'Oshkosh');
INSERT INTO `dg_cities` VALUES (707, 'Oswego');
INSERT INTO `dg_cities` VALUES (708, 'Overland Park');
INSERT INTO `dg_cities` VALUES (709, 'Owensboro');
INSERT INTO `dg_cities` VALUES (710, 'Oxford');
INSERT INTO `dg_cities` VALUES (711, 'Oxnard');
INSERT INTO `dg_cities` VALUES (712, 'Paducah');
INSERT INTO `dg_cities` VALUES (713, 'Palm Springs');
INSERT INTO `dg_cities` VALUES (714, 'Palmdale');
INSERT INTO `dg_cities` VALUES (715, 'Palo Alto');
INSERT INTO `dg_cities` VALUES (716, 'Palos Verdes Estates');
INSERT INTO `dg_cities` VALUES (717, 'Paramount');
INSERT INTO `dg_cities` VALUES (718, 'Parker');
INSERT INTO `dg_cities` VALUES (719, 'Parkersburg');
INSERT INTO `dg_cities` VALUES (720, 'Parma');
INSERT INTO `dg_cities` VALUES (721, 'Pasadena');
INSERT INTO `dg_cities` VALUES (722, 'Pascagoula');
INSERT INTO `dg_cities` VALUES (723, 'Pasco');
INSERT INTO `dg_cities` VALUES (724, 'Pass Christian');
INSERT INTO `dg_cities` VALUES (725, 'Passaic');
INSERT INTO `dg_cities` VALUES (726, 'Paterson');
INSERT INTO `dg_cities` VALUES (727, 'Pawtucket');
INSERT INTO `dg_cities` VALUES (728, 'Peabody');
INSERT INTO `dg_cities` VALUES (729, 'Peekskill');
INSERT INTO `dg_cities` VALUES (730, 'Pembroke Pines');
INSERT INTO `dg_cities` VALUES (731, 'Pendleton');
INSERT INTO `dg_cities` VALUES (732, 'Peoria');
INSERT INTO `dg_cities` VALUES (733, 'Perth Amboy');
INSERT INTO `dg_cities` VALUES (734, 'Peru');
INSERT INTO `dg_cities` VALUES (735, 'Phenix City');
INSERT INTO `dg_cities` VALUES (736, 'Philadelphia');
INSERT INTO `dg_cities` VALUES (737, 'Phoenix');
INSERT INTO `dg_cities` VALUES (738, 'Pico Rivera');
INSERT INTO `dg_cities` VALUES (739, 'Pierre');
INSERT INTO `dg_cities` VALUES (740, 'Pine Bluff');
INSERT INTO `dg_cities` VALUES (741, 'Pittsburgh');
INSERT INTO `dg_cities` VALUES (742, 'Pittsfield');
INSERT INTO `dg_cities` VALUES (743, 'Pittston');
INSERT INTO `dg_cities` VALUES (744, 'Placentia');
INSERT INTO `dg_cities` VALUES (745, 'Plainfield');
INSERT INTO `dg_cities` VALUES (746, 'Plano');
INSERT INTO `dg_cities` VALUES (747, 'Plantation');
INSERT INTO `dg_cities` VALUES (748, 'Plattsburgh');
INSERT INTO `dg_cities` VALUES (749, 'Plymouth');
INSERT INTO `dg_cities` VALUES (750, 'Pocatello');
INSERT INTO `dg_cities` VALUES (751, 'Pomona');
INSERT INTO `dg_cities` VALUES (752, 'Ponce');
INSERT INTO `dg_cities` VALUES (753, 'Port Arthur');
INSERT INTO `dg_cities` VALUES (754, 'Port Huron');
INSERT INTO `dg_cities` VALUES (755, 'Port Jervis');
INSERT INTO `dg_cities` VALUES (756, 'Port Orford');
INSERT INTO `dg_cities` VALUES (757, 'Port St. Lucie');
INSERT INTO `dg_cities` VALUES (758, 'Port Washington');
INSERT INTO `dg_cities` VALUES (759, 'Portland');
INSERT INTO `dg_cities` VALUES (760, 'Portsmouth');
INSERT INTO `dg_cities` VALUES (761, 'Pottsville');
INSERT INTO `dg_cities` VALUES (762, 'Poughkeepsie');
INSERT INTO `dg_cities` VALUES (763, 'Powell');
INSERT INTO `dg_cities` VALUES (764, 'Prescott');
INSERT INTO `dg_cities` VALUES (765, 'Princeton');
INSERT INTO `dg_cities` VALUES (766, 'Providence');
INSERT INTO `dg_cities` VALUES (767, 'Provo');
INSERT INTO `dg_cities` VALUES (768, 'Pueblo');
INSERT INTO `dg_cities` VALUES (769, 'Pulaski');
INSERT INTO `dg_cities` VALUES (770, 'Pullman');
INSERT INTO `dg_cities` VALUES (771, 'Quincy');
INSERT INTO `dg_cities` VALUES (772, 'Racine');
INSERT INTO `dg_cities` VALUES (773, 'Radford');
INSERT INTO `dg_cities` VALUES (774, 'Raleigh');
INSERT INTO `dg_cities` VALUES (775, 'Rancho Cordova');
INSERT INTO `dg_cities` VALUES (776, 'Rancho Cucamonga');
INSERT INTO `dg_cities` VALUES (777, 'Rancho Palos Verdes');
INSERT INTO `dg_cities` VALUES (778, 'Rancho Santa Margarita');
INSERT INTO `dg_cities` VALUES (779, 'Rapid City');
INSERT INTO `dg_cities` VALUES (780, 'Rawlins');
INSERT INTO `dg_cities` VALUES (781, 'Reading');
INSERT INTO `dg_cities` VALUES (782, 'Redding');
INSERT INTO `dg_cities` VALUES (783, 'Redlands');
INSERT INTO `dg_cities` VALUES (784, 'Redondo Beach');
INSERT INTO `dg_cities` VALUES (785, 'Reedsport');
INSERT INTO `dg_cities` VALUES (786, 'Rehoboth Beach');
INSERT INTO `dg_cities` VALUES (787, 'Reno');
INSERT INTO `dg_cities` VALUES (788, 'Rensselaer');
INSERT INTO `dg_cities` VALUES (789, 'Revere');
INSERT INTO `dg_cities` VALUES (790, 'Rhinelander');
INSERT INTO `dg_cities` VALUES (791, 'Rialto');
INSERT INTO `dg_cities` VALUES (792, 'Richland');
INSERT INTO `dg_cities` VALUES (793, 'Richmond');
INSERT INTO `dg_cities` VALUES (794, 'Richmond');
INSERT INTO `dg_cities` VALUES (795, 'Riverside');
INSERT INTO `dg_cities` VALUES (796, 'Riverton');
INSERT INTO `dg_cities` VALUES (797, 'Roanoke');
INSERT INTO `dg_cities` VALUES (798, 'Rochester');
INSERT INTO `dg_cities` VALUES (799, 'Rock Island');
INSERT INTO `dg_cities` VALUES (800, 'Rock Springs');
INSERT INTO `dg_cities` VALUES (801, 'Rockford');
INSERT INTO `dg_cities` VALUES (802, 'Rockville');
INSERT INTO `dg_cities` VALUES (803, 'Rocky Mount');
INSERT INTO `dg_cities` VALUES (804, 'Rohnert Park');
INSERT INTO `dg_cities` VALUES (805, 'Rolla');
INSERT INTO `dg_cities` VALUES (806, 'Rolling Hills');
INSERT INTO `dg_cities` VALUES (807, 'Rolling Hills Estates');
INSERT INTO `dg_cities` VALUES (808, 'Rome');
INSERT INTO `dg_cities` VALUES (809, 'Rosemead');
INSERT INTO `dg_cities` VALUES (810, 'Roseville');
INSERT INTO `dg_cities` VALUES (811, 'Roswell');
INSERT INTO `dg_cities` VALUES (812, 'Ruston');
INSERT INTO `dg_cities` VALUES (813, 'Rutland');
INSERT INTO `dg_cities` VALUES (814, 'Rye');
INSERT INTO `dg_cities` VALUES (815, 'Sacramento');
INSERT INTO `dg_cities` VALUES (816, 'Saginaw');
INSERT INTO `dg_cities` VALUES (817, 'Saint Albans');
INSERT INTO `dg_cities` VALUES (818, 'Saint Cloud');
INSERT INTO `dg_cities` VALUES (819, 'Saint Joseph');
INSERT INTO `dg_cities` VALUES (820, 'Saint Louis');
INSERT INTO `dg_cities` VALUES (821, 'Saint Paul');
INSERT INTO `dg_cities` VALUES (822, 'Saipan');
INSERT INTO `dg_cities` VALUES (823, 'Salem');
INSERT INTO `dg_cities` VALUES (824, 'Salem');
INSERT INTO `dg_cities` VALUES (825, 'Salinas');
INSERT INTO `dg_cities` VALUES (826, 'Salisbury');
INSERT INTO `dg_cities` VALUES (827, 'Salt Lake City');
INSERT INTO `dg_cities` VALUES (828, 'San Angelo');
INSERT INTO `dg_cities` VALUES (829, 'San Antonio');
INSERT INTO `dg_cities` VALUES (830, 'San Bernardino');
INSERT INTO `dg_cities` VALUES (831, 'San Clemente');
INSERT INTO `dg_cities` VALUES (832, 'San Diego');
INSERT INTO `dg_cities` VALUES (833, 'San Dimas');
INSERT INTO `dg_cities` VALUES (834, 'San Fernando');
INSERT INTO `dg_cities` VALUES (835, 'San Francisco');
INSERT INTO `dg_cities` VALUES (836, 'San Gabriel');
INSERT INTO `dg_cities` VALUES (837, 'San Jose');
INSERT INTO `dg_cities` VALUES (838, 'San Juan');
INSERT INTO `dg_cities` VALUES (839, 'San Juan Capistrano');
INSERT INTO `dg_cities` VALUES (840, 'San Luis Obispo');
INSERT INTO `dg_cities` VALUES (841, 'San Marino');
INSERT INTO `dg_cities` VALUES (842, 'San Mateo');
INSERT INTO `dg_cities` VALUES (843, 'San Rafael');
INSERT INTO `dg_cities` VALUES (844, 'Sandpoint');
INSERT INTO `dg_cities` VALUES (845, 'Sandy');
INSERT INTO `dg_cities` VALUES (846, 'Sandy Springs');
INSERT INTO `dg_cities` VALUES (847, 'Sanford');
INSERT INTO `dg_cities` VALUES (848, 'Santa Ana');
INSERT INTO `dg_cities` VALUES (849, 'Santa Barbara');
INSERT INTO `dg_cities` VALUES (850, 'Santa Clara');
INSERT INTO `dg_cities` VALUES (851, 'Santa Clarita');
INSERT INTO `dg_cities` VALUES (852, 'Santa Cruz');
INSERT INTO `dg_cities` VALUES (853, 'Santa Fe');
INSERT INTO `dg_cities` VALUES (854, 'Santa Fe Springs');
INSERT INTO `dg_cities` VALUES (855, 'Santa Monica');
INSERT INTO `dg_cities` VALUES (856, 'Santa Rosa');
INSERT INTO `dg_cities` VALUES (857, 'Saratoga Springs');
INSERT INTO `dg_cities` VALUES (858, 'Saukville');
INSERT INTO `dg_cities` VALUES (859, 'Sault Ste. Marie');
INSERT INTO `dg_cities` VALUES (860, 'Savannah');
INSERT INTO `dg_cities` VALUES (861, 'Scarborough');
INSERT INTO `dg_cities` VALUES (862, 'Schaumburg');
INSERT INTO `dg_cities` VALUES (863, 'Schenectady');
INSERT INTO `dg_cities` VALUES (864, 'Scottsbluff');
INSERT INTO `dg_cities` VALUES (865, 'Scottsdale');
INSERT INTO `dg_cities` VALUES (866, 'Scranton');
INSERT INTO `dg_cities` VALUES (867, 'Seaford');
INSERT INTO `dg_cities` VALUES (868, 'Seal Beach');
INSERT INTO `dg_cities` VALUES (869, 'Seattle');
INSERT INTO `dg_cities` VALUES (870, 'Sedalia');
INSERT INTO `dg_cities` VALUES (871, 'Selma');
INSERT INTO `dg_cities` VALUES (872, 'Seward');
INSERT INTO `dg_cities` VALUES (873, 'Shamokin');
INSERT INTO `dg_cities` VALUES (874, 'Sharon');
INSERT INTO `dg_cities` VALUES (875, 'Shawnee');
INSERT INTO `dg_cities` VALUES (876, 'Sheboygan');
INSERT INTO `dg_cities` VALUES (877, 'Shelton');
INSERT INTO `dg_cities` VALUES (878, 'Sheridan');
INSERT INTO `dg_cities` VALUES (879, 'Sherrill');
INSERT INTO `dg_cities` VALUES (880, 'Shreveport');
INSERT INTO `dg_cities` VALUES (881, 'Sierra Madre');
INSERT INTO `dg_cities` VALUES (882, 'Sierra Vista');
INSERT INTO `dg_cities` VALUES (883, 'Signal Hill');
INSERT INTO `dg_cities` VALUES (884, 'Simi Valley');
INSERT INTO `dg_cities` VALUES (885, 'Sioux City');
INSERT INTO `dg_cities` VALUES (886, 'Sioux Falls');
INSERT INTO `dg_cities` VALUES (887, 'Sister Bay');
INSERT INTO `dg_cities` VALUES (888, 'Sitka');
INSERT INTO `dg_cities` VALUES (889, 'Slidell');
INSERT INTO `dg_cities` VALUES (890, 'Somersworth');
INSERT INTO `dg_cities` VALUES (891, 'Somerville');
INSERT INTO `dg_cities` VALUES (892, 'Sonoma');
INSERT INTO `dg_cities` VALUES (893, 'South Bend');
INSERT INTO `dg_cities` VALUES (894, 'South Burlington');
INSERT INTO `dg_cities` VALUES (895, 'South El Monte');
INSERT INTO `dg_cities` VALUES (896, 'South Gate');
INSERT INTO `dg_cities` VALUES (897, 'South Pasadena');
INSERT INTO `dg_cities` VALUES (898, 'South Portland');
INSERT INTO `dg_cities` VALUES (899, 'Spartanburg');
INSERT INTO `dg_cities` VALUES (900, 'Spokane');
INSERT INTO `dg_cities` VALUES (901, 'Spokane Valley');
INSERT INTO `dg_cities` VALUES (902, 'Springdale');
INSERT INTO `dg_cities` VALUES (903, 'Springfield');
INSERT INTO `dg_cities` VALUES (904, 'Springfield');
INSERT INTO `dg_cities` VALUES (905, 'St. George');
INSERT INTO `dg_cities` VALUES (906, 'St. Marys');
INSERT INTO `dg_cities` VALUES (907, 'St. Petersburg');
INSERT INTO `dg_cities` VALUES (908, 'Stafford');
INSERT INTO `dg_cities` VALUES (909, 'Stamford');
INSERT INTO `dg_cities` VALUES (910, 'Stanton');
INSERT INTO `dg_cities` VALUES (911, 'Starkville');
INSERT INTO `dg_cities` VALUES (912, 'Statesboro');
INSERT INTO `dg_cities` VALUES (913, 'Staunton');
INSERT INTO `dg_cities` VALUES (914, 'Steubenville');
INSERT INTO `dg_cities` VALUES (915, 'Stevens Point');
INSERT INTO `dg_cities` VALUES (916, 'Stillwater');
INSERT INTO `dg_cities` VALUES (917, 'Stockton');
INSERT INTO `dg_cities` VALUES (918, 'Sturgis');
INSERT INTO `dg_cities` VALUES (919, 'Suffolk');
INSERT INTO `dg_cities` VALUES (920, 'Sugar Land');
INSERT INTO `dg_cities` VALUES (921, 'Sun Valley');
INSERT INTO `dg_cities` VALUES (922, 'Sunbury');
INSERT INTO `dg_cities` VALUES (923, 'Sunnyvale');
INSERT INTO `dg_cities` VALUES (924, 'Superior');
INSERT INTO `dg_cities` VALUES (925, 'Sutter Creek');
INSERT INTO `dg_cities` VALUES (926, 'Syracuse');
INSERT INTO `dg_cities` VALUES (927, 'Tacoma');
INSERT INTO `dg_cities` VALUES (928, 'Tallahassee');
INSERT INTO `dg_cities` VALUES (929, 'Tampa');
INSERT INTO `dg_cities` VALUES (930, 'Tamuning');
INSERT INTO `dg_cities` VALUES (931, 'Taunton');
INSERT INTO `dg_cities` VALUES (932, 'Taylorsville');
INSERT INTO `dg_cities` VALUES (933, 'Temecula');
INSERT INTO `dg_cities` VALUES (934, 'Tempe');
INSERT INTO `dg_cities` VALUES (935, 'Temple City');
INSERT INTO `dg_cities` VALUES (936, 'Terre Haute');
INSERT INTO `dg_cities` VALUES (937, 'Texarkana');
INSERT INTO `dg_cities` VALUES (938, 'Texas City');
INSERT INTO `dg_cities` VALUES (939, 'The Dalles');
INSERT INTO `dg_cities` VALUES (940, 'Thibodaux');
INSERT INTO `dg_cities` VALUES (941, 'Thiensville');
INSERT INTO `dg_cities` VALUES (942, 'Thomasville');
INSERT INTO `dg_cities` VALUES (943, 'Thousand Oaks');
INSERT INTO `dg_cities` VALUES (944, 'Titusville');
INSERT INTO `dg_cities` VALUES (945, 'Tok');
INSERT INTO `dg_cities` VALUES (946, 'Toledo');
INSERT INTO `dg_cities` VALUES (947, 'Tonawanda');
INSERT INTO `dg_cities` VALUES (948, 'Topeka');
INSERT INTO `dg_cities` VALUES (949, 'Torrance');
INSERT INTO `dg_cities` VALUES (950, 'Torrington');
INSERT INTO `dg_cities` VALUES (951, 'Trenton');
INSERT INTO `dg_cities` VALUES (952, 'Troy');
INSERT INTO `dg_cities` VALUES (953, 'Truth or Consequences');
INSERT INTO `dg_cities` VALUES (954, 'Tucson');
INSERT INTO `dg_cities` VALUES (955, 'Tulsa');
INSERT INTO `dg_cities` VALUES (956, 'Tupelo');
INSERT INTO `dg_cities` VALUES (957, 'Turlock');
INSERT INTO `dg_cities` VALUES (958, 'Tuscaloosa');
INSERT INTO `dg_cities` VALUES (959, 'Tustin');
INSERT INTO `dg_cities` VALUES (960, 'Twin Falls');
INSERT INTO `dg_cities` VALUES (961, 'Two Rivers');
INSERT INTO `dg_cities` VALUES (962, 'Tyler');
INSERT INTO `dg_cities` VALUES (963, 'Union City');
INSERT INTO `dg_cities` VALUES (964, 'Uniontown');
INSERT INTO `dg_cities` VALUES (965, 'Urbana');
INSERT INTO `dg_cities` VALUES (966, 'Utica');
INSERT INTO `dg_cities` VALUES (967, 'Vacaville');
INSERT INTO `dg_cities` VALUES (968, 'Vail');
INSERT INTO `dg_cities` VALUES (969, 'Valdez');
INSERT INTO `dg_cities` VALUES (970, 'Valdosta');
INSERT INTO `dg_cities` VALUES (971, 'Valencia');
INSERT INTO `dg_cities` VALUES (972, 'Vallejo');
INSERT INTO `dg_cities` VALUES (973, 'Valparaiso');
INSERT INTO `dg_cities` VALUES (974, 'Vancouver');
INSERT INTO `dg_cities` VALUES (975, 'Ventura');
INSERT INTO `dg_cities` VALUES (976, 'Vergennes');
INSERT INTO `dg_cities` VALUES (977, 'Vermillion');
INSERT INTO `dg_cities` VALUES (978, 'Vernon');
INSERT INTO `dg_cities` VALUES (979, 'Vicksburg');
INSERT INTO `dg_cities` VALUES (980, 'Victoria');
INSERT INTO `dg_cities` VALUES (981, 'Villa Park');
INSERT INTO `dg_cities` VALUES (982, 'Vincennes');
INSERT INTO `dg_cities` VALUES (983, 'Vineland');
INSERT INTO `dg_cities` VALUES (984, 'Virginia Beach');
INSERT INTO `dg_cities` VALUES (985, 'Visalia');
INSERT INTO `dg_cities` VALUES (986, 'Waco');
INSERT INTO `dg_cities` VALUES (987, 'Wahoo');
INSERT INTO `dg_cities` VALUES (988, 'Walla Walla');
INSERT INTO `dg_cities` VALUES (989, 'Walnut');
INSERT INTO `dg_cities` VALUES (990, 'Waltham');
INSERT INTO `dg_cities` VALUES (991, 'Warner Robins');
INSERT INTO `dg_cities` VALUES (992, 'Warren');
INSERT INTO `dg_cities` VALUES (993, 'Warwick');
INSERT INTO `dg_cities` VALUES (994, 'Washington');
INSERT INTO `dg_cities` VALUES (995, 'Waterbury');
INSERT INTO `dg_cities` VALUES (996, 'Waterloo');
INSERT INTO `dg_cities` VALUES (997, 'Watertown');
INSERT INTO `dg_cities` VALUES (998, 'Watervliet');
INSERT INTO `dg_cities` VALUES (999, 'Waukegan');
INSERT INTO `dg_cities` VALUES (1000, 'Wausau');
INSERT INTO `dg_cities` VALUES (1001, 'Waycross');
INSERT INTO `dg_cities` VALUES (1002, 'Webster Groves');
INSERT INTO `dg_cities` VALUES (1003, 'Weirton');
INSERT INTO `dg_cities` VALUES (1004, 'West Allis');
INSERT INTO `dg_cities` VALUES (1005, 'West Bend');
INSERT INTO `dg_cities` VALUES (1006, 'West Covina');
INSERT INTO `dg_cities` VALUES (1007, 'West Hartford');
INSERT INTO `dg_cities` VALUES (1008, 'West Haven');
INSERT INTO `dg_cities` VALUES (1009, 'West Hollywood');
INSERT INTO `dg_cities` VALUES (1010, 'West Jordan');
INSERT INTO `dg_cities` VALUES (1011, 'West Lafayette');
INSERT INTO `dg_cities` VALUES (1012, 'West Memphis');
INSERT INTO `dg_cities` VALUES (1013, 'West Palm Beach');
INSERT INTO `dg_cities` VALUES (1014, 'West Sacramento');
INSERT INTO `dg_cities` VALUES (1015, 'West Springfield');
INSERT INTO `dg_cities` VALUES (1016, 'West Valley City');
INSERT INTO `dg_cities` VALUES (1017, 'West Warwick');
INSERT INTO `dg_cities` VALUES (1018, 'Westfield');
INSERT INTO `dg_cities` VALUES (1019, 'Westlake Village');
INSERT INTO `dg_cities` VALUES (1020, 'Westminster');
INSERT INTO `dg_cities` VALUES (1021, 'Weymouth');
INSERT INTO `dg_cities` VALUES (1022, 'Wheaton');
INSERT INTO `dg_cities` VALUES (1023, 'Wheeling');
INSERT INTO `dg_cities` VALUES (1024, 'White Plains');
INSERT INTO `dg_cities` VALUES (1025, 'Whittier');
INSERT INTO `dg_cities` VALUES (1026, 'Wichita');
INSERT INTO `dg_cities` VALUES (1027, 'Wichita Falls');
INSERT INTO `dg_cities` VALUES (1028, 'Wilkes-Barre');
INSERT INTO `dg_cities` VALUES (1029, 'Williamsburg');
INSERT INTO `dg_cities` VALUES (1030, 'Williamsport');
INSERT INTO `dg_cities` VALUES (1031, 'Williston');
INSERT INTO `dg_cities` VALUES (1032, 'Wilmington');
INSERT INTO `dg_cities` VALUES (1033, 'Wilson');
INSERT INTO `dg_cities` VALUES (1034, 'Winnemucca');
INSERT INTO `dg_cities` VALUES (1035, 'Winooski');
INSERT INTO `dg_cities` VALUES (1036, 'Winston-Salem');
INSERT INTO `dg_cities` VALUES (1037, 'Wisconsin Dells');
INSERT INTO `dg_cities` VALUES (1038, 'Wisconsin Rapids');
INSERT INTO `dg_cities` VALUES (1039, 'Woburn');
INSERT INTO `dg_cities` VALUES (1040, 'Woodruff');
INSERT INTO `dg_cities` VALUES (1041, 'Woodward');
INSERT INTO `dg_cities` VALUES (1042, 'Woonsocket');
INSERT INTO `dg_cities` VALUES (1043, 'Worcester');
INSERT INTO `dg_cities` VALUES (1044, 'Worland');
INSERT INTO `dg_cities` VALUES (1045, 'Wynne');
INSERT INTO `dg_cities` VALUES (1046, 'Yakima');
INSERT INTO `dg_cities` VALUES (1047, 'Yazoo City');
INSERT INTO `dg_cities` VALUES (1048, 'Yigo');
INSERT INTO `dg_cities` VALUES (1049, 'Yonkers');
INSERT INTO `dg_cities` VALUES (1050, 'Yorba Linda');
INSERT INTO `dg_cities` VALUES (1051, 'York');
INSERT INTO `dg_cities` VALUES (1052, 'Youngstown');
INSERT INTO `dg_cities` VALUES (1053, 'Ypsilanti');
INSERT INTO `dg_cities` VALUES (1054, 'Yukon');
INSERT INTO `dg_cities` VALUES (1055, 'Yuma');
INSERT INTO `dg_cities` VALUES (1056, 'Zanesville');


-- 
-- table `dg_counties`
-- 

CREATE TABLE `dg_counties` (
  `county_id` mediumint(9) NOT NULL auto_increment,
  `county` varchar(50) NOT NULL default '',
  `chapman_code` char(3) NOT NULL default '',
  `country` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`county_id`)
) TYPE=MyISAM AUTO_INCREMENT=158 ;

INSERT INTO `dg_counties` VALUES (1, 'Aberdeenshire', 'ABD', 'Scotland');
INSERT INTO `dg_counties` VALUES (2, 'Anglesey', 'AGY', 'Wales');
INSERT INTO `dg_counties` VALUES (3, 'Alderney', 'ALD', 'Channel Islands');
INSERT INTO `dg_counties` VALUES (4, 'Angus', 'ANS', 'Scotland');
INSERT INTO `dg_counties` VALUES (5, 'Co. Antrim', 'ANT', 'Northern Ireland');
INSERT INTO `dg_counties` VALUES (6, 'Argyllshire', 'ARL', 'Scotland');
INSERT INTO `dg_counties` VALUES (7, 'Co. Armagh', 'ARM', 'Northern Ireland');
INSERT INTO `dg_counties` VALUES (8, 'Avon', 'AVN', 'England');
INSERT INTO `dg_counties` VALUES (9, 'Ayrshire', 'AYR', 'Scotland');
INSERT INTO `dg_counties` VALUES (10, 'Banffshire', 'BAN', 'Scotland');
INSERT INTO `dg_counties` VALUES (11, 'Bedfordshire', 'BDF', 'England');
INSERT INTO `dg_counties` VALUES (12, 'Berwickshire', 'BEW', 'Scotland');
INSERT INTO `dg_counties` VALUES (13, 'Buckinghamshire', 'BKM', 'England');
INSERT INTO `dg_counties` VALUES (14, 'Borders', 'BOR', 'Scotland');
INSERT INTO `dg_counties` VALUES (15, 'Breconshire', 'BRE', 'Wales');
INSERT INTO `dg_counties` VALUES (16, 'Berkshire', 'BRK', 'England');
INSERT INTO `dg_counties` VALUES (17, 'Bute', 'BUT', 'Scotland');
INSERT INTO `dg_counties` VALUES (18, 'Caernarvonshire', 'CAE', 'Wales');
INSERT INTO `dg_counties` VALUES (19, 'Caithness', 'CAI', 'Scotland');
INSERT INTO `dg_counties` VALUES (20, 'Cambridgeshire', 'CAM', 'England');
INSERT INTO `dg_counties` VALUES (21, 'Co. Carlow', 'CAR', 'Ireland');
INSERT INTO `dg_counties` VALUES (22, 'Co. Cavan', 'CAV', 'Ireland');
INSERT INTO `dg_counties` VALUES (23, 'Central', 'CEN', 'Scotland');
INSERT INTO `dg_counties` VALUES (24, 'Cardiganshire', 'CGN', 'Wales');
INSERT INTO `dg_counties` VALUES (25, 'Cheshire', 'CHS', 'England');
INSERT INTO `dg_counties` VALUES (26, 'Co. Clare', 'CLA', 'Ireland');
INSERT INTO `dg_counties` VALUES (27, 'Clackmannanshire', 'CLK', 'Scotland');
INSERT INTO `dg_counties` VALUES (28, 'Cleveland', 'CLV', 'England');
INSERT INTO `dg_counties` VALUES (29, 'Cumbria', 'CMA', 'England');
INSERT INTO `dg_counties` VALUES (30, 'Carmarthenshire', 'CMN', 'Wales');
INSERT INTO `dg_counties` VALUES (31, 'Cornwall', 'CON', 'England');
INSERT INTO `dg_counties` VALUES (32, 'Co. Cork', 'COR', 'Ireland');
INSERT INTO `dg_counties` VALUES (33, 'Cumberland', 'CUL', 'England');
INSERT INTO `dg_counties` VALUES (34, 'Clwyd', 'CWD', 'Wales');
INSERT INTO `dg_counties` VALUES (35, 'Derbyshire', 'DBY', 'England');
INSERT INTO `dg_counties` VALUES (36, 'Denbighshire', 'DEN', 'Wales');
INSERT INTO `dg_counties` VALUES (37, 'Devon', 'DEV', 'England');
INSERT INTO `dg_counties` VALUES (38, 'Dyfed', 'DFD', 'Wales');
INSERT INTO `dg_counties` VALUES (39, 'Dumfries-shire', 'DFS', 'Scotland');
INSERT INTO `dg_counties` VALUES (40, 'Dumfries and Galloway', 'DGY', 'Scotland');
INSERT INTO `dg_counties` VALUES (41, 'Dunbartonshire', 'DNB', 'Scotland');
INSERT INTO `dg_counties` VALUES (42, 'Co. Donegal', 'DON', 'Ireland');
INSERT INTO `dg_counties` VALUES (43, 'Dorset', 'DOR', 'England');
INSERT INTO `dg_counties` VALUES (44, 'Co. Down', 'DOW', 'Northern Ireland');
INSERT INTO `dg_counties` VALUES (45, 'Co. Dublin', 'DUB', 'Ireland');
INSERT INTO `dg_counties` VALUES (46, 'Co. Durham', 'DUR', 'England');
INSERT INTO `dg_counties` VALUES (47, 'East Lothian', 'ELN', 'Scotland');
INSERT INTO `dg_counties` VALUES (48, 'East Riding of Yorkshire', 'ERY', 'England');
INSERT INTO `dg_counties` VALUES (49, 'Essex', 'ESS', 'England');
INSERT INTO `dg_counties` VALUES (50, 'Co. Fermanagh', 'FER', 'Northern Ireland');
INSERT INTO `dg_counties` VALUES (51, 'Fife', 'FIF', 'Scotland');
INSERT INTO `dg_counties` VALUES (52, 'Flintshire', 'FLN', 'Wales');
INSERT INTO `dg_counties` VALUES (53, 'Co. Galway', 'GAL', 'Ireland');
INSERT INTO `dg_counties` VALUES (54, 'Glamorgan', 'GLA', 'Wales');
INSERT INTO `dg_counties` VALUES (55, 'Gloucestershire', 'GLS', 'England');
INSERT INTO `dg_counties` VALUES (56, 'Grampian', 'GMP', 'Scotland');
INSERT INTO `dg_counties` VALUES (57, 'Gwent', 'GNT', 'Wales');
INSERT INTO `dg_counties` VALUES (58, 'Guernsey', 'GSY', 'Channel Islands');
INSERT INTO `dg_counties` VALUES (59, 'Greater Manchester', 'GTM', 'England');
INSERT INTO `dg_counties` VALUES (60, 'Gwynedd', 'GWN', 'Wales');
INSERT INTO `dg_counties` VALUES (61, 'Hampshire', 'HAM', 'England');
INSERT INTO `dg_counties` VALUES (62, 'Herefordshire', 'HEF', 'England');
INSERT INTO `dg_counties` VALUES (63, 'Highland', 'HLD', 'Scotland');
INSERT INTO `dg_counties` VALUES (64, 'Hertfordshire', 'HRT', 'England');
INSERT INTO `dg_counties` VALUES (65, 'Humberside', 'HUM', 'England');
INSERT INTO `dg_counties` VALUES (66, 'Huntingdonshire', 'HUN', 'England');
INSERT INTO `dg_counties` VALUES (67, 'Hereford and Worcester', 'HWR', 'England');
INSERT INTO `dg_counties` VALUES (68, 'Inverness-shire', 'INV', 'Scotland');
INSERT INTO `dg_counties` VALUES (69, 'Isle of Wight', 'IOW', 'England');
INSERT INTO `dg_counties` VALUES (70, 'Jersey', 'JSY', 'Channel Islands');
INSERT INTO `dg_counties` VALUES (71, 'Kincardineshire', 'KCD', 'Scotland');
INSERT INTO `dg_counties` VALUES (72, 'Kent', 'KEN', 'England');
INSERT INTO `dg_counties` VALUES (73, 'Co. Kerry', 'KER', 'Ireland');
INSERT INTO `dg_counties` VALUES (74, 'Co. Kildare', 'KID', 'Ireland');
INSERT INTO `dg_counties` VALUES (75, 'Co. Kilkenny', 'KIK', 'Ireland');
INSERT INTO `dg_counties` VALUES (76, 'Kirkcudbrightshire', 'KKD', 'Scotland');
INSERT INTO `dg_counties` VALUES (77, 'Kinross-shire', 'KRS', 'Scotland');
INSERT INTO `dg_counties` VALUES (78, 'Lancashire', 'LAN', 'England');
INSERT INTO `dg_counties` VALUES (79, 'Co. Londonderry', 'LDY', 'Northern Ireland');
INSERT INTO `dg_counties` VALUES (80, 'Leicestershire', 'LEI', 'England');
INSERT INTO `dg_counties` VALUES (81, 'Co. Leitrim', 'LET', 'Ireland');
INSERT INTO `dg_counties` VALUES (82, 'Co. Laois', 'LEX', 'Ireland');
INSERT INTO `dg_counties` VALUES (83, 'Co. Limerick', 'LIM', 'Ireland');
INSERT INTO `dg_counties` VALUES (84, 'Lincolnshire', 'LIN', 'England');
INSERT INTO `dg_counties` VALUES (85, 'Lanarkshire', 'LKS', 'Scotland');
INSERT INTO `dg_counties` VALUES (86, 'London', 'LND', 'England');
INSERT INTO `dg_counties` VALUES (87, 'Co. Longford', 'LOG', 'Ireland');
INSERT INTO `dg_counties` VALUES (88, 'Co. Louth', 'LOU', 'Ireland');
INSERT INTO `dg_counties` VALUES (89, 'Lothian', 'LTN', 'Scotland');
INSERT INTO `dg_counties` VALUES (90, 'Co. Mayo', 'MAY', 'Ireland');
INSERT INTO `dg_counties` VALUES (91, 'Middlesex', 'MDX', 'England');
INSERT INTO `dg_counties` VALUES (92, 'Co. Meath', 'MEA', 'Ireland');
INSERT INTO `dg_counties` VALUES (93, 'Merionethshire', 'MER', 'Wales');
INSERT INTO `dg_counties` VALUES (94, 'Mid Glamorgan', 'MGM', 'Wales');
INSERT INTO `dg_counties` VALUES (95, 'Montgomeryshire', 'MGY', 'Wales');
INSERT INTO `dg_counties` VALUES (96, 'Midlothian', 'MLN', 'Scotland');
INSERT INTO `dg_counties` VALUES (97, 'Co. Monaghan', 'MOG', 'Ireland');
INSERT INTO `dg_counties` VALUES (98, 'Monmouthshire', 'MON', 'Wales');
INSERT INTO `dg_counties` VALUES (99, 'Morayshire', 'MOR', 'Scotland');
INSERT INTO `dg_counties` VALUES (100, 'Merseyside', 'MSY', 'England');
INSERT INTO `dg_counties` VALUES (101, 'Nairn', 'NAI', 'Scotland');
INSERT INTO `dg_counties` VALUES (102, 'Northumberland', 'NBL', 'England');
INSERT INTO `dg_counties` VALUES (103, 'Norfolk', 'NFK', 'England');
INSERT INTO `dg_counties` VALUES (104, 'North Riding of Yorkshire', 'NRY', 'England');
INSERT INTO `dg_counties` VALUES (105, 'Northamptonshire', 'NTH', 'England');
INSERT INTO `dg_counties` VALUES (106, 'Nottinghamshire', 'NTT', 'England');
INSERT INTO `dg_counties` VALUES (107, 'North Yorkshire', 'NYK', 'England');
INSERT INTO `dg_counties` VALUES (108, 'Co. Offaly', 'OFF', 'Ireland');
INSERT INTO `dg_counties` VALUES (109, 'Orkney', 'OKI', 'Scotland');
INSERT INTO `dg_counties` VALUES (110, 'Oxfordshire', 'OXF', 'England');
INSERT INTO `dg_counties` VALUES (111, 'Peebles-shire', 'PEE', 'Scotland');
INSERT INTO `dg_counties` VALUES (112, 'Pembrokeshire', 'PEM', 'Wales');
INSERT INTO `dg_counties` VALUES (113, 'Perth', 'PER', 'Scotland');
INSERT INTO `dg_counties` VALUES (114, 'Powys', 'POW', 'Wales');
INSERT INTO `dg_counties` VALUES (115, 'Radnorshire', 'RAD', 'Wales');
INSERT INTO `dg_counties` VALUES (116, 'Renfrewshire', 'RFW', 'Scotland');
INSERT INTO `dg_counties` VALUES (117, 'Ross and Cromarty', 'ROC', 'Scotland');
INSERT INTO `dg_counties` VALUES (118, 'Co. Roscommon', 'ROS', 'Ireland');
INSERT INTO `dg_counties` VALUES (119, 'Roxburghshire', 'ROX', 'Scotland');
INSERT INTO `dg_counties` VALUES (120, 'Rutland', 'RUT', 'England');
INSERT INTO `dg_counties` VALUES (121, 'Shropshire', 'SAL', 'England');
INSERT INTO `dg_counties` VALUES (122, 'Selkirkshire', 'SEL', 'Scotland');
INSERT INTO `dg_counties` VALUES (123, 'Suffolk', 'SFK', 'England');
INSERT INTO `dg_counties` VALUES (124, 'South Glamorgan', 'SGM', 'Wales');
INSERT INTO `dg_counties` VALUES (125, 'Shetland', 'SHI', 'Scotland');
INSERT INTO `dg_counties` VALUES (126, 'Co. Sligo', 'SLI', 'Ireland');
INSERT INTO `dg_counties` VALUES (127, 'Somerset', 'SOM', 'England');
INSERT INTO `dg_counties` VALUES (128, 'Sark', 'SRK', 'Channel Islands');
INSERT INTO `dg_counties` VALUES (129, 'Surrey', 'SRY', 'England');
INSERT INTO `dg_counties` VALUES (130, 'Sussex', 'SSX', 'England');
INSERT INTO `dg_counties` VALUES (131, 'Strathclyde', 'STD', 'Scotland');
INSERT INTO `dg_counties` VALUES (132, 'Stirlingshire', 'STI', 'Scotland');
INSERT INTO `dg_counties` VALUES (133, 'Staffordshire', 'STS', 'England');
INSERT INTO `dg_counties` VALUES (134, 'Sutherland', 'SUT', 'Scotland');
INSERT INTO `dg_counties` VALUES (135, 'East Sussex', 'SXE', 'England');
INSERT INTO `dg_counties` VALUES (136, 'West Sussex', 'SXW', 'England');
INSERT INTO `dg_counties` VALUES (137, 'South Yorkshire', 'SYK', 'England');
INSERT INTO `dg_counties` VALUES (138, 'Tayside', 'TAY', 'Scotland');
INSERT INTO `dg_counties` VALUES (139, 'Co. Tipperary', 'TIP', 'Ireland');
INSERT INTO `dg_counties` VALUES (140, 'Tyne and Wear', 'TWR', 'England');
INSERT INTO `dg_counties` VALUES (141, 'Co. Tyrone', 'TYR', 'Northern Ireland');
INSERT INTO `dg_counties` VALUES (142, 'Warwickshire', 'WAR', 'England');
INSERT INTO `dg_counties` VALUES (143, 'Co. Waterford', 'WAT', 'Ireland');
INSERT INTO `dg_counties` VALUES (144, 'Co. Westmeath', 'WEM', 'Ireland');
INSERT INTO `dg_counties` VALUES (145, 'Westmorland', 'WES', 'England');
INSERT INTO `dg_counties` VALUES (146, 'Co. Wexford', 'WEX', 'Ireland');
INSERT INTO `dg_counties` VALUES (147, 'West Glamorgan', 'WGM', 'Wales');
INSERT INTO `dg_counties` VALUES (148, 'Co. Wicklow', 'WIC', 'Ireland');
INSERT INTO `dg_counties` VALUES (149, 'Wigtownshire', 'WIG', 'Scotland');
INSERT INTO `dg_counties` VALUES (150, 'Wiltshire', 'WIL', 'England');
INSERT INTO `dg_counties` VALUES (151, 'Western Isles', 'WIS', 'Scotland');
INSERT INTO `dg_counties` VALUES (152, 'West Lothian', 'WLN', 'Scotland');
INSERT INTO `dg_counties` VALUES (153, 'West Midlands', 'WMD', 'England');
INSERT INTO `dg_counties` VALUES (154, 'Worcestershire', 'WOR', 'England');
INSERT INTO `dg_counties` VALUES (155, 'West Riding of Yorkshire', 'WRY', 'England');
INSERT INTO `dg_counties` VALUES (156, 'West Yorkshire', 'WYK', 'England');
INSERT INTO `dg_counties` VALUES (157, 'Yorkshire', 'YKS', 'England');


-- 
-- table `dg_countries`
-- 

CREATE TABLE `dg_countries` (
  `id` mediumint(9) NOT NULL auto_increment,
  `country` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=237 ;

INSERT INTO `dg_countries` VALUES (1, 'Afghanistan');
INSERT INTO `dg_countries` VALUES (2, 'Albania');
INSERT INTO `dg_countries` VALUES (3, 'Algeria');
INSERT INTO `dg_countries` VALUES (4, 'American Samoa');
INSERT INTO `dg_countries` VALUES (5, 'Andorra');
INSERT INTO `dg_countries` VALUES (6, 'Angola');
INSERT INTO `dg_countries` VALUES (7, 'Anguilla');
INSERT INTO `dg_countries` VALUES (8, 'Antarctica');
INSERT INTO `dg_countries` VALUES (9, 'Antigua and Barbuda');
INSERT INTO `dg_countries` VALUES (10, 'Argentina');
INSERT INTO `dg_countries` VALUES (11, 'Armenia');
INSERT INTO `dg_countries` VALUES (12, 'Aruba');
INSERT INTO `dg_countries` VALUES (13, 'Australia');
INSERT INTO `dg_countries` VALUES (14, 'Austria');
INSERT INTO `dg_countries` VALUES (15, 'Azerbaijan');
INSERT INTO `dg_countries` VALUES (16, 'Bahamas');
INSERT INTO `dg_countries` VALUES (17, 'Bahrain');
INSERT INTO `dg_countries` VALUES (18, 'Bangladesh');
INSERT INTO `dg_countries` VALUES (19, 'Barbados');
INSERT INTO `dg_countries` VALUES (20, 'Belarus');
INSERT INTO `dg_countries` VALUES (21, 'Belgium');
INSERT INTO `dg_countries` VALUES (22, 'Belize');
INSERT INTO `dg_countries` VALUES (23, 'Benin');
INSERT INTO `dg_countries` VALUES (24, 'Bermuda');
INSERT INTO `dg_countries` VALUES (25, 'Bhutan');
INSERT INTO `dg_countries` VALUES (26, 'Bolivia');
INSERT INTO `dg_countries` VALUES (27, 'Bosnia and Herzegovina');
INSERT INTO `dg_countries` VALUES (28, 'Botswana');
INSERT INTO `dg_countries` VALUES (29, 'Bouvet Island');
INSERT INTO `dg_countries` VALUES (30, 'Brazil');
INSERT INTO `dg_countries` VALUES (31, 'British Indian Ocean Territory');
INSERT INTO `dg_countries` VALUES (32, 'Brunei Darussalam');
INSERT INTO `dg_countries` VALUES (33, 'Bulgaria');
INSERT INTO `dg_countries` VALUES (34, 'Burkina Faso');
INSERT INTO `dg_countries` VALUES (35, 'Burundi');
INSERT INTO `dg_countries` VALUES (36, 'Cambodia');
INSERT INTO `dg_countries` VALUES (37, 'Cameroon');
INSERT INTO `dg_countries` VALUES (38, 'Canada');
INSERT INTO `dg_countries` VALUES (39, 'Cape Verde');
INSERT INTO `dg_countries` VALUES (40, 'Cayman Islands');
INSERT INTO `dg_countries` VALUES (41, 'Central African Republic');
INSERT INTO `dg_countries` VALUES (42, 'Chad');
INSERT INTO `dg_countries` VALUES (43, 'Chile');
INSERT INTO `dg_countries` VALUES (44, 'China');
INSERT INTO `dg_countries` VALUES (45, 'Christmas Island');
INSERT INTO `dg_countries` VALUES (46, 'Cocos (Keeling) Islands');
INSERT INTO `dg_countries` VALUES (47, 'Colombia');
INSERT INTO `dg_countries` VALUES (48, 'Comoros');
INSERT INTO `dg_countries` VALUES (49, 'Congo');
INSERT INTO `dg_countries` VALUES (50, 'Cook Islands');
INSERT INTO `dg_countries` VALUES (51, 'Costa Rica');
INSERT INTO `dg_countries` VALUES (52, 'Croatia');
INSERT INTO `dg_countries` VALUES (53, 'Cuba');
INSERT INTO `dg_countries` VALUES (54, 'Cyprus');
INSERT INTO `dg_countries` VALUES (55, 'Czech Republic');
INSERT INTO `dg_countries` VALUES (56, 'Denmark');
INSERT INTO `dg_countries` VALUES (57, 'Djibouti');
INSERT INTO `dg_countries` VALUES (58, 'Dominica');
INSERT INTO `dg_countries` VALUES (59, 'Dominican Republic');
INSERT INTO `dg_countries` VALUES (60, 'Ecuador');
INSERT INTO `dg_countries` VALUES (61, 'Egypt');
INSERT INTO `dg_countries` VALUES (62, 'El Salvador');
INSERT INTO `dg_countries` VALUES (63, 'Equatorial Guinea');
INSERT INTO `dg_countries` VALUES (64, 'Eritrea');
INSERT INTO `dg_countries` VALUES (65, 'Estonia');
INSERT INTO `dg_countries` VALUES (66, 'Ethiopia');
INSERT INTO `dg_countries` VALUES (67, 'Falkland Islands (Malvinas)');
INSERT INTO `dg_countries` VALUES (68, 'Faroe Islands');
INSERT INTO `dg_countries` VALUES (69, 'Fiji');
INSERT INTO `dg_countries` VALUES (70, 'Finland');
INSERT INTO `dg_countries` VALUES (71, 'France');
INSERT INTO `dg_countries` VALUES (72, 'French Guiana');
INSERT INTO `dg_countries` VALUES (73, 'French Polynesia');
INSERT INTO `dg_countries` VALUES (74, 'French Southern Territories');
INSERT INTO `dg_countries` VALUES (75, 'Gabon');
INSERT INTO `dg_countries` VALUES (76, 'Gambia');
INSERT INTO `dg_countries` VALUES (77, 'Georgia');
INSERT INTO `dg_countries` VALUES (78, 'Germany');
INSERT INTO `dg_countries` VALUES (79, 'Ghana');
INSERT INTO `dg_countries` VALUES (80, 'Gibraltar');
INSERT INTO `dg_countries` VALUES (81, 'Greece');
INSERT INTO `dg_countries` VALUES (82, 'Greenland');
INSERT INTO `dg_countries` VALUES (83, 'Grenada');
INSERT INTO `dg_countries` VALUES (84, 'Guadeloupe');
INSERT INTO `dg_countries` VALUES (85, 'Guam');
INSERT INTO `dg_countries` VALUES (86, 'Guatemala');
INSERT INTO `dg_countries` VALUES (87, 'Guinea');
INSERT INTO `dg_countries` VALUES (88, 'Guinea-bissau');
INSERT INTO `dg_countries` VALUES (89, 'Guyana');
INSERT INTO `dg_countries` VALUES (90, 'Haiti');
INSERT INTO `dg_countries` VALUES (91, 'Heard Island and Mcdonald Islands');
INSERT INTO `dg_countries` VALUES (92, 'Holy See (Vatican City State)');
INSERT INTO `dg_countries` VALUES (93, 'Honduras');
INSERT INTO `dg_countries` VALUES (94, 'Hong Kong');
INSERT INTO `dg_countries` VALUES (95, 'Hungary');
INSERT INTO `dg_countries` VALUES (96, 'Iceland');
INSERT INTO `dg_countries` VALUES (97, 'India');
INSERT INTO `dg_countries` VALUES (98, 'Indonesia');
INSERT INTO `dg_countries` VALUES (99, 'Iran, Islamic Republic of');
INSERT INTO `dg_countries` VALUES (100, 'Iraq');
INSERT INTO `dg_countries` VALUES (101, 'Ireland');
INSERT INTO `dg_countries` VALUES (102, 'Israel');
INSERT INTO `dg_countries` VALUES (103, 'Italy');
INSERT INTO `dg_countries` VALUES (104, 'Jamaica');
INSERT INTO `dg_countries` VALUES (105, 'Japan');
INSERT INTO `dg_countries` VALUES (106, 'Jordan');
INSERT INTO `dg_countries` VALUES (107, 'Kazakhstan');
INSERT INTO `dg_countries` VALUES (108, 'Kenya');
INSERT INTO `dg_countries` VALUES (109, 'Kiribati');
INSERT INTO `dg_countries` VALUES (110, 'Korea');
INSERT INTO `dg_countries` VALUES (111, 'Korea, Republic of');
INSERT INTO `dg_countries` VALUES (112, 'Kuwait');
INSERT INTO `dg_countries` VALUES (113, 'Kyrgyzstan');
INSERT INTO `dg_countries` VALUES (114, 'Latvia');
INSERT INTO `dg_countries` VALUES (115, 'Lebanon');
INSERT INTO `dg_countries` VALUES (116, 'Lesotho');
INSERT INTO `dg_countries` VALUES (117, 'Liberia');
INSERT INTO `dg_countries` VALUES (118, 'Libyan Arab Jamahiriya');
INSERT INTO `dg_countries` VALUES (119, 'Liechtenstein');
INSERT INTO `dg_countries` VALUES (120, 'Lithuania');
INSERT INTO `dg_countries` VALUES (121, 'Luxembourg');
INSERT INTO `dg_countries` VALUES (122, 'Macao');
INSERT INTO `dg_countries` VALUES (123, 'Macedonia');
INSERT INTO `dg_countries` VALUES (124, 'Madagascar');
INSERT INTO `dg_countries` VALUES (125, 'Malawi');
INSERT INTO `dg_countries` VALUES (126, 'Malaysia');
INSERT INTO `dg_countries` VALUES (127, 'Maldives');
INSERT INTO `dg_countries` VALUES (128, 'Mali');
INSERT INTO `dg_countries` VALUES (129, 'Malta');
INSERT INTO `dg_countries` VALUES (130, 'Marshall Islands');
INSERT INTO `dg_countries` VALUES (131, 'Martinique');
INSERT INTO `dg_countries` VALUES (132, 'Mauritania');
INSERT INTO `dg_countries` VALUES (133, 'Mauritius');
INSERT INTO `dg_countries` VALUES (134, 'Mayotte');
INSERT INTO `dg_countries` VALUES (135, 'Mexico');
INSERT INTO `dg_countries` VALUES (136, 'Micronesia');
INSERT INTO `dg_countries` VALUES (137, 'Moldova');
INSERT INTO `dg_countries` VALUES (138, 'Monaco');
INSERT INTO `dg_countries` VALUES (139, 'Mongolia');
INSERT INTO `dg_countries` VALUES (140, 'Montserrat');
INSERT INTO `dg_countries` VALUES (141, 'Morocco');
INSERT INTO `dg_countries` VALUES (142, 'Mozambique');
INSERT INTO `dg_countries` VALUES (143, 'Myanmar');
INSERT INTO `dg_countries` VALUES (144, 'Namibia');
INSERT INTO `dg_countries` VALUES (145, 'Nauru');
INSERT INTO `dg_countries` VALUES (146, 'Nepal');
INSERT INTO `dg_countries` VALUES (147, 'Netherlands');
INSERT INTO `dg_countries` VALUES (148, 'Netherlands Antilles');
INSERT INTO `dg_countries` VALUES (149, 'New Caledonia');
INSERT INTO `dg_countries` VALUES (150, 'New Zealand');
INSERT INTO `dg_countries` VALUES (151, 'Nicaragua');
INSERT INTO `dg_countries` VALUES (152, 'Niger');
INSERT INTO `dg_countries` VALUES (153, 'Nigeria');
INSERT INTO `dg_countries` VALUES (154, 'Niue');
INSERT INTO `dg_countries` VALUES (155, 'Norfolk Island');
INSERT INTO `dg_countries` VALUES (156, 'Northern Mariana Islands');
INSERT INTO `dg_countries` VALUES (157, 'Norway');
INSERT INTO `dg_countries` VALUES (158, 'Oman');
INSERT INTO `dg_countries` VALUES (159, 'Pakistan');
INSERT INTO `dg_countries` VALUES (160, 'Palau');
INSERT INTO `dg_countries` VALUES (161, 'Palestinian Territory, Occupied');
INSERT INTO `dg_countries` VALUES (162, 'Panama');
INSERT INTO `dg_countries` VALUES (163, 'Papua New Guinea');
INSERT INTO `dg_countries` VALUES (164, 'Paraguay');
INSERT INTO `dg_countries` VALUES (165, 'Peru');
INSERT INTO `dg_countries` VALUES (166, 'Philippines');
INSERT INTO `dg_countries` VALUES (167, 'Pitcairn');
INSERT INTO `dg_countries` VALUES (168, 'Poland');
INSERT INTO `dg_countries` VALUES (169, 'Portugal');
INSERT INTO `dg_countries` VALUES (170, 'Puerto Rico');
INSERT INTO `dg_countries` VALUES (171, 'Qatar');
INSERT INTO `dg_countries` VALUES (172, 'Reunion');
INSERT INTO `dg_countries` VALUES (173, 'Romania');
INSERT INTO `dg_countries` VALUES (174, 'Russian Federation');
INSERT INTO `dg_countries` VALUES (175, 'Rwanda');
INSERT INTO `dg_countries` VALUES (176, 'Saint Helena');
INSERT INTO `dg_countries` VALUES (177, 'Saint Kitts and Nevis');
INSERT INTO `dg_countries` VALUES (178, 'Saint Lucia');
INSERT INTO `dg_countries` VALUES (179, 'Saint Pierre and Miquelon');
INSERT INTO `dg_countries` VALUES (180, 'Saint Vincent and The Grenadines');
INSERT INTO `dg_countries` VALUES (181, 'Samoa');
INSERT INTO `dg_countries` VALUES (182, 'San Marino');
INSERT INTO `dg_countries` VALUES (183, 'Sao Tome and Principe');
INSERT INTO `dg_countries` VALUES (184, 'Saudi Arabia');
INSERT INTO `dg_countries` VALUES (185, 'Senegal');
INSERT INTO `dg_countries` VALUES (186, 'Serbia and Montenegro');
INSERT INTO `dg_countries` VALUES (187, 'Seychelles');
INSERT INTO `dg_countries` VALUES (188, 'Sierra Leone');
INSERT INTO `dg_countries` VALUES (189, 'Singapore');
INSERT INTO `dg_countries` VALUES (190, 'Slovakia');
INSERT INTO `dg_countries` VALUES (191, 'Slovenia');
INSERT INTO `dg_countries` VALUES (192, 'Solomon Islands');
INSERT INTO `dg_countries` VALUES (193, 'Somalia');
INSERT INTO `dg_countries` VALUES (194, 'South Africa');
INSERT INTO `dg_countries` VALUES (195, 'South Georgia and The South Sandwich Islands');
INSERT INTO `dg_countries` VALUES (196, 'Spain');
INSERT INTO `dg_countries` VALUES (197, 'Sri Lanka');
INSERT INTO `dg_countries` VALUES (198, 'Sudan');
INSERT INTO `dg_countries` VALUES (199, 'Suriname');
INSERT INTO `dg_countries` VALUES (200, 'Svalbard and Jan Mayen');
INSERT INTO `dg_countries` VALUES (201, 'Swaziland');
INSERT INTO `dg_countries` VALUES (202, 'Sweden');
INSERT INTO `dg_countries` VALUES (203, 'Switzerland');
INSERT INTO `dg_countries` VALUES (204, 'Syrian Arab Republic');
INSERT INTO `dg_countries` VALUES (205, 'Taiwan, Province of China');
INSERT INTO `dg_countries` VALUES (206, 'Tajikistan');
INSERT INTO `dg_countries` VALUES (207, 'Tanzania, United Republic of');
INSERT INTO `dg_countries` VALUES (208, 'Thailand');
INSERT INTO `dg_countries` VALUES (209, 'Timor-leste');
INSERT INTO `dg_countries` VALUES (210, 'Togo');
INSERT INTO `dg_countries` VALUES (211, 'Tokelau');
INSERT INTO `dg_countries` VALUES (212, 'Tonga');
INSERT INTO `dg_countries` VALUES (213, 'Trinidad and Tobago');
INSERT INTO `dg_countries` VALUES (214, 'Tunisia');
INSERT INTO `dg_countries` VALUES (215, 'Turkey');
INSERT INTO `dg_countries` VALUES (216, 'Turkmenistan');
INSERT INTO `dg_countries` VALUES (217, 'Turks and Caicos Islands');
INSERT INTO `dg_countries` VALUES (218, 'Tuvalu');
INSERT INTO `dg_countries` VALUES (219, 'Uganda');
INSERT INTO `dg_countries` VALUES (220, 'Ukraine');
INSERT INTO `dg_countries` VALUES (221, 'United Arab Emirates');
INSERT INTO `dg_countries` VALUES (222, 'United Kingdom');
INSERT INTO `dg_countries` VALUES (223, 'United States');
INSERT INTO `dg_countries` VALUES (224, 'United States Minor Outlying Islands');
INSERT INTO `dg_countries` VALUES (225, 'Uruguay');
INSERT INTO `dg_countries` VALUES (226, 'Uzbekistan');
INSERT INTO `dg_countries` VALUES (227, 'Vanuatu');
INSERT INTO `dg_countries` VALUES (228, 'Venezuela');
INSERT INTO `dg_countries` VALUES (229, 'Viet Nam');
INSERT INTO `dg_countries` VALUES (230, 'Virgin Islands, British');
INSERT INTO `dg_countries` VALUES (231, 'Virgin Islands, U.S.');
INSERT INTO `dg_countries` VALUES (232, 'Wallis and Futuna');
INSERT INTO `dg_countries` VALUES (233, 'Western Sahara');
INSERT INTO `dg_countries` VALUES (234, 'Yemen');
INSERT INTO `dg_countries` VALUES (235, 'Zambia');
INSERT INTO `dg_countries` VALUES (236, 'Zimbabwe');


-- 
-- table `dg_first_names`
-- 

CREATE TABLE `dg_first_names` (
  `id` mediumint(9) NOT NULL auto_increment,
  `first_name` varchar(50) NOT NULL default '',
  `gender` enum('male','female','both') NOT NULL default 'male',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1173 ;


INSERT INTO `dg_first_names` VALUES (1, 'Aaron', 'male');
INSERT INTO `dg_first_names` VALUES (2, 'Abbot', 'male');
INSERT INTO `dg_first_names` VALUES (3, 'Abdul', 'male');
INSERT INTO `dg_first_names` VALUES (4, 'Abel', 'male');
INSERT INTO `dg_first_names` VALUES (5, 'Abigail', 'female');
INSERT INTO `dg_first_names` VALUES (6, 'Abra', 'female');
INSERT INTO `dg_first_names` VALUES (7, 'Abraham', 'male');
INSERT INTO `dg_first_names` VALUES (8, 'Acton', 'male');
INSERT INTO `dg_first_names` VALUES (9, 'Adam', 'male');
INSERT INTO `dg_first_names` VALUES (10, 'Adara', 'female');
INSERT INTO `dg_first_names` VALUES (11, 'Addison', 'male');
INSERT INTO `dg_first_names` VALUES (12, 'Adele', 'female');
INSERT INTO `dg_first_names` VALUES (13, 'Adena', 'female');
INSERT INTO `dg_first_names` VALUES (14, 'Adria', 'female');
INSERT INTO `dg_first_names` VALUES (15, 'Adrian', 'male');
INSERT INTO `dg_first_names` VALUES (16, 'Adrienne', 'female');
INSERT INTO `dg_first_names` VALUES (17, 'Ahmed', 'male');
INSERT INTO `dg_first_names` VALUES (18, 'Aidan', 'male');
INSERT INTO `dg_first_names` VALUES (19, 'Aiko', 'female');
INSERT INTO `dg_first_names` VALUES (20, 'Aileen', 'female');
INSERT INTO `dg_first_names` VALUES (21, 'Aimee', 'female');
INSERT INTO `dg_first_names` VALUES (22, 'Ainsley', 'female');
INSERT INTO `dg_first_names` VALUES (23, 'Akeem', 'male');
INSERT INTO `dg_first_names` VALUES (24, 'Aladdin', 'male');
INSERT INTO `dg_first_names` VALUES (25, 'Alan', 'male');
INSERT INTO `dg_first_names` VALUES (26, 'Alana', 'female');
INSERT INTO `dg_first_names` VALUES (27, 'Alden', 'male');
INSERT INTO `dg_first_names` VALUES (28, 'Alea', 'female');
INSERT INTO `dg_first_names` VALUES (29, 'Alec', 'male');
INSERT INTO `dg_first_names` VALUES (30, 'Alexa', 'female');
INSERT INTO `dg_first_names` VALUES (31, 'Alexander', 'male');
INSERT INTO `dg_first_names` VALUES (32, 'Alexandra', 'female');
INSERT INTO `dg_first_names` VALUES (33, 'Alexis', 'female');
INSERT INTO `dg_first_names` VALUES (34, 'Alfonso', 'male');
INSERT INTO `dg_first_names` VALUES (35, 'Alfreda', 'female');
INSERT INTO `dg_first_names` VALUES (36, 'Ali', 'male');
INSERT INTO `dg_first_names` VALUES (37, 'Alice', 'female');
INSERT INTO `dg_first_names` VALUES (38, 'Alika', 'female');
INSERT INTO `dg_first_names` VALUES (39, 'Aline', 'female');
INSERT INTO `dg_first_names` VALUES (40, 'Alisa', 'female');
INSERT INTO `dg_first_names` VALUES (41, 'Allegra', 'female');
INSERT INTO `dg_first_names` VALUES (42, 'Allen', 'male');
INSERT INTO `dg_first_names` VALUES (43, 'Allistair', 'male');
INSERT INTO `dg_first_names` VALUES (44, 'Alma', 'female');
INSERT INTO `dg_first_names` VALUES (45, 'Althea', 'female');
INSERT INTO `dg_first_names` VALUES (46, 'Alvin', 'male');
INSERT INTO `dg_first_names` VALUES (47, 'Alyssa', 'female');
INSERT INTO `dg_first_names` VALUES (48, 'Amal', 'male');
INSERT INTO `dg_first_names` VALUES (49, 'Amanda', 'female');
INSERT INTO `dg_first_names` VALUES (50, 'Amaya', 'female');
INSERT INTO `dg_first_names` VALUES (51, 'Amber', 'female');
INSERT INTO `dg_first_names` VALUES (52, 'Amela', 'female');
INSERT INTO `dg_first_names` VALUES (53, 'Amelia', 'female');
INSERT INTO `dg_first_names` VALUES (54, 'Amena', 'female');
INSERT INTO `dg_first_names` VALUES (55, 'Amery', 'male');
INSERT INTO `dg_first_names` VALUES (56, 'Amethyst', 'female');
INSERT INTO `dg_first_names` VALUES (57, 'Amir', 'male');
INSERT INTO `dg_first_names` VALUES (58, 'Amity', 'female');
INSERT INTO `dg_first_names` VALUES (59, 'Amos', 'male');
INSERT INTO `dg_first_names` VALUES (60, 'Amy', 'female');
INSERT INTO `dg_first_names` VALUES (61, 'Anastasia', 'female');
INSERT INTO `dg_first_names` VALUES (62, 'Andrew', 'male');
INSERT INTO `dg_first_names` VALUES (63, 'Angela', 'female');
INSERT INTO `dg_first_names` VALUES (64, 'Angelica', 'female');
INSERT INTO `dg_first_names` VALUES (65, 'Anika', 'female');
INSERT INTO `dg_first_names` VALUES (66, 'Anjolie', 'female');
INSERT INTO `dg_first_names` VALUES (67, 'Ann', 'female');
INSERT INTO `dg_first_names` VALUES (68, 'Anne', 'female');
INSERT INTO `dg_first_names` VALUES (69, 'Anthony', 'male');
INSERT INTO `dg_first_names` VALUES (70, 'Aphrodite', 'female');
INSERT INTO `dg_first_names` VALUES (71, 'April', 'female');
INSERT INTO `dg_first_names` VALUES (72, 'Aquila', 'male');
INSERT INTO `dg_first_names` VALUES (73, 'Arden', 'male');
INSERT INTO `dg_first_names` VALUES (74, 'Aretha', 'female');
INSERT INTO `dg_first_names` VALUES (75, 'Ariana', 'female');
INSERT INTO `dg_first_names` VALUES (76, 'Ariel', 'female');
INSERT INTO `dg_first_names` VALUES (77, 'Aristotle', 'male');
INSERT INTO `dg_first_names` VALUES (78, 'Armand', 'male');
INSERT INTO `dg_first_names` VALUES (79, 'Armando', 'male');
INSERT INTO `dg_first_names` VALUES (80, 'Arsenio', 'male');
INSERT INTO `dg_first_names` VALUES (81, 'Arthur', 'male');
INSERT INTO `dg_first_names` VALUES (82, 'Ashely\n', 'female');
INSERT INTO `dg_first_names` VALUES (83, 'Asher', 'male');
INSERT INTO `dg_first_names` VALUES (84, 'Ashton', 'male');
INSERT INTO `dg_first_names` VALUES (85, 'Aspen', 'female');
INSERT INTO `dg_first_names` VALUES (86, 'Astra', 'female');
INSERT INTO `dg_first_names` VALUES (87, 'Athena', 'female');
INSERT INTO `dg_first_names` VALUES (88, 'Aubrey', 'both');
INSERT INTO `dg_first_names` VALUES (89, 'Audra', 'female');
INSERT INTO `dg_first_names` VALUES (90, 'Audrey', 'female');
INSERT INTO `dg_first_names` VALUES (91, 'August', 'male');
INSERT INTO `dg_first_names` VALUES (92, 'Aurelia', 'female');
INSERT INTO `dg_first_names` VALUES (93, 'Aurora', 'female');
INSERT INTO `dg_first_names` VALUES (94, 'Austin', 'male');
INSERT INTO `dg_first_names` VALUES (95, 'Autumn', 'female');
INSERT INTO `dg_first_names` VALUES (96, 'Ava', 'female');
INSERT INTO `dg_first_names` VALUES (97, 'Avram', 'male');
INSERT INTO `dg_first_names` VALUES (98, 'Avye', 'female');
INSERT INTO `dg_first_names` VALUES (99, 'Axel', 'male');
INSERT INTO `dg_first_names` VALUES (100, 'Ayanna', 'female');
INSERT INTO `dg_first_names` VALUES (101, 'Azalia', 'female');
INSERT INTO `dg_first_names` VALUES (102, 'Baker', 'male');
INSERT INTO `dg_first_names` VALUES (103, 'Barbara', 'female');
INSERT INTO `dg_first_names` VALUES (104, 'Barclay', 'male');
INSERT INTO `dg_first_names` VALUES (105, 'Barrett', 'male');
INSERT INTO `dg_first_names` VALUES (106, 'Barry', 'male');
INSERT INTO `dg_first_names` VALUES (107, 'Basia', 'female');
INSERT INTO `dg_first_names` VALUES (108, 'Basil', 'male');
INSERT INTO `dg_first_names` VALUES (109, 'Baxter', 'male');
INSERT INTO `dg_first_names` VALUES (110, 'Beatrice', 'female');
INSERT INTO `dg_first_names` VALUES (111, 'Beau', 'male');
INSERT INTO `dg_first_names` VALUES (112, 'Beck', 'male');
INSERT INTO `dg_first_names` VALUES (113, 'Bell', 'female');
INSERT INTO `dg_first_names` VALUES (114, 'Belle', 'female');
INSERT INTO `dg_first_names` VALUES (115, 'Benedict', 'male');
INSERT INTO `dg_first_names` VALUES (116, 'Benjamin', 'male');
INSERT INTO `dg_first_names` VALUES (117, 'Berk', 'male');
INSERT INTO `dg_first_names` VALUES (118, 'Bernard', 'male');
INSERT INTO `dg_first_names` VALUES (119, 'Bert', 'male');
INSERT INTO `dg_first_names` VALUES (120, 'Bertha', 'female');
INSERT INTO `dg_first_names` VALUES (121, 'Bethany', 'female');
INSERT INTO `dg_first_names` VALUES (122, 'Beverly', 'female');
INSERT INTO `dg_first_names` VALUES (123, 'Bevis', 'male');
INSERT INTO `dg_first_names` VALUES (124, 'Bianca', 'female');
INSERT INTO `dg_first_names` VALUES (125, 'Blaine', 'both');
INSERT INTO `dg_first_names` VALUES (126, 'Blair', 'both');
INSERT INTO `dg_first_names` VALUES (127, 'Blake', 'male');
INSERT INTO `dg_first_names` VALUES (128, 'Blaze', 'male');
INSERT INTO `dg_first_names` VALUES (129, 'Blossom', 'female');
INSERT INTO `dg_first_names` VALUES (130, 'Blythe', 'female');
INSERT INTO `dg_first_names` VALUES (131, 'Bo', 'female');
INSERT INTO `dg_first_names` VALUES (132, 'Boris', 'male');
INSERT INTO `dg_first_names` VALUES (133, 'Bradley', 'male');
INSERT INTO `dg_first_names` VALUES (134, 'Brady', 'male');
INSERT INTO `dg_first_names` VALUES (135, 'Branden', 'male');
INSERT INTO `dg_first_names` VALUES (136, 'Brandon', 'male');
INSERT INTO `dg_first_names` VALUES (137, 'Breanna', 'female');
INSERT INTO `dg_first_names` VALUES (138, 'Bree', 'female');
INSERT INTO `dg_first_names` VALUES (139, 'Brenda', 'female');
INSERT INTO `dg_first_names` VALUES (140, 'Brendan', 'male');
INSERT INTO `dg_first_names` VALUES (141, 'Brenden', 'male');
INSERT INTO `dg_first_names` VALUES (142, 'Brenna', 'female');
INSERT INTO `dg_first_names` VALUES (143, 'Brennan', 'male');
INSERT INTO `dg_first_names` VALUES (144, 'Brent', 'male');
INSERT INTO `dg_first_names` VALUES (145, 'Brett', 'male');
INSERT INTO `dg_first_names` VALUES (146, 'Brian', 'male');
INSERT INTO `dg_first_names` VALUES (147, 'Brianna', 'female');
INSERT INTO `dg_first_names` VALUES (148, 'Briar', 'female');
INSERT INTO `dg_first_names` VALUES (149, 'Brielle', 'female');
INSERT INTO `dg_first_names` VALUES (150, 'Britanney', 'female');
INSERT INTO `dg_first_names` VALUES (151, 'Britanni', 'female');
INSERT INTO `dg_first_names` VALUES (152, 'Brittany', 'female');
INSERT INTO `dg_first_names` VALUES (153, 'Brock', 'male');
INSERT INTO `dg_first_names` VALUES (154, 'Brody', 'male');
INSERT INTO `dg_first_names` VALUES (155, 'Brooke', 'female');
INSERT INTO `dg_first_names` VALUES (156, 'Bruce', 'male');
INSERT INTO `dg_first_names` VALUES (157, 'Bruno', 'male');
INSERT INTO `dg_first_names` VALUES (158, 'Bryar', 'female');
INSERT INTO `dg_first_names` VALUES (159, 'Brynn', 'female');
INSERT INTO `dg_first_names` VALUES (160, 'Brynne', 'female');
INSERT INTO `dg_first_names` VALUES (161, 'Buckminster', 'male');
INSERT INTO `dg_first_names` VALUES (162, 'Buffy', 'female');
INSERT INTO `dg_first_names` VALUES (163, 'Burke', 'male');
INSERT INTO `dg_first_names` VALUES (164, 'Burton', 'male');
INSERT INTO `dg_first_names` VALUES (165, 'Byron', 'male');
INSERT INTO `dg_first_names` VALUES (166, 'Cade', 'male');
INSERT INTO `dg_first_names` VALUES (167, 'Cadman', 'male');
INSERT INTO `dg_first_names` VALUES (168, 'Caesar', 'male');
INSERT INTO `dg_first_names` VALUES (169, 'Cailin', 'female');
INSERT INTO `dg_first_names` VALUES (170, 'Cain', 'male');
INSERT INTO `dg_first_names` VALUES (171, 'Cairo', 'male');
INSERT INTO `dg_first_names` VALUES (172, 'Caldwell', 'male');
INSERT INTO `dg_first_names` VALUES (173, 'Caleb', 'male');
INSERT INTO `dg_first_names` VALUES (174, 'Calista', 'female');
INSERT INTO `dg_first_names` VALUES (175, 'Callie', 'female');
INSERT INTO `dg_first_names` VALUES (176, 'Callum', 'male');
INSERT INTO `dg_first_names` VALUES (177, 'Cally', 'female');
INSERT INTO `dg_first_names` VALUES (178, 'Calvin', 'male');
INSERT INTO `dg_first_names` VALUES (179, 'Camden', 'male');
INSERT INTO `dg_first_names` VALUES (180, 'Cameran', 'female');
INSERT INTO `dg_first_names` VALUES (181, 'Cameron', 'female');
INSERT INTO `dg_first_names` VALUES (182, 'Cameron', 'male');
INSERT INTO `dg_first_names` VALUES (183, 'Camilla', 'female');
INSERT INTO `dg_first_names` VALUES (184, 'Camille', 'female');
INSERT INTO `dg_first_names` VALUES (185, 'Candace', 'female');
INSERT INTO `dg_first_names` VALUES (186, 'Candice', 'female');
INSERT INTO `dg_first_names` VALUES (187, 'Cara', 'female');
INSERT INTO `dg_first_names` VALUES (188, 'Carissa', 'female');
INSERT INTO `dg_first_names` VALUES (189, 'Carl', 'male');
INSERT INTO `dg_first_names` VALUES (190, 'Carla', 'female');
INSERT INTO `dg_first_names` VALUES (191, 'Carlos', 'male');
INSERT INTO `dg_first_names` VALUES (192, 'Carly', 'female');
INSERT INTO `dg_first_names` VALUES (193, 'Carol', 'female');
INSERT INTO `dg_first_names` VALUES (194, 'Carolyn', 'female');
INSERT INTO `dg_first_names` VALUES (195, 'Carson', 'male');
INSERT INTO `dg_first_names` VALUES (196, 'Carter', 'male');
INSERT INTO `dg_first_names` VALUES (197, 'Caryn', 'female');
INSERT INTO `dg_first_names` VALUES (198, 'Casey', 'both');
INSERT INTO `dg_first_names` VALUES (199, 'Cassady', 'female');
INSERT INTO `dg_first_names` VALUES (200, 'Cassandra', 'female');
INSERT INTO `dg_first_names` VALUES (201, 'Cassidy', 'female');
INSERT INTO `dg_first_names` VALUES (202, 'Castor', 'male');
INSERT INTO `dg_first_names` VALUES (203, 'Catherine', 'female');
INSERT INTO `dg_first_names` VALUES (204, 'Cathleen', 'female');
INSERT INTO `dg_first_names` VALUES (205, 'Cecilia', 'female');
INSERT INTO `dg_first_names` VALUES (206, 'Cedric', 'male');
INSERT INTO `dg_first_names` VALUES (207, 'Celeste', 'female');
INSERT INTO `dg_first_names` VALUES (208, 'Chadwick', 'male');
INSERT INTO `dg_first_names` VALUES (209, 'Chaim', 'male');
INSERT INTO `dg_first_names` VALUES (210, 'Chancellor', 'male');
INSERT INTO `dg_first_names` VALUES (211, 'Chanda', 'female');
INSERT INTO `dg_first_names` VALUES (212, 'Chandler', 'male');
INSERT INTO `dg_first_names` VALUES (213, 'Chaney', 'male');
INSERT INTO `dg_first_names` VALUES (214, 'Channing', 'male');
INSERT INTO `dg_first_names` VALUES (215, 'Chantale', 'female');
INSERT INTO `dg_first_names` VALUES (216, 'Charde', 'female');
INSERT INTO `dg_first_names` VALUES (217, 'Charissa', 'female');
INSERT INTO `dg_first_names` VALUES (218, 'Charity', 'female');
INSERT INTO `dg_first_names` VALUES (219, 'Charles', 'male');
INSERT INTO `dg_first_names` VALUES (220, 'Charlotte', 'female');
INSERT INTO `dg_first_names` VALUES (221, 'Chase', 'male');
INSERT INTO `dg_first_names` VALUES (222, 'Chastity', 'female');
INSERT INTO `dg_first_names` VALUES (223, 'Chava', 'female');
INSERT INTO `dg_first_names` VALUES (224, 'Chelsea', 'female');
INSERT INTO `dg_first_names` VALUES (225, 'Cherokee', 'female');
INSERT INTO `dg_first_names` VALUES (226, 'Cheryl', 'female');
INSERT INTO `dg_first_names` VALUES (227, 'Chester', 'male');
INSERT INTO `dg_first_names` VALUES (228, 'Cheyenne', 'female');
INSERT INTO `dg_first_names` VALUES (229, 'Chiquita', 'female');
INSERT INTO `dg_first_names` VALUES (230, 'Chloe', 'female');
INSERT INTO `dg_first_names` VALUES (231, 'Christen', 'female');
INSERT INTO `dg_first_names` VALUES (232, 'Christian', 'male');
INSERT INTO `dg_first_names` VALUES (233, 'Christine', 'female');
INSERT INTO `dg_first_names` VALUES (234, 'Christopher', 'male');
INSERT INTO `dg_first_names` VALUES (235, 'Ciara', 'female');
INSERT INTO `dg_first_names` VALUES (236, 'Ciaran', 'male');
INSERT INTO `dg_first_names` VALUES (237, 'Claire', 'female');
INSERT INTO `dg_first_names` VALUES (238, 'Clare', 'female');
INSERT INTO `dg_first_names` VALUES (239, 'Clark', 'male');
INSERT INTO `dg_first_names` VALUES (240, 'Clarke', 'male');
INSERT INTO `dg_first_names` VALUES (241, 'Claudia', 'female');
INSERT INTO `dg_first_names` VALUES (242, 'Clayton', 'male');
INSERT INTO `dg_first_names` VALUES (243, 'Clementine', 'female');
INSERT INTO `dg_first_names` VALUES (244, 'Cleo', 'female');
INSERT INTO `dg_first_names` VALUES (245, 'Clinton', 'male');
INSERT INTO `dg_first_names` VALUES (246, 'Clio', 'female');
INSERT INTO `dg_first_names` VALUES (247, 'Coby', 'male');
INSERT INTO `dg_first_names` VALUES (248, 'Cody', 'male');
INSERT INTO `dg_first_names` VALUES (249, 'Colby', 'male');
INSERT INTO `dg_first_names` VALUES (250, 'Cole', 'male');
INSERT INTO `dg_first_names` VALUES (251, 'Colette', 'female');
INSERT INTO `dg_first_names` VALUES (252, 'Colin', 'male');
INSERT INTO `dg_first_names` VALUES (253, 'Colleen', 'female');
INSERT INTO `dg_first_names` VALUES (254, 'Colorado', 'male');
INSERT INTO `dg_first_names` VALUES (255, 'Colt', 'male');
INSERT INTO `dg_first_names` VALUES (256, 'Colton', 'male');
INSERT INTO `dg_first_names` VALUES (257, 'Conan', 'male');
INSERT INTO `dg_first_names` VALUES (258, 'Connor', 'male');
INSERT INTO `dg_first_names` VALUES (259, 'Constance', 'female');
INSERT INTO `dg_first_names` VALUES (260, 'Cooper', 'male');
INSERT INTO `dg_first_names` VALUES (261, 'Cora', 'female');
INSERT INTO `dg_first_names` VALUES (262, 'Courtney\n', 'female');
INSERT INTO `dg_first_names` VALUES (263, 'Craig', 'male');
INSERT INTO `dg_first_names` VALUES (264, 'Cruz', 'male');
INSERT INTO `dg_first_names` VALUES (265, 'Cullen', 'male');
INSERT INTO `dg_first_names` VALUES (266, 'Curran', 'male');
INSERT INTO `dg_first_names` VALUES (267, 'Cynthia', 'female');
INSERT INTO `dg_first_names` VALUES (268, 'Cyrus', 'male');
INSERT INTO `dg_first_names` VALUES (269, 'Dacey', 'female');
INSERT INTO `dg_first_names` VALUES (270, 'Dahlia', 'female');
INSERT INTO `dg_first_names` VALUES (271, 'Dai', 'female');
INSERT INTO `dg_first_names` VALUES (272, 'Dakota', 'both');
INSERT INTO `dg_first_names` VALUES (273, 'Dale', 'male');
INSERT INTO `dg_first_names` VALUES (274, 'Dalton', 'male');
INSERT INTO `dg_first_names` VALUES (275, 'Damian', 'male');
INSERT INTO `dg_first_names` VALUES (276, 'Damon', 'male');
INSERT INTO `dg_first_names` VALUES (277, 'Dana', 'female');
INSERT INTO `dg_first_names` VALUES (278, 'Dane', 'male');
INSERT INTO `dg_first_names` VALUES (279, 'Daniel', 'male');
INSERT INTO `dg_first_names` VALUES (280, 'Danielle', 'female');
INSERT INTO `dg_first_names` VALUES (281, 'Dante', 'male');
INSERT INTO `dg_first_names` VALUES (282, 'Daphne', 'female');
INSERT INTO `dg_first_names` VALUES (283, 'Daquan', 'male');
INSERT INTO `dg_first_names` VALUES (284, 'Dara', 'female');
INSERT INTO `dg_first_names` VALUES (285, 'Daria', 'female');
INSERT INTO `dg_first_names` VALUES (286, 'Darius', 'male');
INSERT INTO `dg_first_names` VALUES (287, 'Darrel', 'female');
INSERT INTO `dg_first_names` VALUES (288, 'Darryl', 'female');
INSERT INTO `dg_first_names` VALUES (289, 'Daryl', 'female');
INSERT INTO `dg_first_names` VALUES (290, 'David', 'male');
INSERT INTO `dg_first_names` VALUES (291, 'Davis', 'male');
INSERT INTO `dg_first_names` VALUES (292, 'Dawn', 'female');
INSERT INTO `dg_first_names` VALUES (293, 'Deacon', 'male');
INSERT INTO `dg_first_names` VALUES (294, 'Dean', 'male');
INSERT INTO `dg_first_names` VALUES (295, 'Deanna', 'female');
INSERT INTO `dg_first_names` VALUES (296, 'Deborah', 'female');
INSERT INTO `dg_first_names` VALUES (297, 'Debra', 'female');
INSERT INTO `dg_first_names` VALUES (298, 'Declan', 'male');
INSERT INTO `dg_first_names` VALUES (299, 'Deirdre', 'female');
INSERT INTO `dg_first_names` VALUES (300, 'Delilah', 'female');
INSERT INTO `dg_first_names` VALUES (301, 'Demetria', 'female');
INSERT INTO `dg_first_names` VALUES (302, 'Demetrius', 'male');
INSERT INTO `dg_first_names` VALUES (303, 'Denise', 'female');
INSERT INTO `dg_first_names` VALUES (304, 'Dennis', 'male');
INSERT INTO `dg_first_names` VALUES (305, 'Denton', 'male');
INSERT INTO `dg_first_names` VALUES (306, 'Derek', 'male');
INSERT INTO `dg_first_names` VALUES (307, 'Desirae', 'female');
INSERT INTO `dg_first_names` VALUES (308, 'Desiree', 'female');
INSERT INTO `dg_first_names` VALUES (309, 'Destiny', 'female');
INSERT INTO `dg_first_names` VALUES (310, 'Devin', 'male');
INSERT INTO `dg_first_names` VALUES (311, 'Dexter', 'male');
INSERT INTO `dg_first_names` VALUES (312, 'Diana', 'female');
INSERT INTO `dg_first_names` VALUES (313, 'Dieter', 'male');
INSERT INTO `dg_first_names` VALUES (314, 'Dillon', 'male');
INSERT INTO `dg_first_names` VALUES (315, 'Dolan', 'male');
INSERT INTO `dg_first_names` VALUES (316, 'Dominic', 'male');
INSERT INTO `dg_first_names` VALUES (317, 'Dominique', 'female');
INSERT INTO `dg_first_names` VALUES (318, 'Donna', 'female');
INSERT INTO `dg_first_names` VALUES (319, 'Donovan', 'male');
INSERT INTO `dg_first_names` VALUES (320, 'Dora', 'female');
INSERT INTO `dg_first_names` VALUES (321, 'Dorian', 'male');
INSERT INTO `dg_first_names` VALUES (322, 'Doris', 'female');
INSERT INTO `dg_first_names` VALUES (323, 'Dorothy', 'female');
INSERT INTO `dg_first_names` VALUES (324, 'Drake', 'male');
INSERT INTO `dg_first_names` VALUES (325, 'Drew', 'male');
INSERT INTO `dg_first_names` VALUES (326, 'Driscoll', 'male');
INSERT INTO `dg_first_names` VALUES (327, 'Duncan', 'male');
INSERT INTO `dg_first_names` VALUES (328, 'Dustin', 'male');
INSERT INTO `dg_first_names` VALUES (329, 'Dylan', 'male');
INSERT INTO `dg_first_names` VALUES (330, 'Eagan', 'male');
INSERT INTO `dg_first_names` VALUES (331, 'Eaton', 'male');
INSERT INTO `dg_first_names` VALUES (332, 'Ebony', 'female');
INSERT INTO `dg_first_names` VALUES (333, 'Echo', 'female');
INSERT INTO `dg_first_names` VALUES (334, 'Edan', 'male');
INSERT INTO `dg_first_names` VALUES (335, 'Eden', 'both');
INSERT INTO `dg_first_names` VALUES (336, 'Edward', 'male');
INSERT INTO `dg_first_names` VALUES (337, 'Elaine', 'female');
INSERT INTO `dg_first_names` VALUES (338, 'Eleanor', 'female');
INSERT INTO `dg_first_names` VALUES (339, 'Eliana', 'female');
INSERT INTO `dg_first_names` VALUES (340, 'Elijah', 'male');
INSERT INTO `dg_first_names` VALUES (341, 'Elizabeth', 'female');
INSERT INTO `dg_first_names` VALUES (342, 'Ella', 'female');
INSERT INTO `dg_first_names` VALUES (343, 'Elliott', 'male');
INSERT INTO `dg_first_names` VALUES (344, 'Elmo', 'male');
INSERT INTO `dg_first_names` VALUES (345, 'Elton', 'male');
INSERT INTO `dg_first_names` VALUES (346, 'Elvis', 'male');
INSERT INTO `dg_first_names` VALUES (347, 'Emerald', 'female');
INSERT INTO `dg_first_names` VALUES (348, 'Emerson', 'male');
INSERT INTO `dg_first_names` VALUES (349, 'Emery', 'male');
INSERT INTO `dg_first_names` VALUES (350, 'Emi', 'female');
INSERT INTO `dg_first_names` VALUES (351, 'Emily', 'female');
INSERT INTO `dg_first_names` VALUES (352, 'Emma', 'female');
INSERT INTO `dg_first_names` VALUES (353, 'Emmanuel', 'male');
INSERT INTO `dg_first_names` VALUES (354, 'Erasmus', 'male');
INSERT INTO `dg_first_names` VALUES (355, 'Eric', 'male');
INSERT INTO `dg_first_names` VALUES (356, 'Erica', 'female');
INSERT INTO `dg_first_names` VALUES (357, 'Erich', 'male');
INSERT INTO `dg_first_names` VALUES (358, 'Erin', 'female');
INSERT INTO `dg_first_names` VALUES (359, 'Ethan', 'male');
INSERT INTO `dg_first_names` VALUES (360, 'Eugenia', 'female');
INSERT INTO `dg_first_names` VALUES (361, 'Evan', 'male');
INSERT INTO `dg_first_names` VALUES (362, 'Evangeline', 'female');
INSERT INTO `dg_first_names` VALUES (363, 'Eve', 'female');
INSERT INTO `dg_first_names` VALUES (364, 'Evelyn', 'female');
INSERT INTO `dg_first_names` VALUES (365, 'Ezekiel', 'male');
INSERT INTO `dg_first_names` VALUES (366, 'Ezra', 'male');
INSERT INTO `dg_first_names` VALUES (367, 'Faith', 'female');
INSERT INTO `dg_first_names` VALUES (368, 'Fallon', 'female');
INSERT INTO `dg_first_names` VALUES (369, 'Farrah', 'female');
INSERT INTO `dg_first_names` VALUES (370, 'Fatima', 'female');
INSERT INTO `dg_first_names` VALUES (371, 'Fay', 'female');
INSERT INTO `dg_first_names` VALUES (372, 'Felicia', 'female');
INSERT INTO `dg_first_names` VALUES (373, 'Felix', 'male');
INSERT INTO `dg_first_names` VALUES (374, 'Ferdinand', 'male');
INSERT INTO `dg_first_names` VALUES (375, 'Ferris', 'male');
INSERT INTO `dg_first_names` VALUES (376, 'Finn', 'male');
INSERT INTO `dg_first_names` VALUES (377, 'Fiona', 'female');
INSERT INTO `dg_first_names` VALUES (378, 'Fitzgerald', 'male');
INSERT INTO `dg_first_names` VALUES (379, 'Flavia', 'female');
INSERT INTO `dg_first_names` VALUES (380, 'Fletcher', 'male');
INSERT INTO `dg_first_names` VALUES (381, 'Fleur', 'female');
INSERT INTO `dg_first_names` VALUES (382, 'Florence', 'female');
INSERT INTO `dg_first_names` VALUES (383, 'Flynn', 'male');
INSERT INTO `dg_first_names` VALUES (384, 'Forrest', 'male');
INSERT INTO `dg_first_names` VALUES (385, 'Frances', 'female');
INSERT INTO `dg_first_names` VALUES (386, 'Francesca', 'female');
INSERT INTO `dg_first_names` VALUES (387, 'Francis', 'male');
INSERT INTO `dg_first_names` VALUES (388, 'Fredericka', 'female');
INSERT INTO `dg_first_names` VALUES (389, 'Freya', 'female');
INSERT INTO `dg_first_names` VALUES (390, 'Fritz', 'male');
INSERT INTO `dg_first_names` VALUES (391, 'Fuller', 'male');
INSERT INTO `dg_first_names` VALUES (392, 'Fulton', 'male');
INSERT INTO `dg_first_names` VALUES (393, 'Gabriel', 'male');
INSERT INTO `dg_first_names` VALUES (394, 'Gage', 'male');
INSERT INTO `dg_first_names` VALUES (395, 'Gail', 'female');
INSERT INTO `dg_first_names` VALUES (396, 'Galena', 'female');
INSERT INTO `dg_first_names` VALUES (397, 'Galvin', 'male');
INSERT INTO `dg_first_names` VALUES (398, 'Gannon', 'male');
INSERT INTO `dg_first_names` VALUES (399, 'Gareth', 'male');
INSERT INTO `dg_first_names` VALUES (400, 'Garrett', 'male');
INSERT INTO `dg_first_names` VALUES (401, 'Garrison', 'male');
INSERT INTO `dg_first_names` VALUES (402, 'Garth', 'male');
INSERT INTO `dg_first_names` VALUES (403, 'Gary', 'male');
INSERT INTO `dg_first_names` VALUES (404, 'Gavin', 'male');
INSERT INTO `dg_first_names` VALUES (405, 'Gay', 'female');
INSERT INTO `dg_first_names` VALUES (406, 'Gemma', 'female');
INSERT INTO `dg_first_names` VALUES (407, 'Genevieve', 'female');
INSERT INTO `dg_first_names` VALUES (408, 'Geoffrey', 'male');
INSERT INTO `dg_first_names` VALUES (409, 'George', 'male');
INSERT INTO `dg_first_names` VALUES (410, 'Georgia', 'female');
INSERT INTO `dg_first_names` VALUES (411, 'Geraldine', 'female');
INSERT INTO `dg_first_names` VALUES (412, 'Germaine', 'female');
INSERT INTO `dg_first_names` VALUES (413, 'Germane', 'female');
INSERT INTO `dg_first_names` VALUES (414, 'Giacomo', 'male');
INSERT INTO `dg_first_names` VALUES (415, 'Gil', 'male');
INSERT INTO `dg_first_names` VALUES (416, 'Gillian', 'female');
INSERT INTO `dg_first_names` VALUES (417, 'Ginger', 'female');
INSERT INTO `dg_first_names` VALUES (418, 'Gisela', 'female');
INSERT INTO `dg_first_names` VALUES (419, 'Giselle', 'female');
INSERT INTO `dg_first_names` VALUES (420, 'Glenna', 'female');
INSERT INTO `dg_first_names` VALUES (421, 'Gloria', 'female');
INSERT INTO `dg_first_names` VALUES (422, 'Grace', 'female');
INSERT INTO `dg_first_names` VALUES (423, 'Grady', 'male');
INSERT INTO `dg_first_names` VALUES (424, 'Graham', 'male');
INSERT INTO `dg_first_names` VALUES (425, 'Graiden', 'male');
INSERT INTO `dg_first_names` VALUES (426, 'Grant', 'male');
INSERT INTO `dg_first_names` VALUES (427, 'Gray', 'male');
INSERT INTO `dg_first_names` VALUES (428, 'Gregory', 'male');
INSERT INTO `dg_first_names` VALUES (429, 'Gretchen', 'female');
INSERT INTO `dg_first_names` VALUES (430, 'Griffin', 'male');
INSERT INTO `dg_first_names` VALUES (431, 'Griffith', 'male');
INSERT INTO `dg_first_names` VALUES (432, 'Guinevere', 'female');
INSERT INTO `dg_first_names` VALUES (433, 'Guy', 'male');
INSERT INTO `dg_first_names` VALUES (434, 'Gwendolyn', 'female');
INSERT INTO `dg_first_names` VALUES (435, 'Hadassah', 'female');
INSERT INTO `dg_first_names` VALUES (436, 'Hadley', 'female');
INSERT INTO `dg_first_names` VALUES (437, 'Hakeem', 'male');
INSERT INTO `dg_first_names` VALUES (438, 'Halee', 'female');
INSERT INTO `dg_first_names` VALUES (439, 'Haley', 'female');
INSERT INTO `dg_first_names` VALUES (440, 'Hall', 'male');
INSERT INTO `dg_first_names` VALUES (441, 'Halla', 'female');
INSERT INTO `dg_first_names` VALUES (442, 'Hamilton', 'male');
INSERT INTO `dg_first_names` VALUES (443, 'Hamish', 'male');
INSERT INTO `dg_first_names` VALUES (444, 'Hammett', 'male');
INSERT INTO `dg_first_names` VALUES (445, 'Hanae', 'female');
INSERT INTO `dg_first_names` VALUES (446, 'Hanna', 'female');
INSERT INTO `dg_first_names` VALUES (447, 'Hannah', 'female');
INSERT INTO `dg_first_names` VALUES (448, 'Harding', 'male');
INSERT INTO `dg_first_names` VALUES (449, 'Harlan', 'male');
INSERT INTO `dg_first_names` VALUES (450, 'Harper', 'male');
INSERT INTO `dg_first_names` VALUES (451, 'Harriet', 'female');
INSERT INTO `dg_first_names` VALUES (452, 'Harrison', 'male');
INSERT INTO `dg_first_names` VALUES (453, 'Hasad', 'male');
INSERT INTO `dg_first_names` VALUES (454, 'Hashim', 'male');
INSERT INTO `dg_first_names` VALUES (455, 'Haviva', 'female');
INSERT INTO `dg_first_names` VALUES (456, 'Hayden', 'male');
INSERT INTO `dg_first_names` VALUES (457, 'Hayes', 'male');
INSERT INTO `dg_first_names` VALUES (458, 'Hayfa', 'female');
INSERT INTO `dg_first_names` VALUES (459, 'Hayley', 'female');
INSERT INTO `dg_first_names` VALUES (460, 'Heather', 'female');
INSERT INTO `dg_first_names` VALUES (461, 'Hector', 'male');
INSERT INTO `dg_first_names` VALUES (462, 'Hedda', 'female');
INSERT INTO `dg_first_names` VALUES (463, 'Hedley', 'male');
INSERT INTO `dg_first_names` VALUES (464, 'Hedwig', 'female');
INSERT INTO `dg_first_names` VALUES (465, 'Hedy', 'female');
INSERT INTO `dg_first_names` VALUES (466, 'Heidi', 'female');
INSERT INTO `dg_first_names` VALUES (467, 'Helen', 'female');
INSERT INTO `dg_first_names` VALUES (468, 'Henry', 'male');
INSERT INTO `dg_first_names` VALUES (469, 'Herman', 'male');
INSERT INTO `dg_first_names` VALUES (470, 'Hermione', 'female');
INSERT INTO `dg_first_names` VALUES (471, 'Herrod', 'male');
INSERT INTO `dg_first_names` VALUES (472, 'Hilary', 'female');
INSERT INTO `dg_first_names` VALUES (473, 'Hilda', 'female');
INSERT INTO `dg_first_names` VALUES (474, 'Hilel', 'male');
INSERT INTO `dg_first_names` VALUES (475, 'Hillary', 'female');
INSERT INTO `dg_first_names` VALUES (476, 'Hiram', 'male');
INSERT INTO `dg_first_names` VALUES (477, 'Hiroko', 'female');
INSERT INTO `dg_first_names` VALUES (478, 'Hollee', 'female');
INSERT INTO `dg_first_names` VALUES (479, 'Holly', 'female');
INSERT INTO `dg_first_names` VALUES (480, 'Holmes', 'male');
INSERT INTO `dg_first_names` VALUES (481, 'Honorato', 'male');
INSERT INTO `dg_first_names` VALUES (482, 'Hop', 'male');
INSERT INTO `dg_first_names` VALUES (483, 'Hope', 'female');
INSERT INTO `dg_first_names` VALUES (484, 'Howard', 'male');
INSERT INTO `dg_first_names` VALUES (485, 'Hoyt', 'male');
INSERT INTO `dg_first_names` VALUES (486, 'Hu', 'male');
INSERT INTO `dg_first_names` VALUES (487, 'Hunter', 'male');
INSERT INTO `dg_first_names` VALUES (488, 'Hyacinth', 'female');
INSERT INTO `dg_first_names` VALUES (489, 'Hyatt', 'male');
INSERT INTO `dg_first_names` VALUES (490, 'Ian', 'male');
INSERT INTO `dg_first_names` VALUES (491, 'Idola', 'female');
INSERT INTO `dg_first_names` VALUES (492, 'Idona', 'female');
INSERT INTO `dg_first_names` VALUES (493, 'Ifeoma', 'female');
INSERT INTO `dg_first_names` VALUES (494, 'Ignacia', 'female');
INSERT INTO `dg_first_names` VALUES (495, 'Ignatius', 'male');
INSERT INTO `dg_first_names` VALUES (496, 'Igor', 'male');
INSERT INTO `dg_first_names` VALUES (497, 'Ila', 'female');
INSERT INTO `dg_first_names` VALUES (498, 'Iliana', 'female');
INSERT INTO `dg_first_names` VALUES (499, 'Illana', 'female');
INSERT INTO `dg_first_names` VALUES (500, 'Illiana', 'female');
INSERT INTO `dg_first_names` VALUES (501, 'Ima', 'female');
INSERT INTO `dg_first_names` VALUES (502, 'Imani', 'female');
INSERT INTO `dg_first_names` VALUES (503, 'Imelda', 'female');
INSERT INTO `dg_first_names` VALUES (504, 'Imogene', 'female');
INSERT INTO `dg_first_names` VALUES (505, 'Ina', 'female');
INSERT INTO `dg_first_names` VALUES (506, 'India', 'female');
INSERT INTO `dg_first_names` VALUES (507, 'Indigo', 'female');
INSERT INTO `dg_first_names` VALUES (508, 'Indira', 'female');
INSERT INTO `dg_first_names` VALUES (509, 'Inez', 'female');
INSERT INTO `dg_first_names` VALUES (510, 'Inga', 'female');
INSERT INTO `dg_first_names` VALUES (511, 'Ingrid', 'female');
INSERT INTO `dg_first_names` VALUES (512, 'Iola', 'female');
INSERT INTO `dg_first_names` VALUES (513, 'Iona', 'female');
INSERT INTO `dg_first_names` VALUES (514, 'Ira', 'male');
INSERT INTO `dg_first_names` VALUES (515, 'Irene', 'female');
INSERT INTO `dg_first_names` VALUES (516, 'Iris', 'female');
INSERT INTO `dg_first_names` VALUES (517, 'Irma', 'female');
INSERT INTO `dg_first_names` VALUES (518, 'Isaac', 'male');
INSERT INTO `dg_first_names` VALUES (519, 'Isabella', 'female');
INSERT INTO `dg_first_names` VALUES (520, 'Isabelle', 'female');
INSERT INTO `dg_first_names` VALUES (521, 'Isadora', 'female');
INSERT INTO `dg_first_names` VALUES (522, 'Isaiah', 'male');
INSERT INTO `dg_first_names` VALUES (523, 'Ishmael', 'male');
INSERT INTO `dg_first_names` VALUES (524, 'Ivan', 'male');
INSERT INTO `dg_first_names` VALUES (525, 'Ivana', 'female');
INSERT INTO `dg_first_names` VALUES (526, 'Ivor', 'male');
INSERT INTO `dg_first_names` VALUES (527, 'Ivory', 'female');
INSERT INTO `dg_first_names` VALUES (528, 'Ivy', 'female');
INSERT INTO `dg_first_names` VALUES (529, 'Jack', 'male');
INSERT INTO `dg_first_names` VALUES (530, 'Jackson', 'male');
INSERT INTO `dg_first_names` VALUES (531, 'Jacob', 'male');
INSERT INTO `dg_first_names` VALUES (532, 'Jada', 'female');
INSERT INTO `dg_first_names` VALUES (533, 'Jade', 'female');
INSERT INTO `dg_first_names` VALUES (534, 'Jaden', 'female');
INSERT INTO `dg_first_names` VALUES (535, 'Jael', 'female');
INSERT INTO `dg_first_names` VALUES (536, 'Jaime', 'female');
INSERT INTO `dg_first_names` VALUES (537, 'Jakeem', 'male');
INSERT INTO `dg_first_names` VALUES (538, 'Jamal', 'male');
INSERT INTO `dg_first_names` VALUES (539, 'Jamalia', 'female');
INSERT INTO `dg_first_names` VALUES (540, 'James', 'male');
INSERT INTO `dg_first_names` VALUES (541, 'Jameson', 'male');
INSERT INTO `dg_first_names` VALUES (542, 'Jana', 'female');
INSERT INTO `dg_first_names` VALUES (543, 'Jane', 'female');
INSERT INTO `dg_first_names` VALUES (544, 'Janna', 'female');
INSERT INTO `dg_first_names` VALUES (545, 'Jaquelyn', 'female');
INSERT INTO `dg_first_names` VALUES (546, 'Jared', 'male');
INSERT INTO `dg_first_names` VALUES (547, 'Jarrod', 'male');
INSERT INTO `dg_first_names` VALUES (548, 'Jasmine', 'female');
INSERT INTO `dg_first_names` VALUES (549, 'Jason', 'male');
INSERT INTO `dg_first_names` VALUES (550, 'Jasper', 'male');
INSERT INTO `dg_first_names` VALUES (551, 'Jayme', 'female');
INSERT INTO `dg_first_names` VALUES (552, 'Jeanette', 'female');
INSERT INTO `dg_first_names` VALUES (553, 'Jelani', 'male');
INSERT INTO `dg_first_names` VALUES (554, 'Jemima', 'female');
INSERT INTO `dg_first_names` VALUES (555, 'Jena', 'female');
INSERT INTO `dg_first_names` VALUES (556, 'Jenette', 'female');
INSERT INTO `dg_first_names` VALUES (557, 'Jenna', 'female');
INSERT INTO `dg_first_names` VALUES (558, 'Jennifer', 'female');
INSERT INTO `dg_first_names` VALUES (559, 'Jeremy', 'male');
INSERT INTO `dg_first_names` VALUES (560, 'Jermaine', 'male');
INSERT INTO `dg_first_names` VALUES (561, 'Jerome', 'male');
INSERT INTO `dg_first_names` VALUES (562, 'Jerry', 'male');
INSERT INTO `dg_first_names` VALUES (563, 'Jescie', 'female');
INSERT INTO `dg_first_names` VALUES (564, 'Jessamine', 'female');
INSERT INTO `dg_first_names` VALUES (565, 'Jesse', 'male');
INSERT INTO `dg_first_names` VALUES (566, 'Jessica', 'female');
INSERT INTO `dg_first_names` VALUES (567, 'Jillian', 'female');
INSERT INTO `dg_first_names` VALUES (568, 'Jin', 'male');
INSERT INTO `dg_first_names` VALUES (569, 'Joan', 'female');
INSERT INTO `dg_first_names` VALUES (570, 'Jocelyn', 'female');
INSERT INTO `dg_first_names` VALUES (571, 'Joel', 'male');
INSERT INTO `dg_first_names` VALUES (572, 'Joelle', 'female');
INSERT INTO `dg_first_names` VALUES (573, 'John', 'male');
INSERT INTO `dg_first_names` VALUES (574, 'Jolene', 'female');
INSERT INTO `dg_first_names` VALUES (575, 'Jolie', 'female');
INSERT INTO `dg_first_names` VALUES (576, 'Jonah', 'male');
INSERT INTO `dg_first_names` VALUES (577, 'Jonas', 'male');
INSERT INTO `dg_first_names` VALUES (578, 'Jordan', 'female');
INSERT INTO `dg_first_names` VALUES (579, 'Jordan', 'male');
INSERT INTO `dg_first_names` VALUES (580, 'Jorden', 'female');
INSERT INTO `dg_first_names` VALUES (581, 'Joseph', 'male');
INSERT INTO `dg_first_names` VALUES (582, 'Josephine', 'female');
INSERT INTO `dg_first_names` VALUES (583, 'Joshua', 'male');
INSERT INTO `dg_first_names` VALUES (584, 'Josiah', 'male');
INSERT INTO `dg_first_names` VALUES (585, 'Joy', 'female');
INSERT INTO `dg_first_names` VALUES (586, 'Judah', 'male');
INSERT INTO `dg_first_names` VALUES (587, 'Judith', 'female');
INSERT INTO `dg_first_names` VALUES (588, 'Julian', 'male');
INSERT INTO `dg_first_names` VALUES (589, 'Julie', 'female');
INSERT INTO `dg_first_names` VALUES (590, 'Juliet', 'female');
INSERT INTO `dg_first_names` VALUES (591, 'Justin', 'male');
INSERT INTO `dg_first_names` VALUES (592, 'Justina', 'female');
INSERT INTO `dg_first_names` VALUES (593, 'Justine', 'female');
INSERT INTO `dg_first_names` VALUES (594, 'Kadeem', 'male');
INSERT INTO `dg_first_names` VALUES (595, 'Kaden', 'both');
INSERT INTO `dg_first_names` VALUES (596, 'Kai', 'female');
INSERT INTO `dg_first_names` VALUES (597, 'Kaitlin', 'female');
INSERT INTO `dg_first_names` VALUES (598, 'Kalia', 'female');
INSERT INTO `dg_first_names` VALUES (599, 'Kamal', 'male');
INSERT INTO `dg_first_names` VALUES (600, 'Kameko', 'female');
INSERT INTO `dg_first_names` VALUES (601, 'Kane', 'male');
INSERT INTO `dg_first_names` VALUES (602, 'Kareem', 'male');
INSERT INTO `dg_first_names` VALUES (603, 'Karen', 'female');
INSERT INTO `dg_first_names` VALUES (604, 'Karina', 'female');
INSERT INTO `dg_first_names` VALUES (605, 'Karleigh', 'female');
INSERT INTO `dg_first_names` VALUES (606, 'Karly', 'female');
INSERT INTO `dg_first_names` VALUES (607, 'Karyn', 'female');
INSERT INTO `dg_first_names` VALUES (608, 'Kaseem', 'male');
INSERT INTO `dg_first_names` VALUES (609, 'Kasimir', 'male');
INSERT INTO `dg_first_names` VALUES (610, 'Kasper', 'male');
INSERT INTO `dg_first_names` VALUES (611, 'Katell', 'female');
INSERT INTO `dg_first_names` VALUES (612, 'Katelyn', 'female');
INSERT INTO `dg_first_names` VALUES (613, 'Kathleen', 'female');
INSERT INTO `dg_first_names` VALUES (614, 'Kato', 'male');
INSERT INTO `dg_first_names` VALUES (615, 'Kay', 'female');
INSERT INTO `dg_first_names` VALUES (616, 'Kaye', 'female');
INSERT INTO `dg_first_names` VALUES (617, 'Keane', 'male');
INSERT INTO `dg_first_names` VALUES (618, 'Keaton', 'male');
INSERT INTO `dg_first_names` VALUES (619, 'Keefe', 'male');
INSERT INTO `dg_first_names` VALUES (620, 'Keegan', 'male');
INSERT INTO `dg_first_names` VALUES (621, 'Keelie', 'female');
INSERT INTO `dg_first_names` VALUES (622, 'Keely', 'female');
INSERT INTO `dg_first_names` VALUES (623, 'Keiko', 'female');
INSERT INTO `dg_first_names` VALUES (624, 'Keith', 'male');
INSERT INTO `dg_first_names` VALUES (625, 'Kellie', 'female');
INSERT INTO `dg_first_names` VALUES (626, 'Kelly', 'female');
INSERT INTO `dg_first_names` VALUES (627, 'Kelly', 'male');
INSERT INTO `dg_first_names` VALUES (628, 'Kelsey', 'female');
INSERT INTO `dg_first_names` VALUES (629, 'Kelsie', 'female');
INSERT INTO `dg_first_names` VALUES (630, 'Kendall', 'both');
INSERT INTO `dg_first_names` VALUES (631, 'Kennan', 'male');
INSERT INTO `dg_first_names` VALUES (632, 'Kennedy', 'male');
INSERT INTO `dg_first_names` VALUES (633, 'Kenneth', 'male');
INSERT INTO `dg_first_names` VALUES (634, 'Kenyon', 'male');
INSERT INTO `dg_first_names` VALUES (635, 'Kermit', 'male');
INSERT INTO `dg_first_names` VALUES (636, 'Kerry', 'female');
INSERT INTO `dg_first_names` VALUES (637, 'Kessie', 'female');
INSERT INTO `dg_first_names` VALUES (638, 'Kevin', 'male');
INSERT INTO `dg_first_names` VALUES (639, 'Kevyn', 'female');
INSERT INTO `dg_first_names` VALUES (640, 'Kiara', 'female');
INSERT INTO `dg_first_names` VALUES (641, 'Kiayada', 'female');
INSERT INTO `dg_first_names` VALUES (642, 'Kibo', 'male');
INSERT INTO `dg_first_names` VALUES (643, 'Kieran', 'male');
INSERT INTO `dg_first_names` VALUES (644, 'Kim', 'female');
INSERT INTO `dg_first_names` VALUES (645, 'Kimberley', 'female');
INSERT INTO `dg_first_names` VALUES (646, 'Kimberly', 'female');
INSERT INTO `dg_first_names` VALUES (647, 'Kiona', 'female');
INSERT INTO `dg_first_names` VALUES (648, 'Kirby', 'female');
INSERT INTO `dg_first_names` VALUES (649, 'Kirestin', 'female');
INSERT INTO `dg_first_names` VALUES (650, 'Kirk', 'male');
INSERT INTO `dg_first_names` VALUES (651, 'Kirsten', 'female');
INSERT INTO `dg_first_names` VALUES (652, 'Kitra', 'female');
INSERT INTO `dg_first_names` VALUES (653, 'Knox', 'male');
INSERT INTO `dg_first_names` VALUES (654, 'Kristen', 'female');
INSERT INTO `dg_first_names` VALUES (655, 'Kuame', 'male');
INSERT INTO `dg_first_names` VALUES (656, 'Kyla', 'female');
INSERT INTO `dg_first_names` VALUES (657, 'Kylan', 'female');
INSERT INTO `dg_first_names` VALUES (658, 'Kyle', 'male');
INSERT INTO `dg_first_names` VALUES (659, 'Kylee', 'female');
INSERT INTO `dg_first_names` VALUES (660, 'Kylie', 'female');
INSERT INTO `dg_first_names` VALUES (661, 'Kylynn', 'female');
INSERT INTO `dg_first_names` VALUES (662, 'Kyra', 'female');
INSERT INTO `dg_first_names` VALUES (663, 'Lacey', 'female');
INSERT INTO `dg_first_names` VALUES (664, 'Lacota', 'female');
INSERT INTO `dg_first_names` VALUES (665, 'Lacy', 'female');
INSERT INTO `dg_first_names` VALUES (666, 'Lael', 'female');
INSERT INTO `dg_first_names` VALUES (667, 'Laith', 'male');
INSERT INTO `dg_first_names` VALUES (668, 'Lamar', 'male');
INSERT INTO `dg_first_names` VALUES (669, 'Lana', 'female');
INSERT INTO `dg_first_names` VALUES (670, 'Lance', 'male');
INSERT INTO `dg_first_names` VALUES (671, 'Lane', 'male');
INSERT INTO `dg_first_names` VALUES (672, 'Lani', 'female');
INSERT INTO `dg_first_names` VALUES (673, 'Lara', 'female');
INSERT INTO `dg_first_names` VALUES (674, 'Lareina', 'female');
INSERT INTO `dg_first_names` VALUES (675, 'Larissa', 'female');
INSERT INTO `dg_first_names` VALUES (676, 'Lars', 'male');
INSERT INTO `dg_first_names` VALUES (677, 'Latifah', 'female');
INSERT INTO `dg_first_names` VALUES (678, 'Laura', 'female');
INSERT INTO `dg_first_names` VALUES (679, 'Laurel', 'female');
INSERT INTO `dg_first_names` VALUES (680, 'Lavinia', 'female');
INSERT INTO `dg_first_names` VALUES (681, 'Lawrence', 'male');
INSERT INTO `dg_first_names` VALUES (682, 'Leah', 'female');
INSERT INTO `dg_first_names` VALUES (683, 'Leandra', 'female');
INSERT INTO `dg_first_names` VALUES (684, 'Lee', 'female');
INSERT INTO `dg_first_names` VALUES (685, 'Lee', 'male');
INSERT INTO `dg_first_names` VALUES (686, 'Leigh', 'female');
INSERT INTO `dg_first_names` VALUES (687, 'Leila', 'female');
INSERT INTO `dg_first_names` VALUES (688, 'Leilani', 'female');
INSERT INTO `dg_first_names` VALUES (689, 'Len', 'male');
INSERT INTO `dg_first_names` VALUES (690, 'Lenore', 'female');
INSERT INTO `dg_first_names` VALUES (691, 'Leo', 'male');
INSERT INTO `dg_first_names` VALUES (692, 'Leonard', 'male');
INSERT INTO `dg_first_names` VALUES (693, 'Leroy', 'male');
INSERT INTO `dg_first_names` VALUES (694, 'Lesley', 'female');
INSERT INTO `dg_first_names` VALUES (695, 'Leslie', 'female');
INSERT INTO `dg_first_names` VALUES (696, 'Lester', 'male');
INSERT INTO `dg_first_names` VALUES (697, 'Lev', 'male');
INSERT INTO `dg_first_names` VALUES (698, 'Levi', 'male');
INSERT INTO `dg_first_names` VALUES (699, 'Lewis', 'male');
INSERT INTO `dg_first_names` VALUES (700, 'Libby', 'female');
INSERT INTO `dg_first_names` VALUES (701, 'Liberty', 'female');
INSERT INTO `dg_first_names` VALUES (702, 'Lila', 'female');
INSERT INTO `dg_first_names` VALUES (703, 'Lilah', 'female');
INSERT INTO `dg_first_names` VALUES (704, 'Lillian', 'female');
INSERT INTO `dg_first_names` VALUES (705, 'Lillith', 'female');
INSERT INTO `dg_first_names` VALUES (706, 'Linda', 'female');
INSERT INTO `dg_first_names` VALUES (707, 'Linus', 'male');
INSERT INTO `dg_first_names` VALUES (708, 'Lionel', 'male');
INSERT INTO `dg_first_names` VALUES (709, 'Lisandra', 'female');
INSERT INTO `dg_first_names` VALUES (710, 'Logan', 'male');
INSERT INTO `dg_first_names` VALUES (711, 'Lois', 'female');
INSERT INTO `dg_first_names` VALUES (712, 'Louis', 'male');
INSERT INTO `dg_first_names` VALUES (713, 'Lucas', 'male');
INSERT INTO `dg_first_names` VALUES (714, 'Lucian', 'male');
INSERT INTO `dg_first_names` VALUES (715, 'Lucius', 'male');
INSERT INTO `dg_first_names` VALUES (716, 'Lucy', 'female');
INSERT INTO `dg_first_names` VALUES (717, 'Luke', 'male');
INSERT INTO `dg_first_names` VALUES (718, 'Lunea', 'female');
INSERT INTO `dg_first_names` VALUES (719, 'Lydia', 'female');
INSERT INTO `dg_first_names` VALUES (720, 'Lyle', 'male');
INSERT INTO `dg_first_names` VALUES (721, 'Lynn', 'female');
INSERT INTO `dg_first_names` VALUES (722, 'Lysandra', 'female');
INSERT INTO `dg_first_names` VALUES (723, 'MacKensie', 'female');
INSERT INTO `dg_first_names` VALUES (724, 'MacKenzie', 'female');
INSERT INTO `dg_first_names` VALUES (725, 'Macaulay', 'male');
INSERT INTO `dg_first_names` VALUES (726, 'Macey', 'female');
INSERT INTO `dg_first_names` VALUES (727, 'Macon', 'male');
INSERT INTO `dg_first_names` VALUES (728, 'Macy', 'female');
INSERT INTO `dg_first_names` VALUES (729, 'Madaline', 'female');
INSERT INTO `dg_first_names` VALUES (730, 'Madeline', 'female');
INSERT INTO `dg_first_names` VALUES (731, 'Madeson', 'female');
INSERT INTO `dg_first_names` VALUES (732, 'Madison', 'female');
INSERT INTO `dg_first_names` VALUES (733, 'Madonna', 'female');
INSERT INTO `dg_first_names` VALUES (734, 'Magee', 'male');
INSERT INTO `dg_first_names` VALUES (735, 'Maggie', 'female');
INSERT INTO `dg_first_names` VALUES (736, 'Maggy', 'female');
INSERT INTO `dg_first_names` VALUES (737, 'Maia', 'female');
INSERT INTO `dg_first_names` VALUES (738, 'Maile', 'female');
INSERT INTO `dg_first_names` VALUES (739, 'Maisie', 'female');
INSERT INTO `dg_first_names` VALUES (740, 'Maite', 'female');
INSERT INTO `dg_first_names` VALUES (741, 'Malachi', 'male');
INSERT INTO `dg_first_names` VALUES (742, 'Malcolm', 'male');
INSERT INTO `dg_first_names` VALUES (743, 'Malik', 'male');
INSERT INTO `dg_first_names` VALUES (744, 'Mallory', 'female');
INSERT INTO `dg_first_names` VALUES (745, 'Mannix', 'male');
INSERT INTO `dg_first_names` VALUES (746, 'Mara', 'female');
INSERT INTO `dg_first_names` VALUES (747, 'Marah', 'female');
INSERT INTO `dg_first_names` VALUES (748, 'Marcia', 'female');
INSERT INTO `dg_first_names` VALUES (749, 'Margaret', 'female');
INSERT INTO `dg_first_names` VALUES (750, 'Mari', 'female');
INSERT INTO `dg_first_names` VALUES (751, 'Mariam', 'female');
INSERT INTO `dg_first_names` VALUES (752, 'Mariko', 'female');
INSERT INTO `dg_first_names` VALUES (753, 'Maris', 'female');
INSERT INTO `dg_first_names` VALUES (754, 'Mark', 'male');
INSERT INTO `dg_first_names` VALUES (755, 'Marny', 'female');
INSERT INTO `dg_first_names` VALUES (756, 'Marsden', 'male');
INSERT INTO `dg_first_names` VALUES (757, 'Marshall', 'male');
INSERT INTO `dg_first_names` VALUES (758, 'Martena', 'female');
INSERT INTO `dg_first_names` VALUES (759, 'Martha', 'female');
INSERT INTO `dg_first_names` VALUES (760, 'Martin', 'male');
INSERT INTO `dg_first_names` VALUES (761, 'Martina', 'female');
INSERT INTO `dg_first_names` VALUES (762, 'Marvin', 'male');
INSERT INTO `dg_first_names` VALUES (763, 'Mary', 'female');
INSERT INTO `dg_first_names` VALUES (764, 'Maryam', 'female');
INSERT INTO `dg_first_names` VALUES (765, 'Mason', 'male');
INSERT INTO `dg_first_names` VALUES (766, 'Matthew', 'male');
INSERT INTO `dg_first_names` VALUES (767, 'Maxine', 'female');
INSERT INTO `dg_first_names` VALUES (768, 'Maxwell', 'male');
INSERT INTO `dg_first_names` VALUES (769, 'May', 'female');
INSERT INTO `dg_first_names` VALUES (770, 'Maya', 'female');
INSERT INTO `dg_first_names` VALUES (771, 'McKenzie', 'female');
INSERT INTO `dg_first_names` VALUES (772, 'Mechelle', 'female');
INSERT INTO `dg_first_names` VALUES (773, 'Medge', 'female');
INSERT INTO `dg_first_names` VALUES (774, 'Megan', 'female');
INSERT INTO `dg_first_names` VALUES (775, 'Meghan', 'female');
INSERT INTO `dg_first_names` VALUES (776, 'Melanie', 'female');
INSERT INTO `dg_first_names` VALUES (777, 'Melinda', 'female');
INSERT INTO `dg_first_names` VALUES (778, 'Melissa', 'female');
INSERT INTO `dg_first_names` VALUES (779, 'Melodie', 'female');
INSERT INTO `dg_first_names` VALUES (780, 'Melvin', 'male');
INSERT INTO `dg_first_names` VALUES (781, 'Melyssa', 'female');
INSERT INTO `dg_first_names` VALUES (782, 'Mercedes', 'female');
INSERT INTO `dg_first_names` VALUES (783, 'Meredith', 'female');
INSERT INTO `dg_first_names` VALUES (784, 'Merrill', 'male');
INSERT INTO `dg_first_names` VALUES (785, 'Merritt', 'male');
INSERT INTO `dg_first_names` VALUES (786, 'Mia', 'female');
INSERT INTO `dg_first_names` VALUES (787, 'Micah', 'male');
INSERT INTO `dg_first_names` VALUES (788, 'Michael', 'male');
INSERT INTO `dg_first_names` VALUES (789, 'Michelle', 'female');
INSERT INTO `dg_first_names` VALUES (790, 'Mikayla', 'female');
INSERT INTO `dg_first_names` VALUES (791, 'Minerva', 'female');
INSERT INTO `dg_first_names` VALUES (792, 'Mira', 'female');
INSERT INTO `dg_first_names` VALUES (793, 'Miranda', 'female');
INSERT INTO `dg_first_names` VALUES (794, 'Miriam', 'female');
INSERT INTO `dg_first_names` VALUES (795, 'Moana', 'female');
INSERT INTO `dg_first_names` VALUES (796, 'Mohammad', 'male');
INSERT INTO `dg_first_names` VALUES (797, 'Mollie', 'female');
INSERT INTO `dg_first_names` VALUES (798, 'Molly', 'female');
INSERT INTO `dg_first_names` VALUES (799, 'Mona', 'female');
INSERT INTO `dg_first_names` VALUES (800, 'Montana', 'female');
INSERT INTO `dg_first_names` VALUES (801, 'Morgan', 'female');
INSERT INTO `dg_first_names` VALUES (802, 'Moses', 'male');
INSERT INTO `dg_first_names` VALUES (803, 'Mufutau', 'male');
INSERT INTO `dg_first_names` VALUES (804, 'Murphy', 'male');
INSERT INTO `dg_first_names` VALUES (805, 'Myles', 'male');
INSERT INTO `dg_first_names` VALUES (806, 'Myra', 'female');
INSERT INTO `dg_first_names` VALUES (807, 'Nadine', 'female');
INSERT INTO `dg_first_names` VALUES (808, 'Naida', 'female');
INSERT INTO `dg_first_names` VALUES (809, 'Naomi', 'female');
INSERT INTO `dg_first_names` VALUES (810, 'Nash', 'male');
INSERT INTO `dg_first_names` VALUES (811, 'Nasim', 'male');
INSERT INTO `dg_first_names` VALUES (812, 'Natalie', 'female');
INSERT INTO `dg_first_names` VALUES (813, 'Nathan', 'male');
INSERT INTO `dg_first_names` VALUES (814, 'Nathaniel', 'male');
INSERT INTO `dg_first_names` VALUES (815, 'Nayda', 'female');
INSERT INTO `dg_first_names` VALUES (816, 'Nehru', 'male');
INSERT INTO `dg_first_names` VALUES (817, 'Neil', 'male');
INSERT INTO `dg_first_names` VALUES (818, 'Nell', 'female');
INSERT INTO `dg_first_names` VALUES (819, 'Nelle', 'female');
INSERT INTO `dg_first_names` VALUES (820, 'Nerea', 'female');
INSERT INTO `dg_first_names` VALUES (821, 'Nero', 'male');
INSERT INTO `dg_first_names` VALUES (822, 'Nevada', 'female');
INSERT INTO `dg_first_names` VALUES (823, 'Neve', 'female');
INSERT INTO `dg_first_names` VALUES (824, 'Neville', 'male');
INSERT INTO `dg_first_names` VALUES (825, 'Nicholas', 'male');
INSERT INTO `dg_first_names` VALUES (826, 'Nichole', 'female');
INSERT INTO `dg_first_names` VALUES (827, 'Nicole', 'female');
INSERT INTO `dg_first_names` VALUES (828, 'Nigel', 'male');
INSERT INTO `dg_first_names` VALUES (829, 'Nina', 'female');
INSERT INTO `dg_first_names` VALUES (830, 'Nissim', 'male');
INSERT INTO `dg_first_names` VALUES (831, 'Nita', 'female');
INSERT INTO `dg_first_names` VALUES (832, 'Noah', 'male');
INSERT INTO `dg_first_names` VALUES (833, 'Noble', 'male');
INSERT INTO `dg_first_names` VALUES (834, 'Noel', 'female');
INSERT INTO `dg_first_names` VALUES (835, 'Noelani', 'female');
INSERT INTO `dg_first_names` VALUES (836, 'Noelle', 'female');
INSERT INTO `dg_first_names` VALUES (837, 'Nola', 'female');
INSERT INTO `dg_first_names` VALUES (838, 'Nolan', 'male');
INSERT INTO `dg_first_names` VALUES (839, 'Nomlanga', 'female');
INSERT INTO `dg_first_names` VALUES (840, 'Nora', 'female');
INSERT INTO `dg_first_names` VALUES (841, 'Norman', 'male');
INSERT INTO `dg_first_names` VALUES (842, 'Nyssa', 'female');
INSERT INTO `dg_first_names` VALUES (843, 'Ocean', 'female');
INSERT INTO `dg_first_names` VALUES (844, 'Octavia', 'female');
INSERT INTO `dg_first_names` VALUES (845, 'Octavius', 'male');
INSERT INTO `dg_first_names` VALUES (846, 'Odessa', 'female');
INSERT INTO `dg_first_names` VALUES (847, 'Odette', 'female');
INSERT INTO `dg_first_names` VALUES (848, 'Odysseus', 'male');
INSERT INTO `dg_first_names` VALUES (849, 'Oleg', 'male');
INSERT INTO `dg_first_names` VALUES (850, 'Olga', 'female');
INSERT INTO `dg_first_names` VALUES (851, 'Oliver', 'male');
INSERT INTO `dg_first_names` VALUES (852, 'Olivia', 'female');
INSERT INTO `dg_first_names` VALUES (853, 'Olympia', 'female');
INSERT INTO `dg_first_names` VALUES (854, 'Omar', 'male');
INSERT INTO `dg_first_names` VALUES (855, 'Oprah', 'female');
INSERT INTO `dg_first_names` VALUES (856, 'Ora', 'female');
INSERT INTO `dg_first_names` VALUES (857, 'Oren', 'male');
INSERT INTO `dg_first_names` VALUES (858, 'Ori', 'female');
INSERT INTO `dg_first_names` VALUES (859, 'Orla', 'female');
INSERT INTO `dg_first_names` VALUES (860, 'Orlando', 'male');
INSERT INTO `dg_first_names` VALUES (861, 'Orli', 'female');
INSERT INTO `dg_first_names` VALUES (862, 'Orson', 'male');
INSERT INTO `dg_first_names` VALUES (863, 'Oscar', 'male');
INSERT INTO `dg_first_names` VALUES (864, 'Otto', 'male');
INSERT INTO `dg_first_names` VALUES (865, 'Owen', 'male');
INSERT INTO `dg_first_names` VALUES (866, 'Paki', 'male');
INSERT INTO `dg_first_names` VALUES (867, 'Palmer', 'male');
INSERT INTO `dg_first_names` VALUES (868, 'Paloma', 'female');
INSERT INTO `dg_first_names` VALUES (869, 'Pamela', 'female');
INSERT INTO `dg_first_names` VALUES (870, 'Pandora', 'female');
INSERT INTO `dg_first_names` VALUES (871, 'Pascale', 'female');
INSERT INTO `dg_first_names` VALUES (872, 'Patience', 'female');
INSERT INTO `dg_first_names` VALUES (873, 'Patricia', 'female');
INSERT INTO `dg_first_names` VALUES (874, 'Patrick', 'male');
INSERT INTO `dg_first_names` VALUES (875, 'Paul', 'male');
INSERT INTO `dg_first_names` VALUES (876, 'Paula', 'female');
INSERT INTO `dg_first_names` VALUES (877, 'Pearl', 'female');
INSERT INTO `dg_first_names` VALUES (878, 'Penelope', 'female');
INSERT INTO `dg_first_names` VALUES (879, 'Perry', 'male');
INSERT INTO `dg_first_names` VALUES (880, 'Peter', 'male');
INSERT INTO `dg_first_names` VALUES (881, 'Petra', 'female');
INSERT INTO `dg_first_names` VALUES (882, 'Phelan', 'male');
INSERT INTO `dg_first_names` VALUES (883, 'Philip', 'male');
INSERT INTO `dg_first_names` VALUES (884, 'Phillip', 'male');
INSERT INTO `dg_first_names` VALUES (885, 'Phoebe', 'female');
INSERT INTO `dg_first_names` VALUES (886, 'Phyllis', 'female');
INSERT INTO `dg_first_names` VALUES (887, 'Piper', 'female');
INSERT INTO `dg_first_names` VALUES (888, 'Plato', 'male');
INSERT INTO `dg_first_names` VALUES (889, 'Porter', 'male');
INSERT INTO `dg_first_names` VALUES (890, 'Portia', 'female');
INSERT INTO `dg_first_names` VALUES (891, 'Prescott', 'male');
INSERT INTO `dg_first_names` VALUES (892, 'Preston', 'male');
INSERT INTO `dg_first_names` VALUES (893, 'Price', 'male');
INSERT INTO `dg_first_names` VALUES (894, 'Priscilla', 'female');
INSERT INTO `dg_first_names` VALUES (895, 'Quail', 'female');
INSERT INTO `dg_first_names` VALUES (896, 'Quamar', 'male');
INSERT INTO `dg_first_names` VALUES (897, 'Quemby', 'female');
INSERT INTO `dg_first_names` VALUES (898, 'Quentin', 'male');
INSERT INTO `dg_first_names` VALUES (899, 'Quin', 'female');
INSERT INTO `dg_first_names` VALUES (900, 'Quincy', 'both');
INSERT INTO `dg_first_names` VALUES (901, 'Quinlan', 'male');
INSERT INTO `dg_first_names` VALUES (902, 'Quinn', 'female');
INSERT INTO `dg_first_names` VALUES (903, 'Quinn', 'male');
INSERT INTO `dg_first_names` VALUES (904, 'Quintessa', 'female');
INSERT INTO `dg_first_names` VALUES (905, 'Quon', 'female');
INSERT INTO `dg_first_names` VALUES (906, 'Quyn', 'female');
INSERT INTO `dg_first_names` VALUES (907, 'Quynn', 'female');
INSERT INTO `dg_first_names` VALUES (908, 'Rachel', 'female');
INSERT INTO `dg_first_names` VALUES (909, 'Rae', 'female');
INSERT INTO `dg_first_names` VALUES (910, 'Rafael', 'male');
INSERT INTO `dg_first_names` VALUES (911, 'Rahim', 'male');
INSERT INTO `dg_first_names` VALUES (912, 'Raja', 'male');
INSERT INTO `dg_first_names` VALUES (913, 'Rajah', 'male');
INSERT INTO `dg_first_names` VALUES (914, 'Ralph', 'male');
INSERT INTO `dg_first_names` VALUES (915, 'Rama', 'female');
INSERT INTO `dg_first_names` VALUES (916, 'Ramona', 'female');
INSERT INTO `dg_first_names` VALUES (917, 'Rana', 'female');
INSERT INTO `dg_first_names` VALUES (918, 'Randall', 'male');
INSERT INTO `dg_first_names` VALUES (919, 'Raphael', 'male');
INSERT INTO `dg_first_names` VALUES (920, 'Rashad', 'male');
INSERT INTO `dg_first_names` VALUES (921, 'Raven', 'female');
INSERT INTO `dg_first_names` VALUES (922, 'Ray', 'male');
INSERT INTO `dg_first_names` VALUES (923, 'Raya', 'female');
INSERT INTO `dg_first_names` VALUES (924, 'Raymond', 'male');
INSERT INTO `dg_first_names` VALUES (925, 'Reagan', 'female');
INSERT INTO `dg_first_names` VALUES (926, 'Rebecca', 'female');
INSERT INTO `dg_first_names` VALUES (927, 'Rebekah', 'female');
INSERT INTO `dg_first_names` VALUES (928, 'Reece', 'male');
INSERT INTO `dg_first_names` VALUES (929, 'Reed', 'male');
INSERT INTO `dg_first_names` VALUES (930, 'Reese', 'male');
INSERT INTO `dg_first_names` VALUES (931, 'Regan', 'female');
INSERT INTO `dg_first_names` VALUES (932, 'Regina', 'female');
INSERT INTO `dg_first_names` VALUES (933, 'Remedios', 'female');
INSERT INTO `dg_first_names` VALUES (934, 'Renee', 'female');
INSERT INTO `dg_first_names` VALUES (935, 'Reuben', 'male');
INSERT INTO `dg_first_names` VALUES (936, 'Rhea', 'female');
INSERT INTO `dg_first_names` VALUES (937, 'Rhiannon', 'female');
INSERT INTO `dg_first_names` VALUES (938, 'Rhoda', 'female');
INSERT INTO `dg_first_names` VALUES (939, 'Rhona', 'female');
INSERT INTO `dg_first_names` VALUES (940, 'Rhonda', 'female');
INSERT INTO `dg_first_names` VALUES (941, 'Ria', 'female');
INSERT INTO `dg_first_names` VALUES (942, 'Richard', 'male');
INSERT INTO `dg_first_names` VALUES (943, 'Rigel', 'male');
INSERT INTO `dg_first_names` VALUES (944, 'Riley', 'female');
INSERT INTO `dg_first_names` VALUES (945, 'Rina', 'female');
INSERT INTO `dg_first_names` VALUES (946, 'Rinah', 'female');
INSERT INTO `dg_first_names` VALUES (947, 'Risa', 'female');
INSERT INTO `dg_first_names` VALUES (948, 'Roanna', 'female');
INSERT INTO `dg_first_names` VALUES (949, 'Roary', 'female');
INSERT INTO `dg_first_names` VALUES (950, 'Robert', 'male');
INSERT INTO `dg_first_names` VALUES (951, 'Robin', 'female');
INSERT INTO `dg_first_names` VALUES (952, 'Rogan', 'male');
INSERT INTO `dg_first_names` VALUES (953, 'Ronan', 'male');
INSERT INTO `dg_first_names` VALUES (954, 'Rooney', 'male');
INSERT INTO `dg_first_names` VALUES (955, 'Rosalyn', 'female');
INSERT INTO `dg_first_names` VALUES (956, 'Rose', 'female');
INSERT INTO `dg_first_names` VALUES (957, 'Ross', 'male');
INSERT INTO `dg_first_names` VALUES (958, 'Roth', 'male');
INSERT INTO `dg_first_names` VALUES (959, 'Rowan', 'female');
INSERT INTO `dg_first_names` VALUES (960, 'Ruby', 'female');
INSERT INTO `dg_first_names` VALUES (961, 'Rudyard', 'male');
INSERT INTO `dg_first_names` VALUES (962, 'Russell', 'male');
INSERT INTO `dg_first_names` VALUES (963, 'Ruth', 'female');
INSERT INTO `dg_first_names` VALUES (964, 'Ryan', 'male');
INSERT INTO `dg_first_names` VALUES (965, 'Ryder', 'male');
INSERT INTO `dg_first_names` VALUES (966, 'Rylee', 'female');
INSERT INTO `dg_first_names` VALUES (967, 'Sacha', 'female');
INSERT INTO `dg_first_names` VALUES (968, 'Sade', 'female');
INSERT INTO `dg_first_names` VALUES (969, 'Sage', 'female');
INSERT INTO `dg_first_names` VALUES (970, 'Salvador', 'male');
INSERT INTO `dg_first_names` VALUES (971, 'Samantha', 'female');
INSERT INTO `dg_first_names` VALUES (972, 'Samson', 'male');
INSERT INTO `dg_first_names` VALUES (973, 'Samuel', 'male');
INSERT INTO `dg_first_names` VALUES (974, 'Sandra', 'female');
INSERT INTO `dg_first_names` VALUES (975, 'Sara', 'female');
INSERT INTO `dg_first_names` VALUES (976, 'Sarah', 'female');
INSERT INTO `dg_first_names` VALUES (977, 'Sasha', 'female');
INSERT INTO `dg_first_names` VALUES (978, 'Savannah', 'female');
INSERT INTO `dg_first_names` VALUES (979, 'Sawyer', 'male');
INSERT INTO `dg_first_names` VALUES (980, 'Scarlet', 'female');
INSERT INTO `dg_first_names` VALUES (981, 'Scarlett', 'female');
INSERT INTO `dg_first_names` VALUES (982, 'Scott', 'male');
INSERT INTO `dg_first_names` VALUES (983, 'Sean', 'male');
INSERT INTO `dg_first_names` VALUES (984, 'Sebastian', 'male');
INSERT INTO `dg_first_names` VALUES (985, 'Selma', 'female');
INSERT INTO `dg_first_names` VALUES (986, 'September', 'female');
INSERT INTO `dg_first_names` VALUES (987, 'Serena', 'female');
INSERT INTO `dg_first_names` VALUES (988, 'Serina', 'female');
INSERT INTO `dg_first_names` VALUES (989, 'Seth', 'male');
INSERT INTO `dg_first_names` VALUES (990, 'Shad', 'male');
INSERT INTO `dg_first_names` VALUES (991, 'Shaeleigh', 'female');
INSERT INTO `dg_first_names` VALUES (992, 'Shafira', 'female');
INSERT INTO `dg_first_names` VALUES (993, 'Shaine', 'female');
INSERT INTO `dg_first_names` VALUES (994, 'Shana', 'female');
INSERT INTO `dg_first_names` VALUES (995, 'Shannon', 'female');
INSERT INTO `dg_first_names` VALUES (996, 'Sharon', 'female');
INSERT INTO `dg_first_names` VALUES (997, 'Shay', 'female');
INSERT INTO `dg_first_names` VALUES (998, 'Shea', 'female');
INSERT INTO `dg_first_names` VALUES (999, 'Sheila', 'female');
INSERT INTO `dg_first_names` VALUES (1000, 'Shelby', 'female');
INSERT INTO `dg_first_names` VALUES (1001, 'Shelley', 'female');
INSERT INTO `dg_first_names` VALUES (1002, 'Shellie', 'female');
INSERT INTO `dg_first_names` VALUES (1003, 'Shelly', 'female');
INSERT INTO `dg_first_names` VALUES (1004, 'Shoshana', 'female');
INSERT INTO `dg_first_names` VALUES (1005, 'Sierra', 'female');
INSERT INTO `dg_first_names` VALUES (1006, 'Signe', 'female');
INSERT INTO `dg_first_names` VALUES (1007, 'Sigourney', 'female');
INSERT INTO `dg_first_names` VALUES (1008, 'Silas', 'male');
INSERT INTO `dg_first_names` VALUES (1009, 'Simon', 'male');
INSERT INTO `dg_first_names` VALUES (1010, 'Simone', 'female');
INSERT INTO `dg_first_names` VALUES (1011, 'Skyler', 'female');
INSERT INTO `dg_first_names` VALUES (1012, 'Slade', 'male');
INSERT INTO `dg_first_names` VALUES (1013, 'Sloane', 'both');
INSERT INTO `dg_first_names` VALUES (1014, 'Solomon', 'male');
INSERT INTO `dg_first_names` VALUES (1015, 'Sonia', 'female');
INSERT INTO `dg_first_names` VALUES (1016, 'Sonya', 'female');
INSERT INTO `dg_first_names` VALUES (1017, 'Sophia', 'female');
INSERT INTO `dg_first_names` VALUES (1018, 'Sopoline', 'female');
INSERT INTO `dg_first_names` VALUES (1019, 'Stacey', 'female');
INSERT INTO `dg_first_names` VALUES (1020, 'Stacy', 'female');
INSERT INTO `dg_first_names` VALUES (1021, 'Steel', 'male');
INSERT INTO `dg_first_names` VALUES (1022, 'Stella', 'female');
INSERT INTO `dg_first_names` VALUES (1023, 'Stephanie', 'female');
INSERT INTO `dg_first_names` VALUES (1024, 'Stephen', 'male');
INSERT INTO `dg_first_names` VALUES (1025, 'Steven', 'male');
INSERT INTO `dg_first_names` VALUES (1026, 'Stewart', 'male');
INSERT INTO `dg_first_names` VALUES (1027, 'Stone', 'male');
INSERT INTO `dg_first_names` VALUES (1028, 'Stuart', 'male');
INSERT INTO `dg_first_names` VALUES (1029, 'Suki', 'female');
INSERT INTO `dg_first_names` VALUES (1030, 'Summer', 'female');
INSERT INTO `dg_first_names` VALUES (1031, 'Susan', 'female');
INSERT INTO `dg_first_names` VALUES (1032, 'Sybil', 'female');
INSERT INTO `dg_first_names` VALUES (1033, 'Sybill', 'female');
INSERT INTO `dg_first_names` VALUES (1034, 'Sydnee', 'female');
INSERT INTO `dg_first_names` VALUES (1035, 'Sydney', 'female');
INSERT INTO `dg_first_names` VALUES (1036, 'Sylvester', 'male');
INSERT INTO `dg_first_names` VALUES (1037, 'Sylvia', 'female');
INSERT INTO `dg_first_names` VALUES (1038, 'TaShya', 'female');
INSERT INTO `dg_first_names` VALUES (1039, 'Tad', 'male');
INSERT INTO `dg_first_names` VALUES (1040, 'Tallulah', 'female');
INSERT INTO `dg_first_names` VALUES (1041, 'Talon', 'male');
INSERT INTO `dg_first_names` VALUES (1042, 'Tamara', 'female');
INSERT INTO `dg_first_names` VALUES (1043, 'Tamekah', 'female');
INSERT INTO `dg_first_names` VALUES (1044, 'Tana', 'female');
INSERT INTO `dg_first_names` VALUES (1045, 'Tanek', 'male');
INSERT INTO `dg_first_names` VALUES (1046, 'Tanisha', 'female');
INSERT INTO `dg_first_names` VALUES (1047, 'Tanner', 'male');
INSERT INTO `dg_first_names` VALUES (1048, 'Tanya', 'female');
INSERT INTO `dg_first_names` VALUES (1049, 'Tara', 'female');
INSERT INTO `dg_first_names` VALUES (1050, 'Tarik', 'male');
INSERT INTO `dg_first_names` VALUES (1051, 'Tasha', 'female');
INSERT INTO `dg_first_names` VALUES (1052, 'Tashya', 'female');
INSERT INTO `dg_first_names` VALUES (1053, 'Tate', 'male');
INSERT INTO `dg_first_names` VALUES (1054, 'Tatiana', 'female');
INSERT INTO `dg_first_names` VALUES (1055, 'Tatum', 'female');
INSERT INTO `dg_first_names` VALUES (1056, 'Tatyana', 'female');
INSERT INTO `dg_first_names` VALUES (1057, 'Taylor', 'both');
INSERT INTO `dg_first_names` VALUES (1058, 'Teagan', 'female');
INSERT INTO `dg_first_names` VALUES (1059, 'Teegan', 'female');
INSERT INTO `dg_first_names` VALUES (1060, 'Thaddeus', 'male');
INSERT INTO `dg_first_names` VALUES (1061, 'Thane', 'male');
INSERT INTO `dg_first_names` VALUES (1062, 'Theodore', 'male');
INSERT INTO `dg_first_names` VALUES (1063, 'Thomas', 'male');
INSERT INTO `dg_first_names` VALUES (1064, 'Thor', 'male');
INSERT INTO `dg_first_names` VALUES (1065, 'Tiger', 'male');
INSERT INTO `dg_first_names` VALUES (1066, 'Timon', 'male');
INSERT INTO `dg_first_names` VALUES (1067, 'Timothy', 'male');
INSERT INTO `dg_first_names` VALUES (1068, 'Tobias', 'male');
INSERT INTO `dg_first_names` VALUES (1069, 'Todd', 'male');
INSERT INTO `dg_first_names` VALUES (1070, 'Travis', 'male');
INSERT INTO `dg_first_names` VALUES (1071, 'Trevor', 'male');
INSERT INTO `dg_first_names` VALUES (1072, 'Troy', 'male');
INSERT INTO `dg_first_names` VALUES (1073, 'Tucker', 'male');
INSERT INTO `dg_first_names` VALUES (1074, 'Tyler', 'male');
INSERT INTO `dg_first_names` VALUES (1075, 'Tyrone', 'male');
INSERT INTO `dg_first_names` VALUES (1076, 'Ulla', 'female');
INSERT INTO `dg_first_names` VALUES (1077, 'Ulric', 'male');
INSERT INTO `dg_first_names` VALUES (1078, 'Ulysses', 'male');
INSERT INTO `dg_first_names` VALUES (1079, 'Uma', 'female');
INSERT INTO `dg_first_names` VALUES (1080, 'Unity', 'female');
INSERT INTO `dg_first_names` VALUES (1081, 'Upton', 'male');
INSERT INTO `dg_first_names` VALUES (1082, 'Uriah', 'male');
INSERT INTO `dg_first_names` VALUES (1083, 'Uriel', 'male');
INSERT INTO `dg_first_names` VALUES (1084, 'Urielle', 'female');
INSERT INTO `dg_first_names` VALUES (1085, 'Ursa', 'female');
INSERT INTO `dg_first_names` VALUES (1086, 'Ursula', 'female');
INSERT INTO `dg_first_names` VALUES (1087, 'Uta', 'female');
INSERT INTO `dg_first_names` VALUES (1088, 'Valentine', 'male');
INSERT INTO `dg_first_names` VALUES (1089, 'Vance', 'male');
INSERT INTO `dg_first_names` VALUES (1090, 'Vanna', 'female');
INSERT INTO `dg_first_names` VALUES (1091, 'Vaughan', 'male');
INSERT INTO `dg_first_names` VALUES (1092, 'Veda', 'female');
INSERT INTO `dg_first_names` VALUES (1093, 'Velma', 'female');
INSERT INTO `dg_first_names` VALUES (1094, 'Venus', 'female');
INSERT INTO `dg_first_names` VALUES (1095, 'Vera', 'female');
INSERT INTO `dg_first_names` VALUES (1096, 'Vernon', 'male');
INSERT INTO `dg_first_names` VALUES (1097, 'Veronica', 'female');
INSERT INTO `dg_first_names` VALUES (1098, 'Victor', 'male');
INSERT INTO `dg_first_names` VALUES (1099, 'Victoria', 'female');
INSERT INTO `dg_first_names` VALUES (1100, 'Vielka', 'female');
INSERT INTO `dg_first_names` VALUES (1101, 'Vincent', 'male');
INSERT INTO `dg_first_names` VALUES (1102, 'Violet', 'female');
INSERT INTO `dg_first_names` VALUES (1103, 'Virginia', 'female');
INSERT INTO `dg_first_names` VALUES (1104, 'Vivian', 'female');
INSERT INTO `dg_first_names` VALUES (1105, 'Vivien', 'female');
INSERT INTO `dg_first_names` VALUES (1106, 'Vladimir', 'male');
INSERT INTO `dg_first_names` VALUES (1107, 'Wade', 'male');
INSERT INTO `dg_first_names` VALUES (1108, 'Walker', 'male');
INSERT INTO `dg_first_names` VALUES (1109, 'Wallace', 'male');
INSERT INTO `dg_first_names` VALUES (1110, 'Walter', 'male');
INSERT INTO `dg_first_names` VALUES (1111, 'Wanda', 'female');
INSERT INTO `dg_first_names` VALUES (1112, 'Wang', 'male');
INSERT INTO `dg_first_names` VALUES (1113, 'Warren', 'male');
INSERT INTO `dg_first_names` VALUES (1114, 'Wayne', 'male');
INSERT INTO `dg_first_names` VALUES (1115, 'Wendy', 'female');
INSERT INTO `dg_first_names` VALUES (1116, 'Wesley', 'male');
INSERT INTO `dg_first_names` VALUES (1117, 'Whilemina', 'female');
INSERT INTO `dg_first_names` VALUES (1118, 'Whitney', 'female');
INSERT INTO `dg_first_names` VALUES (1119, 'Whoopi', 'female');
INSERT INTO `dg_first_names` VALUES (1120, 'Willa', 'female');
INSERT INTO `dg_first_names` VALUES (1121, 'William', 'male');
INSERT INTO `dg_first_names` VALUES (1122, 'Willow', 'female');
INSERT INTO `dg_first_names` VALUES (1123, 'Wilma', 'female');
INSERT INTO `dg_first_names` VALUES (1124, 'Wing', 'male');
INSERT INTO `dg_first_names` VALUES (1125, 'Winifred', 'female');
INSERT INTO `dg_first_names` VALUES (1126, 'Winter', 'female');
INSERT INTO `dg_first_names` VALUES (1127, 'Wyatt', 'male');
INSERT INTO `dg_first_names` VALUES (1128, 'Wylie', 'male');
INSERT INTO `dg_first_names` VALUES (1129, 'Wynne', 'female');
INSERT INTO `dg_first_names` VALUES (1130, 'Wynter', 'female');
INSERT INTO `dg_first_names` VALUES (1131, 'Wyoming', 'female');
INSERT INTO `dg_first_names` VALUES (1132, 'Xander', 'male');
INSERT INTO `dg_first_names` VALUES (1133, 'Xandra', 'female');
INSERT INTO `dg_first_names` VALUES (1134, 'Xantha', 'female');
INSERT INTO `dg_first_names` VALUES (1135, 'Xanthus', 'male');
INSERT INTO `dg_first_names` VALUES (1136, 'Xavier', 'male');
INSERT INTO `dg_first_names` VALUES (1137, 'Xaviera', 'female');
INSERT INTO `dg_first_names` VALUES (1138, 'Xena', 'female');
INSERT INTO `dg_first_names` VALUES (1139, 'Xenos', 'male');
INSERT INTO `dg_first_names` VALUES (1140, 'Xerxes', 'both');
INSERT INTO `dg_first_names` VALUES (1141, 'Xyla', 'female');
INSERT INTO `dg_first_names` VALUES (1142, 'Yael', 'female');
INSERT INTO `dg_first_names` VALUES (1143, 'Yardley', 'male');
INSERT INTO `dg_first_names` VALUES (1144, 'Yasir', 'male');
INSERT INTO `dg_first_names` VALUES (1145, 'Yen', 'female');
INSERT INTO `dg_first_names` VALUES (1146, 'Yeo', 'female');
INSERT INTO `dg_first_names` VALUES (1147, 'Yetta', 'female');
INSERT INTO `dg_first_names` VALUES (1148, 'Yoko', 'female');
INSERT INTO `dg_first_names` VALUES (1149, 'Yolanda', 'female');
INSERT INTO `dg_first_names` VALUES (1150, 'Yoshi', 'female');
INSERT INTO `dg_first_names` VALUES (1151, 'Yoshio', 'male');
INSERT INTO `dg_first_names` VALUES (1152, 'Yuli', 'male');
INSERT INTO `dg_first_names` VALUES (1153, 'Yuri', 'female');
INSERT INTO `dg_first_names` VALUES (1154, 'Yvette', 'female');
INSERT INTO `dg_first_names` VALUES (1155, 'Yvonne', 'female');
INSERT INTO `dg_first_names` VALUES (1156, 'Zachary', 'male');
INSERT INTO `dg_first_names` VALUES (1157, 'Zachery', 'male');
INSERT INTO `dg_first_names` VALUES (1158, 'Zahir', 'male');
INSERT INTO `dg_first_names` VALUES (1159, 'Zane', 'male');
INSERT INTO `dg_first_names` VALUES (1160, 'Zelda', 'female');
INSERT INTO `dg_first_names` VALUES (1161, 'Zelenia', 'female');
INSERT INTO `dg_first_names` VALUES (1162, 'Zena', 'female');
INSERT INTO `dg_first_names` VALUES (1163, 'Zenaida', 'female');
INSERT INTO `dg_first_names` VALUES (1164, 'Zenia', 'female');
INSERT INTO `dg_first_names` VALUES (1165, 'Zeph', 'male');
INSERT INTO `dg_first_names` VALUES (1166, 'Zephania', 'male');
INSERT INTO `dg_first_names` VALUES (1167, 'Zephr', 'female');
INSERT INTO `dg_first_names` VALUES (1168, 'Zeus', 'male');
INSERT INTO `dg_first_names` VALUES (1169, 'Zia', 'female');
INSERT INTO `dg_first_names` VALUES (1170, 'Zoe', 'female');
INSERT INTO `dg_first_names` VALUES (1171, 'Zorita', 'female');
INSERT INTO `dg_first_names` VALUES (1172, 'acqueline', 'female');


-- 
-- table `dg_provinces`
-- 

CREATE TABLE `dg_provinces` (
  `id` mediumint(9) NOT NULL auto_increment,
  `province` varchar(50) NOT NULL default '',
  `prov_short` char(2) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=14 ;

INSERT INTO `dg_provinces` VALUES (1, 'Alberta', 'AB');
INSERT INTO `dg_provinces` VALUES (2, 'British Columbia', 'BC');
INSERT INTO `dg_provinces` VALUES (3, 'Manitoba', 'MB');
INSERT INTO `dg_provinces` VALUES (4, 'New Brunswick', 'NB');
INSERT INTO `dg_provinces` VALUES (5, 'Newfoundland and Labrador', 'NL');
INSERT INTO `dg_provinces` VALUES (6, 'Northwest Territories', 'NT');
INSERT INTO `dg_provinces` VALUES (7, 'Nova Scotia', 'NS');
INSERT INTO `dg_provinces` VALUES (8, 'Nunavut', 'NU');
INSERT INTO `dg_provinces` VALUES (9, 'Ontario', 'ON');
INSERT INTO `dg_provinces` VALUES (10, 'Prince Edward Island', 'PE');
INSERT INTO `dg_provinces` VALUES (11, 'Quebec', 'QC');
INSERT INTO `dg_provinces` VALUES (12, 'Saskatchewan', 'SK');
INSERT INTO `dg_provinces` VALUES (13, 'Yukon', 'YT');


-- 
-- table `dg_provinces_netherlands`
-- 

CREATE TABLE `dg_provinces_netherlands` (
  `province_id` mediumint(8) unsigned NOT NULL auto_increment,
  `province` varchar(50) NOT NULL default '',
  `prov_short` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`province_id`)
) TYPE=MyISAM AUTO_INCREMENT=13 ;

INSERT INTO `dg_provinces_netherlands` VALUES (1, 'Drenthe', 'Dr.');
INSERT INTO `dg_provinces_netherlands` VALUES (2, 'Flevoland', 'Fl.');
INSERT INTO `dg_provinces_netherlands` VALUES (3, 'Friesland', 'Fr.');
INSERT INTO `dg_provinces_netherlands` VALUES (4, 'Gelderland', 'Gld.');
INSERT INTO `dg_provinces_netherlands` VALUES (5, 'Groningen', 'Gr.');
INSERT INTO `dg_provinces_netherlands` VALUES (6, 'Limburg', 'L.');
INSERT INTO `dg_provinces_netherlands` VALUES (7, 'Noord Brabant', 'N.-Br.');
INSERT INTO `dg_provinces_netherlands` VALUES (8, 'Noord Holland', 'N.-H.');
INSERT INTO `dg_provinces_netherlands` VALUES (9, 'Overijssel', 'Ov.');
INSERT INTO `dg_provinces_netherlands` VALUES (10, 'Zuid Holland', 'Z.-H.');
INSERT INTO `dg_provinces_netherlands` VALUES (11, 'Utrecht', 'U.');
INSERT INTO `dg_provinces_netherlands` VALUES (12, 'Zeeland', 'Zld.');


-- 
-- Dumping data for table `dg_states`
-- 

CREATE TABLE `dg_states` (
  `id` mediumint(9) NOT NULL auto_increment,
  `state` varchar(25) NOT NULL default '',
  `state_short` char(2) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=52 ;

INSERT INTO `dg_states` VALUES (1, 'Alabama', 'AL');
INSERT INTO `dg_states` VALUES (2, 'Alaska', 'AK');
INSERT INTO `dg_states` VALUES (3, 'Arizona', 'AZ');
INSERT INTO `dg_states` VALUES (4, 'Arkansas', 'AK');
INSERT INTO `dg_states` VALUES (5, 'California', 'CA');
INSERT INTO `dg_states` VALUES (6, 'Colorado', 'CO');
INSERT INTO `dg_states` VALUES (7, 'Connecticut', 'CT');
INSERT INTO `dg_states` VALUES (8, 'Delaware', 'DE');
INSERT INTO `dg_states` VALUES (9, 'District of Columbia', 'DC');
INSERT INTO `dg_states` VALUES (10, 'Florida', 'FL');
INSERT INTO `dg_states` VALUES (11, 'Georgia', 'GA');
INSERT INTO `dg_states` VALUES (12, 'Hawaii', 'HI');
INSERT INTO `dg_states` VALUES (13, 'Idaho', 'ID');
INSERT INTO `dg_states` VALUES (14, 'Illinois', 'IL');
INSERT INTO `dg_states` VALUES (15, 'Indiana', 'IN');
INSERT INTO `dg_states` VALUES (16, 'Iowa', 'IA');
INSERT INTO `dg_states` VALUES (17, 'Kansas', 'KS');
INSERT INTO `dg_states` VALUES (18, 'Kentucky', 'KY');
INSERT INTO `dg_states` VALUES (19, 'Louisiana', 'LA');
INSERT INTO `dg_states` VALUES (20, 'Maine', 'ME');
INSERT INTO `dg_states` VALUES (21, 'Maryland', 'MD');
INSERT INTO `dg_states` VALUES (22, 'Massachusetts', 'MA');
INSERT INTO `dg_states` VALUES (23, 'Michigan', 'MI');
INSERT INTO `dg_states` VALUES (24, 'Minnesota', 'MN');
INSERT INTO `dg_states` VALUES (25, 'Mississippi', 'MS');
INSERT INTO `dg_states` VALUES (26, 'Missouri', 'MO');
INSERT INTO `dg_states` VALUES (27, 'Montana', 'MT');
INSERT INTO `dg_states` VALUES (28, 'Nebraska', 'NE');
INSERT INTO `dg_states` VALUES (29, 'Nevada', 'NV');
INSERT INTO `dg_states` VALUES (30, 'New Hampshire', 'NH');
INSERT INTO `dg_states` VALUES (31, 'New Jersey', 'NJ');
INSERT INTO `dg_states` VALUES (32, 'New Mexico', 'NM');
INSERT INTO `dg_states` VALUES (33, 'New York', 'NY');
INSERT INTO `dg_states` VALUES (34, 'North Carolina', 'NC');
INSERT INTO `dg_states` VALUES (35, 'North Dakota', 'ND');
INSERT INTO `dg_states` VALUES (36, 'Ohio', 'OH');
INSERT INTO `dg_states` VALUES (37, 'Oklahoma', 'OK');
INSERT INTO `dg_states` VALUES (38, 'Oregon', 'OR');
INSERT INTO `dg_states` VALUES (39, 'Pennsylvania', 'PA');
INSERT INTO `dg_states` VALUES (40, 'Rhode Island', 'RI');
INSERT INTO `dg_states` VALUES (41, 'South Carolina', 'SC');
INSERT INTO `dg_states` VALUES (42, 'South Dakota', 'SD');
INSERT INTO `dg_states` VALUES (43, 'Tennessee', 'TN');
INSERT INTO `dg_states` VALUES (44, 'Texas', 'TX');
INSERT INTO `dg_states` VALUES (45, 'Utah', 'UT');
INSERT INTO `dg_states` VALUES (46, 'Vermont', 'VT');
INSERT INTO `dg_states` VALUES (47, 'Virginia', 'VA');
INSERT INTO `dg_states` VALUES (48, 'Washington', 'WA');
INSERT INTO `dg_states` VALUES (49, 'West Virginia', 'WV');
INSERT INTO `dg_states` VALUES (50, 'Wisconsin', 'WI');
INSERT INTO `dg_states` VALUES (51, 'Wyoming', 'WY');


-- 
-- Dumping data for table `dg_surnames`
-- 

CREATE TABLE `dg_surnames` (
  `id` mediumint(9) NOT NULL auto_increment,
  `surname` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=3347 ;

INSERT INTO `dg_surnames` VALUES (1, 'Abbott');
INSERT INTO `dg_surnames` VALUES (2, 'Acevedo');
INSERT INTO `dg_surnames` VALUES (3, 'Acosta');
INSERT INTO `dg_surnames` VALUES (4, 'Adams');
INSERT INTO `dg_surnames` VALUES (5, 'Adkins');
INSERT INTO `dg_surnames` VALUES (6, 'Aguilar');
INSERT INTO `dg_surnames` VALUES (7, 'Aguirre');
INSERT INTO `dg_surnames` VALUES (8, 'Albert');
INSERT INTO `dg_surnames` VALUES (9, 'Alexander');
INSERT INTO `dg_surnames` VALUES (10, 'Alford');
INSERT INTO `dg_surnames` VALUES (11, 'Allen');
INSERT INTO `dg_surnames` VALUES (12, 'Allison');
INSERT INTO `dg_surnames` VALUES (13, 'Alston');
INSERT INTO `dg_surnames` VALUES (14, 'Alvarado');
INSERT INTO `dg_surnames` VALUES (15, 'Alvarez');
INSERT INTO `dg_surnames` VALUES (16, 'Anderson');
INSERT INTO `dg_surnames` VALUES (17, 'Andrews');
INSERT INTO `dg_surnames` VALUES (18, 'Anthony');
INSERT INTO `dg_surnames` VALUES (19, 'Armstrong');
INSERT INTO `dg_surnames` VALUES (20, 'Arnold');
INSERT INTO `dg_surnames` VALUES (21, 'Ashley');
INSERT INTO `dg_surnames` VALUES (22, 'Atkins');
INSERT INTO `dg_surnames` VALUES (23, 'Atkinson');
INSERT INTO `dg_surnames` VALUES (24, 'Austin');
INSERT INTO `dg_surnames` VALUES (25, 'Avery');
INSERT INTO `dg_surnames` VALUES (26, 'Avila');
INSERT INTO `dg_surnames` VALUES (27, 'Ayala');
INSERT INTO `dg_surnames` VALUES (28, 'Ayers');
INSERT INTO `dg_surnames` VALUES (29, 'Bailey');
INSERT INTO `dg_surnames` VALUES (30, 'Baird');
INSERT INTO `dg_surnames` VALUES (31, 'Baker');
INSERT INTO `dg_surnames` VALUES (32, 'Baldwin');
INSERT INTO `dg_surnames` VALUES (33, 'Ball');
INSERT INTO `dg_surnames` VALUES (34, 'Ballard');
INSERT INTO `dg_surnames` VALUES (35, 'Banks');
INSERT INTO `dg_surnames` VALUES (36, 'Barber');
INSERT INTO `dg_surnames` VALUES (37, 'Barker');
INSERT INTO `dg_surnames` VALUES (38, 'Barlow');
INSERT INTO `dg_surnames` VALUES (39, 'Barnes');
INSERT INTO `dg_surnames` VALUES (40, 'Barnett');
INSERT INTO `dg_surnames` VALUES (41, 'Barr');
INSERT INTO `dg_surnames` VALUES (42, 'Barrera');
INSERT INTO `dg_surnames` VALUES (43, 'Barrett');
INSERT INTO `dg_surnames` VALUES (44, 'Barron');
INSERT INTO `dg_surnames` VALUES (45, 'Barry');
INSERT INTO `dg_surnames` VALUES (46, 'Bartlett');
INSERT INTO `dg_surnames` VALUES (47, 'Barton');
INSERT INTO `dg_surnames` VALUES (48, 'Bass');
INSERT INTO `dg_surnames` VALUES (49, 'Bates');
INSERT INTO `dg_surnames` VALUES (50, 'Battle');
INSERT INTO `dg_surnames` VALUES (51, 'Bauer');
INSERT INTO `dg_surnames` VALUES (52, 'Baxter');
INSERT INTO `dg_surnames` VALUES (53, 'Beach');
INSERT INTO `dg_surnames` VALUES (54, 'Bean');
INSERT INTO `dg_surnames` VALUES (55, 'Beard');
INSERT INTO `dg_surnames` VALUES (56, 'Beasley');
INSERT INTO `dg_surnames` VALUES (57, 'Beck');
INSERT INTO `dg_surnames` VALUES (58, 'Becker');
INSERT INTO `dg_surnames` VALUES (59, 'Bell');
INSERT INTO `dg_surnames` VALUES (60, 'Bender');
INSERT INTO `dg_surnames` VALUES (61, 'Benjamin');
INSERT INTO `dg_surnames` VALUES (62, 'Bennett');
INSERT INTO `dg_surnames` VALUES (63, 'Benson');
INSERT INTO `dg_surnames` VALUES (64, 'Bentley');
INSERT INTO `dg_surnames` VALUES (65, 'Benton');
INSERT INTO `dg_surnames` VALUES (66, 'Berg');
INSERT INTO `dg_surnames` VALUES (67, 'Berger');
INSERT INTO `dg_surnames` VALUES (68, 'Bernard');
INSERT INTO `dg_surnames` VALUES (69, 'Berry');
INSERT INTO `dg_surnames` VALUES (70, 'Best');
INSERT INTO `dg_surnames` VALUES (71, 'Bird');
INSERT INTO `dg_surnames` VALUES (72, 'Bishop');
INSERT INTO `dg_surnames` VALUES (73, 'Black');
INSERT INTO `dg_surnames` VALUES (74, 'Blackburn');
INSERT INTO `dg_surnames` VALUES (75, 'Blackwell');
INSERT INTO `dg_surnames` VALUES (76, 'Blair');
INSERT INTO `dg_surnames` VALUES (77, 'Blake');
INSERT INTO `dg_surnames` VALUES (78, 'Blanchard');
INSERT INTO `dg_surnames` VALUES (79, 'Blankenship');
INSERT INTO `dg_surnames` VALUES (80, 'Blevins');
INSERT INTO `dg_surnames` VALUES (81, 'Bolton');
INSERT INTO `dg_surnames` VALUES (82, 'Bond');
INSERT INTO `dg_surnames` VALUES (83, 'Bonner');
INSERT INTO `dg_surnames` VALUES (84, 'Booker');
INSERT INTO `dg_surnames` VALUES (85, 'Boone');
INSERT INTO `dg_surnames` VALUES (86, 'Booth');
INSERT INTO `dg_surnames` VALUES (87, 'Bowen');
INSERT INTO `dg_surnames` VALUES (88, 'Bowers');
INSERT INTO `dg_surnames` VALUES (89, 'Bowman');
INSERT INTO `dg_surnames` VALUES (90, 'Boyd');
INSERT INTO `dg_surnames` VALUES (91, 'Boyer');
INSERT INTO `dg_surnames` VALUES (92, 'Boyle');
INSERT INTO `dg_surnames` VALUES (93, 'Bradford');
INSERT INTO `dg_surnames` VALUES (94, 'Bradley');
INSERT INTO `dg_surnames` VALUES (95, 'Bradshaw');
INSERT INTO `dg_surnames` VALUES (96, 'Brady');
INSERT INTO `dg_surnames` VALUES (97, 'Branch');
INSERT INTO `dg_surnames` VALUES (98, 'Bray');
INSERT INTO `dg_surnames` VALUES (99, 'Brennan');
INSERT INTO `dg_surnames` VALUES (100, 'Brewer');
INSERT INTO `dg_surnames` VALUES (101, 'Bridges');
INSERT INTO `dg_surnames` VALUES (102, 'Briggs');
INSERT INTO `dg_surnames` VALUES (103, 'Bright');
INSERT INTO `dg_surnames` VALUES (104, 'Britt');
INSERT INTO `dg_surnames` VALUES (105, 'Brock');
INSERT INTO `dg_surnames` VALUES (106, 'Brooks');
INSERT INTO `dg_surnames` VALUES (107, 'Brown');
INSERT INTO `dg_surnames` VALUES (108, 'Browning');
INSERT INTO `dg_surnames` VALUES (109, 'Bruce');
INSERT INTO `dg_surnames` VALUES (110, 'Bryan');
INSERT INTO `dg_surnames` VALUES (111, 'Bryant');
INSERT INTO `dg_surnames` VALUES (112, 'Buchanan');
INSERT INTO `dg_surnames` VALUES (113, 'Buck');
INSERT INTO `dg_surnames` VALUES (114, 'Buckley');
INSERT INTO `dg_surnames` VALUES (115, 'Buckner');
INSERT INTO `dg_surnames` VALUES (116, 'Bullock');
INSERT INTO `dg_surnames` VALUES (117, 'Burch');
INSERT INTO `dg_surnames` VALUES (118, 'Burgess');
INSERT INTO `dg_surnames` VALUES (119, 'Burke');
INSERT INTO `dg_surnames` VALUES (120, 'Burks');
INSERT INTO `dg_surnames` VALUES (121, 'Burnett');
INSERT INTO `dg_surnames` VALUES (122, 'Burns');
INSERT INTO `dg_surnames` VALUES (123, 'Burris');
INSERT INTO `dg_surnames` VALUES (124, 'Burt');
INSERT INTO `dg_surnames` VALUES (125, 'Burton');
INSERT INTO `dg_surnames` VALUES (126, 'Bush');
INSERT INTO `dg_surnames` VALUES (127, 'Butler');
INSERT INTO `dg_surnames` VALUES (128, 'Byers');
INSERT INTO `dg_surnames` VALUES (129, 'Byrd');
INSERT INTO `dg_surnames` VALUES (130, 'Cabrera');
INSERT INTO `dg_surnames` VALUES (131, 'Cain');
INSERT INTO `dg_surnames` VALUES (132, 'Calderon');
INSERT INTO `dg_surnames` VALUES (133, 'Caldwell');
INSERT INTO `dg_surnames` VALUES (134, 'Calhoun');
INSERT INTO `dg_surnames` VALUES (135, 'Callahan');
INSERT INTO `dg_surnames` VALUES (136, 'Camacho');
INSERT INTO `dg_surnames` VALUES (137, 'Cameron');
INSERT INTO `dg_surnames` VALUES (138, 'Campbell');
INSERT INTO `dg_surnames` VALUES (139, 'Campos');
INSERT INTO `dg_surnames` VALUES (140, 'Cannon');
INSERT INTO `dg_surnames` VALUES (141, 'Cantrell');
INSERT INTO `dg_surnames` VALUES (142, 'Cantu');
INSERT INTO `dg_surnames` VALUES (143, 'Cardenas');
INSERT INTO `dg_surnames` VALUES (144, 'Carey');
INSERT INTO `dg_surnames` VALUES (145, 'Carlson');
INSERT INTO `dg_surnames` VALUES (146, 'Carney');
INSERT INTO `dg_surnames` VALUES (147, 'Carpenter');
INSERT INTO `dg_surnames` VALUES (148, 'Carr');
INSERT INTO `dg_surnames` VALUES (149, 'Carrillo');
INSERT INTO `dg_surnames` VALUES (150, 'Carroll');
INSERT INTO `dg_surnames` VALUES (151, 'Carson');
INSERT INTO `dg_surnames` VALUES (152, 'Carter');
INSERT INTO `dg_surnames` VALUES (153, 'Carver');
INSERT INTO `dg_surnames` VALUES (154, 'Case');
INSERT INTO `dg_surnames` VALUES (155, 'Casey');
INSERT INTO `dg_surnames` VALUES (156, 'Cash');
INSERT INTO `dg_surnames` VALUES (157, 'Castaneda');
INSERT INTO `dg_surnames` VALUES (158, 'Castillo');
INSERT INTO `dg_surnames` VALUES (159, 'Castro');
INSERT INTO `dg_surnames` VALUES (160, 'Cervantes');
INSERT INTO `dg_surnames` VALUES (161, 'Chambers');
INSERT INTO `dg_surnames` VALUES (162, 'Chan');
INSERT INTO `dg_surnames` VALUES (163, 'Chandler');
INSERT INTO `dg_surnames` VALUES (164, 'Chaney');
INSERT INTO `dg_surnames` VALUES (165, 'Chang');
INSERT INTO `dg_surnames` VALUES (166, 'Chapman');
INSERT INTO `dg_surnames` VALUES (167, 'Charles');
INSERT INTO `dg_surnames` VALUES (168, 'Chase');
INSERT INTO `dg_surnames` VALUES (169, 'Chavez');
INSERT INTO `dg_surnames` VALUES (170, 'Chen');
INSERT INTO `dg_surnames` VALUES (171, 'Cherry');
INSERT INTO `dg_surnames` VALUES (172, 'Christensen');
INSERT INTO `dg_surnames` VALUES (173, 'Christian');
INSERT INTO `dg_surnames` VALUES (174, 'Church');
INSERT INTO `dg_surnames` VALUES (175, 'Clark');
INSERT INTO `dg_surnames` VALUES (176, 'Clarke');
INSERT INTO `dg_surnames` VALUES (177, 'Clay');
INSERT INTO `dg_surnames` VALUES (178, 'Clayton');
INSERT INTO `dg_surnames` VALUES (179, 'Clements');
INSERT INTO `dg_surnames` VALUES (180, 'Clemons');
INSERT INTO `dg_surnames` VALUES (181, 'Cleveland');
INSERT INTO `dg_surnames` VALUES (182, 'Cline');
INSERT INTO `dg_surnames` VALUES (183, 'Cobb');
INSERT INTO `dg_surnames` VALUES (184, 'Cochran');
INSERT INTO `dg_surnames` VALUES (185, 'Coffey');
INSERT INTO `dg_surnames` VALUES (186, 'Cohen');
INSERT INTO `dg_surnames` VALUES (187, 'Cole');
INSERT INTO `dg_surnames` VALUES (188, 'Coleman');
INSERT INTO `dg_surnames` VALUES (189, 'Collier');
INSERT INTO `dg_surnames` VALUES (190, 'Collins');
INSERT INTO `dg_surnames` VALUES (191, 'Colon');
INSERT INTO `dg_surnames` VALUES (192, 'Combs');
INSERT INTO `dg_surnames` VALUES (193, 'Compton');
INSERT INTO `dg_surnames` VALUES (194, 'Conley');
INSERT INTO `dg_surnames` VALUES (195, 'Conner');
INSERT INTO `dg_surnames` VALUES (196, 'Conrad');
INSERT INTO `dg_surnames` VALUES (197, 'Contreras');
INSERT INTO `dg_surnames` VALUES (198, 'Conway');
INSERT INTO `dg_surnames` VALUES (199, 'Cook');
INSERT INTO `dg_surnames` VALUES (200, 'Cooke');
INSERT INTO `dg_surnames` VALUES (201, 'Cooley');
INSERT INTO `dg_surnames` VALUES (202, 'Cooper');
INSERT INTO `dg_surnames` VALUES (203, 'Copeland');
INSERT INTO `dg_surnames` VALUES (204, 'Cortez');
INSERT INTO `dg_surnames` VALUES (205, 'Cote');
INSERT INTO `dg_surnames` VALUES (206, 'Cotton');
INSERT INTO `dg_surnames` VALUES (207, 'Cox');
INSERT INTO `dg_surnames` VALUES (208, 'Craft');
INSERT INTO `dg_surnames` VALUES (209, 'Craig');
INSERT INTO `dg_surnames` VALUES (210, 'Crane');
INSERT INTO `dg_surnames` VALUES (211, 'Crawford');
INSERT INTO `dg_surnames` VALUES (212, 'Crosby');
INSERT INTO `dg_surnames` VALUES (213, 'Cross');
INSERT INTO `dg_surnames` VALUES (214, 'Cruz');
INSERT INTO `dg_surnames` VALUES (215, 'Cummings');
INSERT INTO `dg_surnames` VALUES (216, 'Cunningham');
INSERT INTO `dg_surnames` VALUES (217, 'Curry');
INSERT INTO `dg_surnames` VALUES (218, 'Curtis');
INSERT INTO `dg_surnames` VALUES (219, 'Dale');
INSERT INTO `dg_surnames` VALUES (220, 'Dalton');
INSERT INTO `dg_surnames` VALUES (221, 'Daniel');
INSERT INTO `dg_surnames` VALUES (222, 'Daniels');
INSERT INTO `dg_surnames` VALUES (223, 'Daugherty');
INSERT INTO `dg_surnames` VALUES (224, 'Davenport');
INSERT INTO `dg_surnames` VALUES (225, 'David');
INSERT INTO `dg_surnames` VALUES (226, 'Davidson');
INSERT INTO `dg_surnames` VALUES (227, 'Davis');
INSERT INTO `dg_surnames` VALUES (228, 'Dawson');
INSERT INTO `dg_surnames` VALUES (229, 'Day');
INSERT INTO `dg_surnames` VALUES (230, 'Dean');
INSERT INTO `dg_surnames` VALUES (231, 'Decker');
INSERT INTO `dg_surnames` VALUES (232, 'Dejesus');
INSERT INTO `dg_surnames` VALUES (233, 'Delacruz');
INSERT INTO `dg_surnames` VALUES (234, 'Delaney');
INSERT INTO `dg_surnames` VALUES (235, 'Deleon');
INSERT INTO `dg_surnames` VALUES (236, 'Delgado');
INSERT INTO `dg_surnames` VALUES (237, 'Dennis');
INSERT INTO `dg_surnames` VALUES (238, 'Diaz');
INSERT INTO `dg_surnames` VALUES (239, 'Dickerson');
INSERT INTO `dg_surnames` VALUES (240, 'Dickson');
INSERT INTO `dg_surnames` VALUES (241, 'Dillard');
INSERT INTO `dg_surnames` VALUES (242, 'Dillon');
INSERT INTO `dg_surnames` VALUES (243, 'Dixon');
INSERT INTO `dg_surnames` VALUES (244, 'Dodson');
INSERT INTO `dg_surnames` VALUES (245, 'Dominguez');
INSERT INTO `dg_surnames` VALUES (246, 'Donaldson');
INSERT INTO `dg_surnames` VALUES (247, 'Donovan');
INSERT INTO `dg_surnames` VALUES (248, 'Dorsey');
INSERT INTO `dg_surnames` VALUES (249, 'Dotson');
INSERT INTO `dg_surnames` VALUES (250, 'Douglas');
INSERT INTO `dg_surnames` VALUES (251, 'Downs');
INSERT INTO `dg_surnames` VALUES (252, 'Doyle');
INSERT INTO `dg_surnames` VALUES (253, 'Drake');
INSERT INTO `dg_surnames` VALUES (254, 'Dudley');
INSERT INTO `dg_surnames` VALUES (255, 'Duffy');
INSERT INTO `dg_surnames` VALUES (256, 'Duke');
INSERT INTO `dg_surnames` VALUES (257, 'Duncan');
INSERT INTO `dg_surnames` VALUES (258, 'Dunlap');
INSERT INTO `dg_surnames` VALUES (259, 'Dunn');
INSERT INTO `dg_surnames` VALUES (260, 'Duran');
INSERT INTO `dg_surnames` VALUES (261, 'Durham');
INSERT INTO `dg_surnames` VALUES (262, 'Dyer');
INSERT INTO `dg_surnames` VALUES (263, 'Eaton');
INSERT INTO `dg_surnames` VALUES (264, 'Edwards');
INSERT INTO `dg_surnames` VALUES (265, 'Elliott');
INSERT INTO `dg_surnames` VALUES (266, 'Ellis');
INSERT INTO `dg_surnames` VALUES (267, 'Ellison');
INSERT INTO `dg_surnames` VALUES (268, 'Emerson');
INSERT INTO `dg_surnames` VALUES (269, 'England');
INSERT INTO `dg_surnames` VALUES (270, 'English');
INSERT INTO `dg_surnames` VALUES (271, 'Erickson');
INSERT INTO `dg_surnames` VALUES (272, 'Espinoza');
INSERT INTO `dg_surnames` VALUES (273, 'Estes');
INSERT INTO `dg_surnames` VALUES (274, 'Estrada');
INSERT INTO `dg_surnames` VALUES (275, 'Evans');
INSERT INTO `dg_surnames` VALUES (276, 'Everett');
INSERT INTO `dg_surnames` VALUES (277, 'Ewing');
INSERT INTO `dg_surnames` VALUES (278, 'Farley');
INSERT INTO `dg_surnames` VALUES (279, 'Farmer');
INSERT INTO `dg_surnames` VALUES (280, 'Farrell');
INSERT INTO `dg_surnames` VALUES (281, 'Faulkner');
INSERT INTO `dg_surnames` VALUES (282, 'Ferguson');
INSERT INTO `dg_surnames` VALUES (283, 'Fernandez');
INSERT INTO `dg_surnames` VALUES (284, 'Ferrell');
INSERT INTO `dg_surnames` VALUES (285, 'Fields');
INSERT INTO `dg_surnames` VALUES (286, 'Figueroa');
INSERT INTO `dg_surnames` VALUES (287, 'Finch');
INSERT INTO `dg_surnames` VALUES (288, 'Finley');
INSERT INTO `dg_surnames` VALUES (289, 'Fischer');
INSERT INTO `dg_surnames` VALUES (290, 'Fisher');
INSERT INTO `dg_surnames` VALUES (291, 'Fitzgerald');
INSERT INTO `dg_surnames` VALUES (292, 'Fitzpatrick');
INSERT INTO `dg_surnames` VALUES (293, 'Fleming');
INSERT INTO `dg_surnames` VALUES (294, 'Fletcher');
INSERT INTO `dg_surnames` VALUES (295, 'Flores');
INSERT INTO `dg_surnames` VALUES (296, 'Flowers');
INSERT INTO `dg_surnames` VALUES (297, 'Floyd');
INSERT INTO `dg_surnames` VALUES (298, 'Flynn');
INSERT INTO `dg_surnames` VALUES (299, 'Foley');
INSERT INTO `dg_surnames` VALUES (300, 'Forbes');
INSERT INTO `dg_surnames` VALUES (301, 'Ford');
INSERT INTO `dg_surnames` VALUES (302, 'Foreman');
INSERT INTO `dg_surnames` VALUES (303, 'Foster');
INSERT INTO `dg_surnames` VALUES (304, 'Fowler');
INSERT INTO `dg_surnames` VALUES (305, 'Fox');
INSERT INTO `dg_surnames` VALUES (306, 'Francis');
INSERT INTO `dg_surnames` VALUES (307, 'Franco');
INSERT INTO `dg_surnames` VALUES (308, 'Frank');
INSERT INTO `dg_surnames` VALUES (309, 'Franklin');
INSERT INTO `dg_surnames` VALUES (310, 'Franks');
INSERT INTO `dg_surnames` VALUES (311, 'Frazier');
INSERT INTO `dg_surnames` VALUES (312, 'Frederick');
INSERT INTO `dg_surnames` VALUES (313, 'Freeman');
INSERT INTO `dg_surnames` VALUES (314, 'French');
INSERT INTO `dg_surnames` VALUES (315, 'Frost');
INSERT INTO `dg_surnames` VALUES (316, 'Fry');
INSERT INTO `dg_surnames` VALUES (317, 'Frye');
INSERT INTO `dg_surnames` VALUES (318, 'Fuentes');
INSERT INTO `dg_surnames` VALUES (319, 'Fuller');
INSERT INTO `dg_surnames` VALUES (320, 'Fulton');
INSERT INTO `dg_surnames` VALUES (321, 'Gaines');
INSERT INTO `dg_surnames` VALUES (322, 'Gallagher');
INSERT INTO `dg_surnames` VALUES (323, 'Gallegos');
INSERT INTO `dg_surnames` VALUES (324, 'Galloway');
INSERT INTO `dg_surnames` VALUES (325, 'Gamble');
INSERT INTO `dg_surnames` VALUES (326, 'Garcia');
INSERT INTO `dg_surnames` VALUES (327, 'Gardner');
INSERT INTO `dg_surnames` VALUES (328, 'Garner');
INSERT INTO `dg_surnames` VALUES (329, 'Garrett');
INSERT INTO `dg_surnames` VALUES (330, 'Garrison');
INSERT INTO `dg_surnames` VALUES (331, 'Garza');
INSERT INTO `dg_surnames` VALUES (332, 'Gates');
INSERT INTO `dg_surnames` VALUES (333, 'Gay');
INSERT INTO `dg_surnames` VALUES (334, 'Gentry');
INSERT INTO `dg_surnames` VALUES (335, 'George');
INSERT INTO `dg_surnames` VALUES (336, 'Gibbs');
INSERT INTO `dg_surnames` VALUES (337, 'Gibson');
INSERT INTO `dg_surnames` VALUES (338, 'Gilbert');
INSERT INTO `dg_surnames` VALUES (339, 'Giles');
INSERT INTO `dg_surnames` VALUES (340, 'Gill');
INSERT INTO `dg_surnames` VALUES (341, 'Gillespie');
INSERT INTO `dg_surnames` VALUES (342, 'Gilliam');
INSERT INTO `dg_surnames` VALUES (343, 'Gilmore');
INSERT INTO `dg_surnames` VALUES (344, 'Glass');
INSERT INTO `dg_surnames` VALUES (345, 'Glenn');
INSERT INTO `dg_surnames` VALUES (346, 'Glover');
INSERT INTO `dg_surnames` VALUES (347, 'Goff');
INSERT INTO `dg_surnames` VALUES (348, 'Golden');
INSERT INTO `dg_surnames` VALUES (349, 'Gomez');
INSERT INTO `dg_surnames` VALUES (350, 'Gonzales');
INSERT INTO `dg_surnames` VALUES (351, 'Gonzalez');
INSERT INTO `dg_surnames` VALUES (352, 'Good');
INSERT INTO `dg_surnames` VALUES (353, 'Goodman');
INSERT INTO `dg_surnames` VALUES (354, 'Goodwin');
INSERT INTO `dg_surnames` VALUES (355, 'Gordon');
INSERT INTO `dg_surnames` VALUES (356, 'Gould');
INSERT INTO `dg_surnames` VALUES (357, 'Graham');
INSERT INTO `dg_surnames` VALUES (358, 'Grant');
INSERT INTO `dg_surnames` VALUES (359, 'Graves');
INSERT INTO `dg_surnames` VALUES (360, 'Gray');
INSERT INTO `dg_surnames` VALUES (361, 'Green');
INSERT INTO `dg_surnames` VALUES (362, 'Greene');
INSERT INTO `dg_surnames` VALUES (363, 'Greer');
INSERT INTO `dg_surnames` VALUES (364, 'Gregory');
INSERT INTO `dg_surnames` VALUES (365, 'Griffin');
INSERT INTO `dg_surnames` VALUES (366, 'Griffith');
INSERT INTO `dg_surnames` VALUES (367, 'Grimes');
INSERT INTO `dg_surnames` VALUES (368, 'Gross');
INSERT INTO `dg_surnames` VALUES (369, 'Guerra');
INSERT INTO `dg_surnames` VALUES (370, 'Guerrero');
INSERT INTO `dg_surnames` VALUES (371, 'Guthrie');
INSERT INTO `dg_surnames` VALUES (372, 'Gutierrez');
INSERT INTO `dg_surnames` VALUES (373, 'Guy');
INSERT INTO `dg_surnames` VALUES (374, 'Guzman');
INSERT INTO `dg_surnames` VALUES (375, 'Hahn');
INSERT INTO `dg_surnames` VALUES (376, 'Hale');
INSERT INTO `dg_surnames` VALUES (377, 'Haley');
INSERT INTO `dg_surnames` VALUES (378, 'Hall');
INSERT INTO `dg_surnames` VALUES (379, 'Hamilton');
INSERT INTO `dg_surnames` VALUES (380, 'Hammond');
INSERT INTO `dg_surnames` VALUES (381, 'Hampton');
INSERT INTO `dg_surnames` VALUES (382, 'Hancock');
INSERT INTO `dg_surnames` VALUES (383, 'Haney');
INSERT INTO `dg_surnames` VALUES (384, 'Hansen');
INSERT INTO `dg_surnames` VALUES (385, 'Hanson');
INSERT INTO `dg_surnames` VALUES (386, 'Hardin');
INSERT INTO `dg_surnames` VALUES (387, 'Harding');
INSERT INTO `dg_surnames` VALUES (388, 'Hardy');
INSERT INTO `dg_surnames` VALUES (389, 'Harmon');
INSERT INTO `dg_surnames` VALUES (390, 'Harper');
INSERT INTO `dg_surnames` VALUES (391, 'Harrell');
INSERT INTO `dg_surnames` VALUES (392, 'Harrington');
INSERT INTO `dg_surnames` VALUES (393, 'Harris');
INSERT INTO `dg_surnames` VALUES (394, 'Harrison');
INSERT INTO `dg_surnames` VALUES (395, 'Hart');
INSERT INTO `dg_surnames` VALUES (396, 'Hartman');
INSERT INTO `dg_surnames` VALUES (397, 'Harvey');
INSERT INTO `dg_surnames` VALUES (398, 'Hatfield');
INSERT INTO `dg_surnames` VALUES (399, 'Hawkins');
INSERT INTO `dg_surnames` VALUES (400, 'Hayden');
INSERT INTO `dg_surnames` VALUES (401, 'Hayes');
INSERT INTO `dg_surnames` VALUES (402, 'Haynes');
INSERT INTO `dg_surnames` VALUES (403, 'Hays');
INSERT INTO `dg_surnames` VALUES (404, 'Head');
INSERT INTO `dg_surnames` VALUES (405, 'Heath');
INSERT INTO `dg_surnames` VALUES (406, 'Hebert');
INSERT INTO `dg_surnames` VALUES (407, 'Henderson');
INSERT INTO `dg_surnames` VALUES (408, 'Hendricks');
INSERT INTO `dg_surnames` VALUES (409, 'Hendrix');
INSERT INTO `dg_surnames` VALUES (410, 'Henry');
INSERT INTO `dg_surnames` VALUES (411, 'Hensley');
INSERT INTO `dg_surnames` VALUES (412, 'Henson');
INSERT INTO `dg_surnames` VALUES (413, 'Herman');
INSERT INTO `dg_surnames` VALUES (414, 'Hernandez');
INSERT INTO `dg_surnames` VALUES (415, 'Herrera');
INSERT INTO `dg_surnames` VALUES (416, 'Herring');
INSERT INTO `dg_surnames` VALUES (417, 'Hess');
INSERT INTO `dg_surnames` VALUES (418, 'Hester');
INSERT INTO `dg_surnames` VALUES (419, 'Hewitt');
INSERT INTO `dg_surnames` VALUES (420, 'Hickman');
INSERT INTO `dg_surnames` VALUES (421, 'Hicks');
INSERT INTO `dg_surnames` VALUES (422, 'Higgins');
INSERT INTO `dg_surnames` VALUES (423, 'Hill');
INSERT INTO `dg_surnames` VALUES (424, 'Hines');
INSERT INTO `dg_surnames` VALUES (425, 'Hinton');
INSERT INTO `dg_surnames` VALUES (426, 'Hobbs');
INSERT INTO `dg_surnames` VALUES (427, 'Hodge');
INSERT INTO `dg_surnames` VALUES (428, 'Hodges');
INSERT INTO `dg_surnames` VALUES (429, 'Hoffman');
INSERT INTO `dg_surnames` VALUES (430, 'Hogan');
INSERT INTO `dg_surnames` VALUES (431, 'Holcomb');
INSERT INTO `dg_surnames` VALUES (432, 'Holden');
INSERT INTO `dg_surnames` VALUES (433, 'Holder');
INSERT INTO `dg_surnames` VALUES (434, 'Holland');
INSERT INTO `dg_surnames` VALUES (435, 'Holloway');
INSERT INTO `dg_surnames` VALUES (436, 'Holman');
INSERT INTO `dg_surnames` VALUES (437, 'Holmes');
INSERT INTO `dg_surnames` VALUES (438, 'Holt');
INSERT INTO `dg_surnames` VALUES (439, 'Hood');
INSERT INTO `dg_surnames` VALUES (440, 'Hooper');
INSERT INTO `dg_surnames` VALUES (441, 'Hoover');
INSERT INTO `dg_surnames` VALUES (442, 'Hopkins');
INSERT INTO `dg_surnames` VALUES (443, 'Hopper');
INSERT INTO `dg_surnames` VALUES (444, 'Horn');
INSERT INTO `dg_surnames` VALUES (445, 'Horne');
INSERT INTO `dg_surnames` VALUES (446, 'Horton');
INSERT INTO `dg_surnames` VALUES (447, 'House');
INSERT INTO `dg_surnames` VALUES (448, 'Houston');
INSERT INTO `dg_surnames` VALUES (449, 'Howard');
INSERT INTO `dg_surnames` VALUES (450, 'Howe');
INSERT INTO `dg_surnames` VALUES (451, 'Howell');
INSERT INTO `dg_surnames` VALUES (452, 'Hubbard');
INSERT INTO `dg_surnames` VALUES (453, 'Huber');
INSERT INTO `dg_surnames` VALUES (454, 'Hudson');
INSERT INTO `dg_surnames` VALUES (455, 'Huff');
INSERT INTO `dg_surnames` VALUES (456, 'Huffman');
INSERT INTO `dg_surnames` VALUES (457, 'Hughes');
INSERT INTO `dg_surnames` VALUES (458, 'Hull');
INSERT INTO `dg_surnames` VALUES (459, 'Humphrey');
INSERT INTO `dg_surnames` VALUES (460, 'Hunt');
INSERT INTO `dg_surnames` VALUES (461, 'Hunter');
INSERT INTO `dg_surnames` VALUES (462, 'Hurley');
INSERT INTO `dg_surnames` VALUES (463, 'Hurst');
INSERT INTO `dg_surnames` VALUES (464, 'Hutchinson');
INSERT INTO `dg_surnames` VALUES (465, 'Hyde');
INSERT INTO `dg_surnames` VALUES (466, 'Ingram');
INSERT INTO `dg_surnames` VALUES (467, 'Irwin');
INSERT INTO `dg_surnames` VALUES (468, 'Jackson');
INSERT INTO `dg_surnames` VALUES (469, 'Jacobs');
INSERT INTO `dg_surnames` VALUES (470, 'Jacobson');
INSERT INTO `dg_surnames` VALUES (471, 'James');
INSERT INTO `dg_surnames` VALUES (472, 'Jarvis');
INSERT INTO `dg_surnames` VALUES (473, 'Jefferson');
INSERT INTO `dg_surnames` VALUES (474, 'Jenkins');
INSERT INTO `dg_surnames` VALUES (475, 'Jennings');
INSERT INTO `dg_surnames` VALUES (476, 'Jensen');
INSERT INTO `dg_surnames` VALUES (477, 'Jimenez');
INSERT INTO `dg_surnames` VALUES (478, 'Johns');
INSERT INTO `dg_surnames` VALUES (479, 'Johnson');
INSERT INTO `dg_surnames` VALUES (480, 'Johnston');
INSERT INTO `dg_surnames` VALUES (481, 'Jones');
INSERT INTO `dg_surnames` VALUES (482, 'Jordan');
INSERT INTO `dg_surnames` VALUES (483, 'Joseph');
INSERT INTO `dg_surnames` VALUES (484, 'Joyce');
INSERT INTO `dg_surnames` VALUES (485, 'Joyner');
INSERT INTO `dg_surnames` VALUES (486, 'Juarez');
INSERT INTO `dg_surnames` VALUES (487, 'Justice');
INSERT INTO `dg_surnames` VALUES (488, 'Kane');
INSERT INTO `dg_surnames` VALUES (489, 'Kaufman');
INSERT INTO `dg_surnames` VALUES (490, 'Keith');
INSERT INTO `dg_surnames` VALUES (491, 'Keller');
INSERT INTO `dg_surnames` VALUES (492, 'Kelley');
INSERT INTO `dg_surnames` VALUES (493, 'Kelly');
INSERT INTO `dg_surnames` VALUES (494, 'Kemp');
INSERT INTO `dg_surnames` VALUES (495, 'Kennedy');
INSERT INTO `dg_surnames` VALUES (496, 'Kent');
INSERT INTO `dg_surnames` VALUES (497, 'Kerr');
INSERT INTO `dg_surnames` VALUES (498, 'Key');
INSERT INTO `dg_surnames` VALUES (499, 'Kidd');
INSERT INTO `dg_surnames` VALUES (500, 'Kim');
INSERT INTO `dg_surnames` VALUES (501, 'King');
INSERT INTO `dg_surnames` VALUES (502, 'Kinney');
INSERT INTO `dg_surnames` VALUES (503, 'Kirby');
INSERT INTO `dg_surnames` VALUES (504, 'Kirk');
INSERT INTO `dg_surnames` VALUES (505, 'Kirkland');
INSERT INTO `dg_surnames` VALUES (506, 'Klein');
INSERT INTO `dg_surnames` VALUES (507, 'Kline');
INSERT INTO `dg_surnames` VALUES (508, 'Knapp');
INSERT INTO `dg_surnames` VALUES (509, 'Knight');
INSERT INTO `dg_surnames` VALUES (510, 'Knowles');
INSERT INTO `dg_surnames` VALUES (511, 'Knox');
INSERT INTO `dg_surnames` VALUES (512, 'Koch');
INSERT INTO `dg_surnames` VALUES (513, 'Kramer');
INSERT INTO `dg_surnames` VALUES (514, 'Lamb');
INSERT INTO `dg_surnames` VALUES (515, 'Lambert');
INSERT INTO `dg_surnames` VALUES (516, 'Lancaster');
INSERT INTO `dg_surnames` VALUES (517, 'Landry');
INSERT INTO `dg_surnames` VALUES (518, 'Lane');
INSERT INTO `dg_surnames` VALUES (519, 'Lang');
INSERT INTO `dg_surnames` VALUES (520, 'Langley');
INSERT INTO `dg_surnames` VALUES (521, 'Lara');
INSERT INTO `dg_surnames` VALUES (522, 'Larsen');
INSERT INTO `dg_surnames` VALUES (523, 'Larson');
INSERT INTO `dg_surnames` VALUES (524, 'Lawrence');
INSERT INTO `dg_surnames` VALUES (525, 'Lawson');
INSERT INTO `dg_surnames` VALUES (526, 'Le');
INSERT INTO `dg_surnames` VALUES (527, 'Leach');
INSERT INTO `dg_surnames` VALUES (528, 'Leblanc');
INSERT INTO `dg_surnames` VALUES (529, 'Lee');
INSERT INTO `dg_surnames` VALUES (530, 'Leon');
INSERT INTO `dg_surnames` VALUES (531, 'Leonard');
INSERT INTO `dg_surnames` VALUES (532, 'Lester');
INSERT INTO `dg_surnames` VALUES (533, 'Levine');
INSERT INTO `dg_surnames` VALUES (534, 'Levy');
INSERT INTO `dg_surnames` VALUES (535, 'Lewis');
INSERT INTO `dg_surnames` VALUES (536, 'Lindsay');
INSERT INTO `dg_surnames` VALUES (537, 'Lindsey');
INSERT INTO `dg_surnames` VALUES (538, 'Little');
INSERT INTO `dg_surnames` VALUES (539, 'Livingston');
INSERT INTO `dg_surnames` VALUES (540, 'Lloyd');
INSERT INTO `dg_surnames` VALUES (541, 'Logan');
INSERT INTO `dg_surnames` VALUES (542, 'Long');
INSERT INTO `dg_surnames` VALUES (543, 'Lopez');
INSERT INTO `dg_surnames` VALUES (544, 'Lott');
INSERT INTO `dg_surnames` VALUES (545, 'Love');
INSERT INTO `dg_surnames` VALUES (546, 'Lowe');
INSERT INTO `dg_surnames` VALUES (547, 'Lowery');
INSERT INTO `dg_surnames` VALUES (548, 'Lucas');
INSERT INTO `dg_surnames` VALUES (549, 'Luna');
INSERT INTO `dg_surnames` VALUES (550, 'Lynch');
INSERT INTO `dg_surnames` VALUES (551, 'Lynn');
INSERT INTO `dg_surnames` VALUES (552, 'Lyons');
INSERT INTO `dg_surnames` VALUES (553, 'Macdonald');
INSERT INTO `dg_surnames` VALUES (554, 'Macias');
INSERT INTO `dg_surnames` VALUES (555, 'Mack');
INSERT INTO `dg_surnames` VALUES (556, 'Madden');
INSERT INTO `dg_surnames` VALUES (557, 'Maddox');
INSERT INTO `dg_surnames` VALUES (558, 'Maldonado');
INSERT INTO `dg_surnames` VALUES (559, 'Malone');
INSERT INTO `dg_surnames` VALUES (560, 'Mann');
INSERT INTO `dg_surnames` VALUES (561, 'Manning');
INSERT INTO `dg_surnames` VALUES (562, 'Marks');
INSERT INTO `dg_surnames` VALUES (563, 'Marquez');
INSERT INTO `dg_surnames` VALUES (564, 'Marsh');
INSERT INTO `dg_surnames` VALUES (565, 'Marshall');
INSERT INTO `dg_surnames` VALUES (566, 'Martin');
INSERT INTO `dg_surnames` VALUES (567, 'Martinez');
INSERT INTO `dg_surnames` VALUES (568, 'Mason');
INSERT INTO `dg_surnames` VALUES (569, 'Massey');
INSERT INTO `dg_surnames` VALUES (570, 'Mathews');
INSERT INTO `dg_surnames` VALUES (571, 'Mathis');
INSERT INTO `dg_surnames` VALUES (572, 'Matthews');
INSERT INTO `dg_surnames` VALUES (573, 'Maxwell');
INSERT INTO `dg_surnames` VALUES (574, 'May');
INSERT INTO `dg_surnames` VALUES (575, 'Mayer');
INSERT INTO `dg_surnames` VALUES (576, 'Maynard');
INSERT INTO `dg_surnames` VALUES (577, 'Mayo');
INSERT INTO `dg_surnames` VALUES (578, 'Mays');
INSERT INTO `dg_surnames` VALUES (579, 'Mcbride');
INSERT INTO `dg_surnames` VALUES (580, 'Mccall');
INSERT INTO `dg_surnames` VALUES (581, 'Mccarthy');
INSERT INTO `dg_surnames` VALUES (582, 'Mccarty');
INSERT INTO `dg_surnames` VALUES (583, 'Mcclain');
INSERT INTO `dg_surnames` VALUES (584, 'Mcclure');
INSERT INTO `dg_surnames` VALUES (585, 'Mcconnell');
INSERT INTO `dg_surnames` VALUES (586, 'Mccormick');
INSERT INTO `dg_surnames` VALUES (587, 'Mccoy');
INSERT INTO `dg_surnames` VALUES (588, 'Mccray');
INSERT INTO `dg_surnames` VALUES (589, 'Mccullough');
INSERT INTO `dg_surnames` VALUES (590, 'Mcdaniel');
INSERT INTO `dg_surnames` VALUES (591, 'Mcdonald');
INSERT INTO `dg_surnames` VALUES (592, 'Mcdowell');
INSERT INTO `dg_surnames` VALUES (593, 'Mcfadden');
INSERT INTO `dg_surnames` VALUES (594, 'Mcfarland');
INSERT INTO `dg_surnames` VALUES (595, 'Mcgee');
INSERT INTO `dg_surnames` VALUES (596, 'Mcgowan');
INSERT INTO `dg_surnames` VALUES (597, 'Mcguire');
INSERT INTO `dg_surnames` VALUES (598, 'Mcintosh');
INSERT INTO `dg_surnames` VALUES (599, 'Mcintyre');
INSERT INTO `dg_surnames` VALUES (600, 'Mckay');
INSERT INTO `dg_surnames` VALUES (601, 'Mckee');
INSERT INTO `dg_surnames` VALUES (602, 'Mckenzie');
INSERT INTO `dg_surnames` VALUES (603, 'Mckinney');
INSERT INTO `dg_surnames` VALUES (604, 'Mcknight');
INSERT INTO `dg_surnames` VALUES (605, 'Mclaughlin');
INSERT INTO `dg_surnames` VALUES (606, 'Mclean');
INSERT INTO `dg_surnames` VALUES (607, 'Mcleod');
INSERT INTO `dg_surnames` VALUES (608, 'Mcmahon');
INSERT INTO `dg_surnames` VALUES (609, 'Mcmillan');
INSERT INTO `dg_surnames` VALUES (610, 'Mcneil');
INSERT INTO `dg_surnames` VALUES (611, 'Mcpherson');
INSERT INTO `dg_surnames` VALUES (612, 'Meadows');
INSERT INTO `dg_surnames` VALUES (613, 'Medina');
INSERT INTO `dg_surnames` VALUES (614, 'Mejia');
INSERT INTO `dg_surnames` VALUES (615, 'Melendez');
INSERT INTO `dg_surnames` VALUES (616, 'Melton');
INSERT INTO `dg_surnames` VALUES (617, 'Mendez');
INSERT INTO `dg_surnames` VALUES (618, 'Mendoza');
INSERT INTO `dg_surnames` VALUES (619, 'Mercado');
INSERT INTO `dg_surnames` VALUES (620, 'Mercer');
INSERT INTO `dg_surnames` VALUES (621, 'Merrill');
INSERT INTO `dg_surnames` VALUES (622, 'Merritt');
INSERT INTO `dg_surnames` VALUES (623, 'Meyer');
INSERT INTO `dg_surnames` VALUES (624, 'Meyers');
INSERT INTO `dg_surnames` VALUES (625, 'Michael');
INSERT INTO `dg_surnames` VALUES (626, 'Middleton');
INSERT INTO `dg_surnames` VALUES (627, 'Miles');
INSERT INTO `dg_surnames` VALUES (628, 'Miller');
INSERT INTO `dg_surnames` VALUES (629, 'Mills');
INSERT INTO `dg_surnames` VALUES (630, 'Miranda');
INSERT INTO `dg_surnames` VALUES (631, 'Mitchell');
INSERT INTO `dg_surnames` VALUES (632, 'Molina');
INSERT INTO `dg_surnames` VALUES (633, 'Monroe');
INSERT INTO `dg_surnames` VALUES (634, 'Montgomery');
INSERT INTO `dg_surnames` VALUES (635, 'Montoya');
INSERT INTO `dg_surnames` VALUES (636, 'Moody');
INSERT INTO `dg_surnames` VALUES (637, 'Moon');
INSERT INTO `dg_surnames` VALUES (638, 'Mooney');
INSERT INTO `dg_surnames` VALUES (639, 'Moore');
INSERT INTO `dg_surnames` VALUES (640, 'Morales');
INSERT INTO `dg_surnames` VALUES (641, 'Moran');
INSERT INTO `dg_surnames` VALUES (642, 'Moreno');
INSERT INTO `dg_surnames` VALUES (643, 'Morgan');
INSERT INTO `dg_surnames` VALUES (644, 'Morin');
INSERT INTO `dg_surnames` VALUES (645, 'Morris');
INSERT INTO `dg_surnames` VALUES (646, 'Morrison');
INSERT INTO `dg_surnames` VALUES (647, 'Morrow');
INSERT INTO `dg_surnames` VALUES (648, 'Morse');
INSERT INTO `dg_surnames` VALUES (649, 'Morton');
INSERT INTO `dg_surnames` VALUES (650, 'Moses');
INSERT INTO `dg_surnames` VALUES (651, 'Mosley');
INSERT INTO `dg_surnames` VALUES (652, 'Moss');
INSERT INTO `dg_surnames` VALUES (653, 'Mueller');
INSERT INTO `dg_surnames` VALUES (654, 'Mullen');
INSERT INTO `dg_surnames` VALUES (655, 'Mullins');
INSERT INTO `dg_surnames` VALUES (656, 'Munoz');
INSERT INTO `dg_surnames` VALUES (657, 'Murphy');
INSERT INTO `dg_surnames` VALUES (658, 'Murray');
INSERT INTO `dg_surnames` VALUES (659, 'Myers');
INSERT INTO `dg_surnames` VALUES (660, 'Nash');
INSERT INTO `dg_surnames` VALUES (661, 'Navarro');
INSERT INTO `dg_surnames` VALUES (662, 'Neal');
INSERT INTO `dg_surnames` VALUES (663, 'Nelson');
INSERT INTO `dg_surnames` VALUES (664, 'Newman');
INSERT INTO `dg_surnames` VALUES (665, 'Newton');
INSERT INTO `dg_surnames` VALUES (666, 'Nguyen');
INSERT INTO `dg_surnames` VALUES (667, 'Nichols');
INSERT INTO `dg_surnames` VALUES (668, 'Nicholson');
INSERT INTO `dg_surnames` VALUES (669, 'Nielsen');
INSERT INTO `dg_surnames` VALUES (670, 'Nieves');
INSERT INTO `dg_surnames` VALUES (671, 'Nixon');
INSERT INTO `dg_surnames` VALUES (672, 'Noble');
INSERT INTO `dg_surnames` VALUES (673, 'Noel');
INSERT INTO `dg_surnames` VALUES (674, 'Nolan');
INSERT INTO `dg_surnames` VALUES (675, 'Norman');
INSERT INTO `dg_surnames` VALUES (676, 'Norris');
INSERT INTO `dg_surnames` VALUES (677, 'Norton');
INSERT INTO `dg_surnames` VALUES (678, 'Nunez');
INSERT INTO `dg_surnames` VALUES (679, 'Obrien');
INSERT INTO `dg_surnames` VALUES (680, 'Ochoa');
INSERT INTO `dg_surnames` VALUES (681, 'Oconnor');
INSERT INTO `dg_surnames` VALUES (682, 'Odom');
INSERT INTO `dg_surnames` VALUES (683, 'Odonnell');
INSERT INTO `dg_surnames` VALUES (684, 'Oliver');
INSERT INTO `dg_surnames` VALUES (685, 'Olsen');
INSERT INTO `dg_surnames` VALUES (686, 'Olson');
INSERT INTO `dg_surnames` VALUES (687, 'Oneal');
INSERT INTO `dg_surnames` VALUES (688, 'Oneil');
INSERT INTO `dg_surnames` VALUES (689, 'Oneill');
INSERT INTO `dg_surnames` VALUES (690, 'Orr');
INSERT INTO `dg_surnames` VALUES (691, 'Ortega');
INSERT INTO `dg_surnames` VALUES (692, 'Ortiz');
INSERT INTO `dg_surnames` VALUES (693, 'Osborn');
INSERT INTO `dg_surnames` VALUES (694, 'Osborne');
INSERT INTO `dg_surnames` VALUES (695, 'Owen');
INSERT INTO `dg_surnames` VALUES (696, 'Owens');
INSERT INTO `dg_surnames` VALUES (697, 'Pace');
INSERT INTO `dg_surnames` VALUES (698, 'Pacheco');
INSERT INTO `dg_surnames` VALUES (699, 'Padilla');
INSERT INTO `dg_surnames` VALUES (700, 'Page');
INSERT INTO `dg_surnames` VALUES (701, 'Palmer');
INSERT INTO `dg_surnames` VALUES (702, 'Park');
INSERT INTO `dg_surnames` VALUES (703, 'Parker');
INSERT INTO `dg_surnames` VALUES (704, 'Parks');
INSERT INTO `dg_surnames` VALUES (705, 'Parrish');
INSERT INTO `dg_surnames` VALUES (706, 'Parsons');
INSERT INTO `dg_surnames` VALUES (707, 'Pate');
INSERT INTO `dg_surnames` VALUES (708, 'Patel');
INSERT INTO `dg_surnames` VALUES (709, 'Patrick');
INSERT INTO `dg_surnames` VALUES (710, 'Patterson');
INSERT INTO `dg_surnames` VALUES (711, 'Patton');
INSERT INTO `dg_surnames` VALUES (712, 'Paul');
INSERT INTO `dg_surnames` VALUES (713, 'Payne');
INSERT INTO `dg_surnames` VALUES (714, 'Pearson');
INSERT INTO `dg_surnames` VALUES (715, 'Peck');
INSERT INTO `dg_surnames` VALUES (716, 'Pena');
INSERT INTO `dg_surnames` VALUES (717, 'Pennington');
INSERT INTO `dg_surnames` VALUES (718, 'Perez');
INSERT INTO `dg_surnames` VALUES (719, 'Perkins');
INSERT INTO `dg_surnames` VALUES (720, 'Perry');
INSERT INTO `dg_surnames` VALUES (721, 'Peters');
INSERT INTO `dg_surnames` VALUES (722, 'Petersen');
INSERT INTO `dg_surnames` VALUES (723, 'Peterson');
INSERT INTO `dg_surnames` VALUES (724, 'Petty');
INSERT INTO `dg_surnames` VALUES (725, 'Phelps');
INSERT INTO `dg_surnames` VALUES (726, 'Phillips');
INSERT INTO `dg_surnames` VALUES (727, 'Pickett');
INSERT INTO `dg_surnames` VALUES (728, 'Pierce');
INSERT INTO `dg_surnames` VALUES (729, 'Pittman');
INSERT INTO `dg_surnames` VALUES (730, 'Pitts');
INSERT INTO `dg_surnames` VALUES (731, 'Pollard');
INSERT INTO `dg_surnames` VALUES (732, 'Poole');
INSERT INTO `dg_surnames` VALUES (733, 'Pope');
INSERT INTO `dg_surnames` VALUES (734, 'Porter');
INSERT INTO `dg_surnames` VALUES (735, 'Potter');
INSERT INTO `dg_surnames` VALUES (736, 'Potts');
INSERT INTO `dg_surnames` VALUES (737, 'Powell');
INSERT INTO `dg_surnames` VALUES (738, 'Powers');
INSERT INTO `dg_surnames` VALUES (739, 'Pratt');
INSERT INTO `dg_surnames` VALUES (740, 'Preston');
INSERT INTO `dg_surnames` VALUES (741, 'Price');
INSERT INTO `dg_surnames` VALUES (742, 'Prince');
INSERT INTO `dg_surnames` VALUES (743, 'Pruitt');
INSERT INTO `dg_surnames` VALUES (744, 'Puckett');
INSERT INTO `dg_surnames` VALUES (745, 'Pugh');
INSERT INTO `dg_surnames` VALUES (746, 'Quinn');
INSERT INTO `dg_surnames` VALUES (747, 'Ramirez');
INSERT INTO `dg_surnames` VALUES (748, 'Ramos');
INSERT INTO `dg_surnames` VALUES (749, 'Ramsey');
INSERT INTO `dg_surnames` VALUES (750, 'Randall');
INSERT INTO `dg_surnames` VALUES (751, 'Randolph');
INSERT INTO `dg_surnames` VALUES (752, 'Rasmussen');
INSERT INTO `dg_surnames` VALUES (753, 'Ratliff');
INSERT INTO `dg_surnames` VALUES (754, 'Ray');
INSERT INTO `dg_surnames` VALUES (755, 'Raymond');
INSERT INTO `dg_surnames` VALUES (756, 'Reed');
INSERT INTO `dg_surnames` VALUES (757, 'Reese');
INSERT INTO `dg_surnames` VALUES (758, 'Reeves');
INSERT INTO `dg_surnames` VALUES (759, 'Reid');
INSERT INTO `dg_surnames` VALUES (760, 'Reilly');
INSERT INTO `dg_surnames` VALUES (761, 'Reyes');
INSERT INTO `dg_surnames` VALUES (762, 'Reynolds');
INSERT INTO `dg_surnames` VALUES (763, 'Rhodes');
INSERT INTO `dg_surnames` VALUES (764, 'Rice');
INSERT INTO `dg_surnames` VALUES (765, 'Rich');
INSERT INTO `dg_surnames` VALUES (766, 'Richard');
INSERT INTO `dg_surnames` VALUES (767, 'Richards');
INSERT INTO `dg_surnames` VALUES (768, 'Richardson');
INSERT INTO `dg_surnames` VALUES (769, 'Richmond');
INSERT INTO `dg_surnames` VALUES (770, 'Riddle');
INSERT INTO `dg_surnames` VALUES (771, 'Riggs');
INSERT INTO `dg_surnames` VALUES (772, 'Riley');
INSERT INTO `dg_surnames` VALUES (773, 'Rios');
INSERT INTO `dg_surnames` VALUES (774, 'Rivas');
INSERT INTO `dg_surnames` VALUES (775, 'Rivera');
INSERT INTO `dg_surnames` VALUES (776, 'Rivers');
INSERT INTO `dg_surnames` VALUES (777, 'Roach');
INSERT INTO `dg_surnames` VALUES (778, 'Robbins');
INSERT INTO `dg_surnames` VALUES (779, 'Roberson');
INSERT INTO `dg_surnames` VALUES (780, 'Roberts');
INSERT INTO `dg_surnames` VALUES (781, 'Robertson');
INSERT INTO `dg_surnames` VALUES (782, 'Robinson');
INSERT INTO `dg_surnames` VALUES (783, 'Robles');
INSERT INTO `dg_surnames` VALUES (784, 'Rocha');
INSERT INTO `dg_surnames` VALUES (785, 'Rodgers');
INSERT INTO `dg_surnames` VALUES (786, 'Rodriguez');
INSERT INTO `dg_surnames` VALUES (787, 'Rodriquez');
INSERT INTO `dg_surnames` VALUES (788, 'Rogers');
INSERT INTO `dg_surnames` VALUES (789, 'Rojas');
INSERT INTO `dg_surnames` VALUES (790, 'Rollins');
INSERT INTO `dg_surnames` VALUES (791, 'Roman');
INSERT INTO `dg_surnames` VALUES (792, 'Romero');
INSERT INTO `dg_surnames` VALUES (793, 'Rosa');
INSERT INTO `dg_surnames` VALUES (794, 'Rosales');
INSERT INTO `dg_surnames` VALUES (795, 'Rosario');
INSERT INTO `dg_surnames` VALUES (796, 'Rose');
INSERT INTO `dg_surnames` VALUES (797, 'Ross');
INSERT INTO `dg_surnames` VALUES (798, 'Roth');
INSERT INTO `dg_surnames` VALUES (799, 'Rowe');
INSERT INTO `dg_surnames` VALUES (800, 'Rowland');
INSERT INTO `dg_surnames` VALUES (801, 'Roy');
INSERT INTO `dg_surnames` VALUES (802, 'Ruiz');
INSERT INTO `dg_surnames` VALUES (803, 'Rush');
INSERT INTO `dg_surnames` VALUES (804, 'Russell');
INSERT INTO `dg_surnames` VALUES (805, 'Russo');
INSERT INTO `dg_surnames` VALUES (806, 'Rutledge');
INSERT INTO `dg_surnames` VALUES (807, 'Ryan');
INSERT INTO `dg_surnames` VALUES (808, 'Salas');
INSERT INTO `dg_surnames` VALUES (809, 'Salazar');
INSERT INTO `dg_surnames` VALUES (810, 'Salinas');
INSERT INTO `dg_surnames` VALUES (811, 'Sampson');
INSERT INTO `dg_surnames` VALUES (812, 'Sanchez');
INSERT INTO `dg_surnames` VALUES (813, 'Sanders');
INSERT INTO `dg_surnames` VALUES (814, 'Sandoval');
INSERT INTO `dg_surnames` VALUES (815, 'Sanford');
INSERT INTO `dg_surnames` VALUES (816, 'Santana');
INSERT INTO `dg_surnames` VALUES (817, 'Santiago');
INSERT INTO `dg_surnames` VALUES (818, 'Santos');
INSERT INTO `dg_surnames` VALUES (819, 'Sargent');
INSERT INTO `dg_surnames` VALUES (820, 'Saunders');
INSERT INTO `dg_surnames` VALUES (821, 'Savage');
INSERT INTO `dg_surnames` VALUES (822, 'Sawyer');
INSERT INTO `dg_surnames` VALUES (823, 'Schmidt');
INSERT INTO `dg_surnames` VALUES (824, 'Schneider');
INSERT INTO `dg_surnames` VALUES (825, 'Schroeder');
INSERT INTO `dg_surnames` VALUES (826, 'Schultz');
INSERT INTO `dg_surnames` VALUES (827, 'Schwartz');
INSERT INTO `dg_surnames` VALUES (828, 'Scott');
INSERT INTO `dg_surnames` VALUES (829, 'Sears');
INSERT INTO `dg_surnames` VALUES (830, 'Sellers');
INSERT INTO `dg_surnames` VALUES (831, 'Serrano');
INSERT INTO `dg_surnames` VALUES (832, 'Sexton');
INSERT INTO `dg_surnames` VALUES (833, 'Shaffer');
INSERT INTO `dg_surnames` VALUES (834, 'Shannon');
INSERT INTO `dg_surnames` VALUES (835, 'Sharp');
INSERT INTO `dg_surnames` VALUES (836, 'Sharpe');
INSERT INTO `dg_surnames` VALUES (837, 'Shaw');
INSERT INTO `dg_surnames` VALUES (838, 'Shelton');
INSERT INTO `dg_surnames` VALUES (839, 'Shepard');
INSERT INTO `dg_surnames` VALUES (840, 'Shepherd');
INSERT INTO `dg_surnames` VALUES (841, 'Sheppard');
INSERT INTO `dg_surnames` VALUES (842, 'Sherman');
INSERT INTO `dg_surnames` VALUES (843, 'Shields');
INSERT INTO `dg_surnames` VALUES (844, 'Short');
INSERT INTO `dg_surnames` VALUES (845, 'Silva');
INSERT INTO `dg_surnames` VALUES (846, 'Simmons');
INSERT INTO `dg_surnames` VALUES (847, 'Simon');
INSERT INTO `dg_surnames` VALUES (848, 'Simpson');
INSERT INTO `dg_surnames` VALUES (849, 'Sims');
INSERT INTO `dg_surnames` VALUES (850, 'Singleton');
INSERT INTO `dg_surnames` VALUES (851, 'Skinner');
INSERT INTO `dg_surnames` VALUES (852, 'Slater');
INSERT INTO `dg_surnames` VALUES (853, 'Sloan');
INSERT INTO `dg_surnames` VALUES (854, 'Small');
INSERT INTO `dg_surnames` VALUES (855, 'Smith');
INSERT INTO `dg_surnames` VALUES (856, 'Snider');
INSERT INTO `dg_surnames` VALUES (857, 'Snow');
INSERT INTO `dg_surnames` VALUES (858, 'Snyder');
INSERT INTO `dg_surnames` VALUES (859, 'Solis');
INSERT INTO `dg_surnames` VALUES (860, 'Solomon');
INSERT INTO `dg_surnames` VALUES (861, 'Sosa');
INSERT INTO `dg_surnames` VALUES (862, 'Soto');
INSERT INTO `dg_surnames` VALUES (863, 'Sparks');
INSERT INTO `dg_surnames` VALUES (864, 'Spears');
INSERT INTO `dg_surnames` VALUES (865, 'Spence');
INSERT INTO `dg_surnames` VALUES (866, 'Spencer');
INSERT INTO `dg_surnames` VALUES (867, 'Stafford');
INSERT INTO `dg_surnames` VALUES (868, 'Stanley');
INSERT INTO `dg_surnames` VALUES (869, 'Stanton');
INSERT INTO `dg_surnames` VALUES (870, 'Stark');
INSERT INTO `dg_surnames` VALUES (871, 'Steele');
INSERT INTO `dg_surnames` VALUES (872, 'Stein');
INSERT INTO `dg_surnames` VALUES (873, 'Stephens');
INSERT INTO `dg_surnames` VALUES (874, 'Stephenson');
INSERT INTO `dg_surnames` VALUES (875, 'Stevens');
INSERT INTO `dg_surnames` VALUES (876, 'Stevenson');
INSERT INTO `dg_surnames` VALUES (877, 'Stewart');
INSERT INTO `dg_surnames` VALUES (878, 'Stokes');
INSERT INTO `dg_surnames` VALUES (879, 'Stone');
INSERT INTO `dg_surnames` VALUES (880, 'Stout');
INSERT INTO `dg_surnames` VALUES (881, 'Strickland');
INSERT INTO `dg_surnames` VALUES (882, 'Strong');
INSERT INTO `dg_surnames` VALUES (883, 'Stuart');
INSERT INTO `dg_surnames` VALUES (884, 'Suarez');
INSERT INTO `dg_surnames` VALUES (885, 'Sullivan');
INSERT INTO `dg_surnames` VALUES (886, 'Summers');
INSERT INTO `dg_surnames` VALUES (887, 'Sutton');
INSERT INTO `dg_surnames` VALUES (888, 'Swanson');
INSERT INTO `dg_surnames` VALUES (889, 'Sweeney');
INSERT INTO `dg_surnames` VALUES (890, 'Sweet');
INSERT INTO `dg_surnames` VALUES (891, 'Sykes');
INSERT INTO `dg_surnames` VALUES (892, 'Talley');
INSERT INTO `dg_surnames` VALUES (893, 'Tanner');
INSERT INTO `dg_surnames` VALUES (894, 'Tate');
INSERT INTO `dg_surnames` VALUES (895, 'Taylor');
INSERT INTO `dg_surnames` VALUES (896, 'Terrell');
INSERT INTO `dg_surnames` VALUES (897, 'Terry');
INSERT INTO `dg_surnames` VALUES (898, 'Thomas');
INSERT INTO `dg_surnames` VALUES (899, 'Thompson');
INSERT INTO `dg_surnames` VALUES (900, 'Thornton');
INSERT INTO `dg_surnames` VALUES (901, 'Tillman');
INSERT INTO `dg_surnames` VALUES (902, 'Todd');
INSERT INTO `dg_surnames` VALUES (903, 'Torres');
INSERT INTO `dg_surnames` VALUES (904, 'Townsend');
INSERT INTO `dg_surnames` VALUES (905, 'Tran');
INSERT INTO `dg_surnames` VALUES (906, 'Travis');
INSERT INTO `dg_surnames` VALUES (907, 'Trevino');
INSERT INTO `dg_surnames` VALUES (908, 'Trujillo');
INSERT INTO `dg_surnames` VALUES (909, 'Tucker');
INSERT INTO `dg_surnames` VALUES (910, 'Turner');
INSERT INTO `dg_surnames` VALUES (911, 'Tyler');
INSERT INTO `dg_surnames` VALUES (912, 'Tyson');
INSERT INTO `dg_surnames` VALUES (913, 'Underwood');
INSERT INTO `dg_surnames` VALUES (914, 'Valdez');
INSERT INTO `dg_surnames` VALUES (915, 'Valencia');
INSERT INTO `dg_surnames` VALUES (916, 'Valentine');
INSERT INTO `dg_surnames` VALUES (917, 'Valenzuela');
INSERT INTO `dg_surnames` VALUES (918, 'Vance');
INSERT INTO `dg_surnames` VALUES (919, 'Vang');
INSERT INTO `dg_surnames` VALUES (920, 'Vargas');
INSERT INTO `dg_surnames` VALUES (921, 'Vasquez');
INSERT INTO `dg_surnames` VALUES (922, 'Vaughan');
INSERT INTO `dg_surnames` VALUES (923, 'Vaughn');
INSERT INTO `dg_surnames` VALUES (924, 'Vazquez');
INSERT INTO `dg_surnames` VALUES (925, 'Vega');
INSERT INTO `dg_surnames` VALUES (926, 'Velasquez');
INSERT INTO `dg_surnames` VALUES (927, 'Velazquez');
INSERT INTO `dg_surnames` VALUES (928, 'Velez');
INSERT INTO `dg_surnames` VALUES (929, 'Villarreal');
INSERT INTO `dg_surnames` VALUES (930, 'Vincent');
INSERT INTO `dg_surnames` VALUES (931, 'Vinson');
INSERT INTO `dg_surnames` VALUES (932, 'Wade');
INSERT INTO `dg_surnames` VALUES (933, 'Wagner');
INSERT INTO `dg_surnames` VALUES (934, 'Walker');
INSERT INTO `dg_surnames` VALUES (935, 'Wall');
INSERT INTO `dg_surnames` VALUES (936, 'Wallace');
INSERT INTO `dg_surnames` VALUES (937, 'Waller');
INSERT INTO `dg_surnames` VALUES (938, 'Walls');
INSERT INTO `dg_surnames` VALUES (939, 'Walsh');
INSERT INTO `dg_surnames` VALUES (940, 'Walter');
INSERT INTO `dg_surnames` VALUES (941, 'Walters');
INSERT INTO `dg_surnames` VALUES (942, 'Walton');
INSERT INTO `dg_surnames` VALUES (943, 'Ward');
INSERT INTO `dg_surnames` VALUES (944, 'Ware');
INSERT INTO `dg_surnames` VALUES (945, 'Warner');
INSERT INTO `dg_surnames` VALUES (946, 'Warren');
INSERT INTO `dg_surnames` VALUES (947, 'Washington');
INSERT INTO `dg_surnames` VALUES (948, 'Waters');
INSERT INTO `dg_surnames` VALUES (949, 'Watkins');
INSERT INTO `dg_surnames` VALUES (950, 'Watson');
INSERT INTO `dg_surnames` VALUES (951, 'Watts');
INSERT INTO `dg_surnames` VALUES (952, 'Weaver');
INSERT INTO `dg_surnames` VALUES (953, 'Webb');
INSERT INTO `dg_surnames` VALUES (954, 'Weber');
INSERT INTO `dg_surnames` VALUES (955, 'Webster');
INSERT INTO `dg_surnames` VALUES (956, 'Weeks');
INSERT INTO `dg_surnames` VALUES (957, 'Weiss');
INSERT INTO `dg_surnames` VALUES (958, 'Welch');
INSERT INTO `dg_surnames` VALUES (959, 'Wells');
INSERT INTO `dg_surnames` VALUES (960, 'West');
INSERT INTO `dg_surnames` VALUES (961, 'Wheeler');
INSERT INTO `dg_surnames` VALUES (962, 'Whitaker');
INSERT INTO `dg_surnames` VALUES (963, 'White');
INSERT INTO `dg_surnames` VALUES (964, 'Whitehead');
INSERT INTO `dg_surnames` VALUES (965, 'Whitfield');
INSERT INTO `dg_surnames` VALUES (966, 'Whitley');
INSERT INTO `dg_surnames` VALUES (967, 'Whitney');
INSERT INTO `dg_surnames` VALUES (968, 'Wiggins');
INSERT INTO `dg_surnames` VALUES (969, 'Wilcox');
INSERT INTO `dg_surnames` VALUES (970, 'Wilder');
INSERT INTO `dg_surnames` VALUES (971, 'Wiley');
INSERT INTO `dg_surnames` VALUES (972, 'Wilkerson');
INSERT INTO `dg_surnames` VALUES (973, 'Wilkins');
INSERT INTO `dg_surnames` VALUES (974, 'Wilkinson');
INSERT INTO `dg_surnames` VALUES (975, 'William');
INSERT INTO `dg_surnames` VALUES (976, 'Williams');
INSERT INTO `dg_surnames` VALUES (977, 'Williamson');
INSERT INTO `dg_surnames` VALUES (978, 'Willis');
INSERT INTO `dg_surnames` VALUES (979, 'Wilson');
INSERT INTO `dg_surnames` VALUES (980, 'Winters');
INSERT INTO `dg_surnames` VALUES (981, 'Wise');
INSERT INTO `dg_surnames` VALUES (982, 'Witt');
INSERT INTO `dg_surnames` VALUES (983, 'Wolf');
INSERT INTO `dg_surnames` VALUES (984, 'Wolfe');
INSERT INTO `dg_surnames` VALUES (985, 'Wong');
INSERT INTO `dg_surnames` VALUES (986, 'Wood');
INSERT INTO `dg_surnames` VALUES (987, 'Woodard');
INSERT INTO `dg_surnames` VALUES (988, 'Woods');
INSERT INTO `dg_surnames` VALUES (989, 'Woodward');
INSERT INTO `dg_surnames` VALUES (990, 'Wooten');
INSERT INTO `dg_surnames` VALUES (991, 'Workman');
INSERT INTO `dg_surnames` VALUES (992, 'Wright');
INSERT INTO `dg_surnames` VALUES (993, 'Wyatt');
INSERT INTO `dg_surnames` VALUES (994, 'Wynn');
INSERT INTO `dg_surnames` VALUES (995, 'Yang');
INSERT INTO `dg_surnames` VALUES (996, 'Yates');
INSERT INTO `dg_surnames` VALUES (997, 'York');
INSERT INTO `dg_surnames` VALUES (998, 'Young');
INSERT INTO `dg_surnames` VALUES (999, 'Zamora');
INSERT INTO `dg_surnames` VALUES (1000, 'Zimmerman');       	
